// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"
	"wechat-api/ent/predicate"
	"wechat-api/ent/usagetotal"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// UsageTotalQuery is the builder for querying UsageTotal entities.
type UsageTotalQuery struct {
	config
	ctx        *QueryContext
	order      []usagetotal.OrderOption
	inters     []Interceptor
	predicates []predicate.UsageTotal
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the UsageTotalQuery builder.
func (utq *UsageTotalQuery) Where(ps ...predicate.UsageTotal) *UsageTotalQuery {
	utq.predicates = append(utq.predicates, ps...)
	return utq
}

// Limit the number of records to be returned by this query.
func (utq *UsageTotalQuery) Limit(limit int) *UsageTotalQuery {
	utq.ctx.Limit = &limit
	return utq
}

// Offset to start from.
func (utq *UsageTotalQuery) Offset(offset int) *UsageTotalQuery {
	utq.ctx.Offset = &offset
	return utq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (utq *UsageTotalQuery) Unique(unique bool) *UsageTotalQuery {
	utq.ctx.Unique = &unique
	return utq
}

// Order specifies how the records should be ordered.
func (utq *UsageTotalQuery) Order(o ...usagetotal.OrderOption) *UsageTotalQuery {
	utq.order = append(utq.order, o...)
	return utq
}

// First returns the first UsageTotal entity from the query.
// Returns a *NotFoundError when no UsageTotal was found.
func (utq *UsageTotalQuery) First(ctx context.Context) (*UsageTotal, error) {
	nodes, err := utq.Limit(1).All(setContextOp(ctx, utq.ctx, "First"))
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{usagetotal.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (utq *UsageTotalQuery) FirstX(ctx context.Context) *UsageTotal {
	node, err := utq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first UsageTotal ID from the query.
// Returns a *NotFoundError when no UsageTotal ID was found.
func (utq *UsageTotalQuery) FirstID(ctx context.Context) (id uint64, err error) {
	var ids []uint64
	if ids, err = utq.Limit(1).IDs(setContextOp(ctx, utq.ctx, "FirstID")); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{usagetotal.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (utq *UsageTotalQuery) FirstIDX(ctx context.Context) uint64 {
	id, err := utq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single UsageTotal entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one UsageTotal entity is found.
// Returns a *NotFoundError when no UsageTotal entities are found.
func (utq *UsageTotalQuery) Only(ctx context.Context) (*UsageTotal, error) {
	nodes, err := utq.Limit(2).All(setContextOp(ctx, utq.ctx, "Only"))
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{usagetotal.Label}
	default:
		return nil, &NotSingularError{usagetotal.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (utq *UsageTotalQuery) OnlyX(ctx context.Context) *UsageTotal {
	node, err := utq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only UsageTotal ID in the query.
// Returns a *NotSingularError when more than one UsageTotal ID is found.
// Returns a *NotFoundError when no entities are found.
func (utq *UsageTotalQuery) OnlyID(ctx context.Context) (id uint64, err error) {
	var ids []uint64
	if ids, err = utq.Limit(2).IDs(setContextOp(ctx, utq.ctx, "OnlyID")); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{usagetotal.Label}
	default:
		err = &NotSingularError{usagetotal.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (utq *UsageTotalQuery) OnlyIDX(ctx context.Context) uint64 {
	id, err := utq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of UsageTotals.
func (utq *UsageTotalQuery) All(ctx context.Context) ([]*UsageTotal, error) {
	ctx = setContextOp(ctx, utq.ctx, "All")
	if err := utq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	qr := querierAll[[]*UsageTotal, *UsageTotalQuery]()
	return withInterceptors[[]*UsageTotal](ctx, utq, qr, utq.inters)
}

// AllX is like All, but panics if an error occurs.
func (utq *UsageTotalQuery) AllX(ctx context.Context) []*UsageTotal {
	nodes, err := utq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of UsageTotal IDs.
func (utq *UsageTotalQuery) IDs(ctx context.Context) (ids []uint64, err error) {
	if utq.ctx.Unique == nil && utq.path != nil {
		utq.Unique(true)
	}
	ctx = setContextOp(ctx, utq.ctx, "IDs")
	if err = utq.Select(usagetotal.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (utq *UsageTotalQuery) IDsX(ctx context.Context) []uint64 {
	ids, err := utq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (utq *UsageTotalQuery) Count(ctx context.Context) (int, error) {
	ctx = setContextOp(ctx, utq.ctx, "Count")
	if err := utq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return withInterceptors[int](ctx, utq, querierCount[*UsageTotalQuery](), utq.inters)
}

// CountX is like Count, but panics if an error occurs.
func (utq *UsageTotalQuery) CountX(ctx context.Context) int {
	count, err := utq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (utq *UsageTotalQuery) Exist(ctx context.Context) (bool, error) {
	ctx = setContextOp(ctx, utq.ctx, "Exist")
	switch _, err := utq.FirstID(ctx); {
	case IsNotFound(err):
		return false, nil
	case err != nil:
		return false, fmt.Errorf("ent: check existence: %w", err)
	default:
		return true, nil
	}
}

// ExistX is like Exist, but panics if an error occurs.
func (utq *UsageTotalQuery) ExistX(ctx context.Context) bool {
	exist, err := utq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the UsageTotalQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (utq *UsageTotalQuery) Clone() *UsageTotalQuery {
	if utq == nil {
		return nil
	}
	return &UsageTotalQuery{
		config:     utq.config,
		ctx:        utq.ctx.Clone(),
		order:      append([]usagetotal.OrderOption{}, utq.order...),
		inters:     append([]Interceptor{}, utq.inters...),
		predicates: append([]predicate.UsageTotal{}, utq.predicates...),
		// clone intermediate query.
		sql:  utq.sql.Clone(),
		path: utq.path,
	}
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.UsageTotal.Query().
//		GroupBy(usagetotal.FieldCreatedAt).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (utq *UsageTotalQuery) GroupBy(field string, fields ...string) *UsageTotalGroupBy {
	utq.ctx.Fields = append([]string{field}, fields...)
	grbuild := &UsageTotalGroupBy{build: utq}
	grbuild.flds = &utq.ctx.Fields
	grbuild.label = usagetotal.Label
	grbuild.scan = grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//	}
//
//	client.UsageTotal.Query().
//		Select(usagetotal.FieldCreatedAt).
//		Scan(ctx, &v)
func (utq *UsageTotalQuery) Select(fields ...string) *UsageTotalSelect {
	utq.ctx.Fields = append(utq.ctx.Fields, fields...)
	sbuild := &UsageTotalSelect{UsageTotalQuery: utq}
	sbuild.label = usagetotal.Label
	sbuild.flds, sbuild.scan = &utq.ctx.Fields, sbuild.Scan
	return sbuild
}

// Aggregate returns a UsageTotalSelect configured with the given aggregations.
func (utq *UsageTotalQuery) Aggregate(fns ...AggregateFunc) *UsageTotalSelect {
	return utq.Select().Aggregate(fns...)
}

func (utq *UsageTotalQuery) prepareQuery(ctx context.Context) error {
	for _, inter := range utq.inters {
		if inter == nil {
			return fmt.Errorf("ent: uninitialized interceptor (forgotten import ent/runtime?)")
		}
		if trv, ok := inter.(Traverser); ok {
			if err := trv.Traverse(ctx, utq); err != nil {
				return err
			}
		}
	}
	for _, f := range utq.ctx.Fields {
		if !usagetotal.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if utq.path != nil {
		prev, err := utq.path(ctx)
		if err != nil {
			return err
		}
		utq.sql = prev
	}
	return nil
}

func (utq *UsageTotalQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*UsageTotal, error) {
	var (
		nodes = []*UsageTotal{}
		_spec = utq.querySpec()
	)
	_spec.ScanValues = func(columns []string) ([]any, error) {
		return (*UsageTotal).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []any) error {
		node := &UsageTotal{config: utq.config}
		nodes = append(nodes, node)
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, utq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	return nodes, nil
}

func (utq *UsageTotalQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := utq.querySpec()
	_spec.Node.Columns = utq.ctx.Fields
	if len(utq.ctx.Fields) > 0 {
		_spec.Unique = utq.ctx.Unique != nil && *utq.ctx.Unique
	}
	return sqlgraph.CountNodes(ctx, utq.driver, _spec)
}

func (utq *UsageTotalQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := sqlgraph.NewQuerySpec(usagetotal.Table, usagetotal.Columns, sqlgraph.NewFieldSpec(usagetotal.FieldID, field.TypeUint64))
	_spec.From = utq.sql
	if unique := utq.ctx.Unique; unique != nil {
		_spec.Unique = *unique
	} else if utq.path != nil {
		_spec.Unique = true
	}
	if fields := utq.ctx.Fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, usagetotal.FieldID)
		for i := range fields {
			if fields[i] != usagetotal.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := utq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := utq.ctx.Limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := utq.ctx.Offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := utq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (utq *UsageTotalQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(utq.driver.Dialect())
	t1 := builder.Table(usagetotal.Table)
	columns := utq.ctx.Fields
	if len(columns) == 0 {
		columns = usagetotal.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if utq.sql != nil {
		selector = utq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if utq.ctx.Unique != nil && *utq.ctx.Unique {
		selector.Distinct()
	}
	for _, p := range utq.predicates {
		p(selector)
	}
	for _, p := range utq.order {
		p(selector)
	}
	if offset := utq.ctx.Offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := utq.ctx.Limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// UsageTotalGroupBy is the group-by builder for UsageTotal entities.
type UsageTotalGroupBy struct {
	selector
	build *UsageTotalQuery
}

// Aggregate adds the given aggregation functions to the group-by query.
func (utgb *UsageTotalGroupBy) Aggregate(fns ...AggregateFunc) *UsageTotalGroupBy {
	utgb.fns = append(utgb.fns, fns...)
	return utgb
}

// Scan applies the selector query and scans the result into the given value.
func (utgb *UsageTotalGroupBy) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, utgb.build.ctx, "GroupBy")
	if err := utgb.build.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*UsageTotalQuery, *UsageTotalGroupBy](ctx, utgb.build, utgb, utgb.build.inters, v)
}

func (utgb *UsageTotalGroupBy) sqlScan(ctx context.Context, root *UsageTotalQuery, v any) error {
	selector := root.sqlQuery(ctx).Select()
	aggregation := make([]string, 0, len(utgb.fns))
	for _, fn := range utgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(*utgb.flds)+len(utgb.fns))
		for _, f := range *utgb.flds {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	selector.GroupBy(selector.Columns(*utgb.flds...)...)
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := utgb.build.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// UsageTotalSelect is the builder for selecting fields of UsageTotal entities.
type UsageTotalSelect struct {
	*UsageTotalQuery
	selector
}

// Aggregate adds the given aggregation functions to the selector query.
func (uts *UsageTotalSelect) Aggregate(fns ...AggregateFunc) *UsageTotalSelect {
	uts.fns = append(uts.fns, fns...)
	return uts
}

// Scan applies the selector query and scans the result into the given value.
func (uts *UsageTotalSelect) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, uts.ctx, "Select")
	if err := uts.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*UsageTotalQuery, *UsageTotalSelect](ctx, uts.UsageTotalQuery, uts, uts.inters, v)
}

func (uts *UsageTotalSelect) sqlScan(ctx context.Context, root *UsageTotalQuery, v any) error {
	selector := root.sqlQuery(ctx)
	aggregation := make([]string, 0, len(uts.fns))
	for _, fn := range uts.fns {
		aggregation = append(aggregation, fn(selector))
	}
	switch n := len(*uts.selector.flds); {
	case n == 0 && len(aggregation) > 0:
		selector.Select(aggregation...)
	case n != 0 && len(aggregation) > 0:
		selector.AppendSelect(aggregation...)
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := uts.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
