// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"
	"wechat-api/ent/agent"
	"wechat-api/ent/predicate"
	"wechat-api/ent/whatsapp"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// WhatsappQuery is the builder for querying Whatsapp entities.
type WhatsappQuery struct {
	config
	ctx        *QueryContext
	order      []whatsapp.OrderOption
	inters     []Interceptor
	predicates []predicate.Whatsapp
	withAgent  *AgentQuery
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the WhatsappQuery builder.
func (wq *WhatsappQuery) Where(ps ...predicate.Whatsapp) *WhatsappQuery {
	wq.predicates = append(wq.predicates, ps...)
	return wq
}

// Limit the number of records to be returned by this query.
func (wq *WhatsappQuery) Limit(limit int) *WhatsappQuery {
	wq.ctx.Limit = &limit
	return wq
}

// Offset to start from.
func (wq *WhatsappQuery) Offset(offset int) *WhatsappQuery {
	wq.ctx.Offset = &offset
	return wq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (wq *WhatsappQuery) Unique(unique bool) *WhatsappQuery {
	wq.ctx.Unique = &unique
	return wq
}

// Order specifies how the records should be ordered.
func (wq *WhatsappQuery) Order(o ...whatsapp.OrderOption) *WhatsappQuery {
	wq.order = append(wq.order, o...)
	return wq
}

// QueryAgent chains the current query on the "agent" edge.
func (wq *WhatsappQuery) QueryAgent() *AgentQuery {
	query := (&AgentClient{config: wq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := wq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := wq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(whatsapp.Table, whatsapp.FieldID, selector),
			sqlgraph.To(agent.Table, agent.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, whatsapp.AgentTable, whatsapp.AgentColumn),
		)
		fromU = sqlgraph.SetNeighbors(wq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first Whatsapp entity from the query.
// Returns a *NotFoundError when no Whatsapp was found.
func (wq *WhatsappQuery) First(ctx context.Context) (*Whatsapp, error) {
	nodes, err := wq.Limit(1).All(setContextOp(ctx, wq.ctx, "First"))
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{whatsapp.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (wq *WhatsappQuery) FirstX(ctx context.Context) *Whatsapp {
	node, err := wq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first Whatsapp ID from the query.
// Returns a *NotFoundError when no Whatsapp ID was found.
func (wq *WhatsappQuery) FirstID(ctx context.Context) (id uint64, err error) {
	var ids []uint64
	if ids, err = wq.Limit(1).IDs(setContextOp(ctx, wq.ctx, "FirstID")); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{whatsapp.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (wq *WhatsappQuery) FirstIDX(ctx context.Context) uint64 {
	id, err := wq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single Whatsapp entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one Whatsapp entity is found.
// Returns a *NotFoundError when no Whatsapp entities are found.
func (wq *WhatsappQuery) Only(ctx context.Context) (*Whatsapp, error) {
	nodes, err := wq.Limit(2).All(setContextOp(ctx, wq.ctx, "Only"))
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{whatsapp.Label}
	default:
		return nil, &NotSingularError{whatsapp.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (wq *WhatsappQuery) OnlyX(ctx context.Context) *Whatsapp {
	node, err := wq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only Whatsapp ID in the query.
// Returns a *NotSingularError when more than one Whatsapp ID is found.
// Returns a *NotFoundError when no entities are found.
func (wq *WhatsappQuery) OnlyID(ctx context.Context) (id uint64, err error) {
	var ids []uint64
	if ids, err = wq.Limit(2).IDs(setContextOp(ctx, wq.ctx, "OnlyID")); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{whatsapp.Label}
	default:
		err = &NotSingularError{whatsapp.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (wq *WhatsappQuery) OnlyIDX(ctx context.Context) uint64 {
	id, err := wq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of Whatsapps.
func (wq *WhatsappQuery) All(ctx context.Context) ([]*Whatsapp, error) {
	ctx = setContextOp(ctx, wq.ctx, "All")
	if err := wq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	qr := querierAll[[]*Whatsapp, *WhatsappQuery]()
	return withInterceptors[[]*Whatsapp](ctx, wq, qr, wq.inters)
}

// AllX is like All, but panics if an error occurs.
func (wq *WhatsappQuery) AllX(ctx context.Context) []*Whatsapp {
	nodes, err := wq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of Whatsapp IDs.
func (wq *WhatsappQuery) IDs(ctx context.Context) (ids []uint64, err error) {
	if wq.ctx.Unique == nil && wq.path != nil {
		wq.Unique(true)
	}
	ctx = setContextOp(ctx, wq.ctx, "IDs")
	if err = wq.Select(whatsapp.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (wq *WhatsappQuery) IDsX(ctx context.Context) []uint64 {
	ids, err := wq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (wq *WhatsappQuery) Count(ctx context.Context) (int, error) {
	ctx = setContextOp(ctx, wq.ctx, "Count")
	if err := wq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return withInterceptors[int](ctx, wq, querierCount[*WhatsappQuery](), wq.inters)
}

// CountX is like Count, but panics if an error occurs.
func (wq *WhatsappQuery) CountX(ctx context.Context) int {
	count, err := wq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (wq *WhatsappQuery) Exist(ctx context.Context) (bool, error) {
	ctx = setContextOp(ctx, wq.ctx, "Exist")
	switch _, err := wq.FirstID(ctx); {
	case IsNotFound(err):
		return false, nil
	case err != nil:
		return false, fmt.Errorf("ent: check existence: %w", err)
	default:
		return true, nil
	}
}

// ExistX is like Exist, but panics if an error occurs.
func (wq *WhatsappQuery) ExistX(ctx context.Context) bool {
	exist, err := wq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the WhatsappQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (wq *WhatsappQuery) Clone() *WhatsappQuery {
	if wq == nil {
		return nil
	}
	return &WhatsappQuery{
		config:     wq.config,
		ctx:        wq.ctx.Clone(),
		order:      append([]whatsapp.OrderOption{}, wq.order...),
		inters:     append([]Interceptor{}, wq.inters...),
		predicates: append([]predicate.Whatsapp{}, wq.predicates...),
		withAgent:  wq.withAgent.Clone(),
		// clone intermediate query.
		sql:  wq.sql.Clone(),
		path: wq.path,
	}
}

// WithAgent tells the query-builder to eager-load the nodes that are connected to
// the "agent" edge. The optional arguments are used to configure the query builder of the edge.
func (wq *WhatsappQuery) WithAgent(opts ...func(*AgentQuery)) *WhatsappQuery {
	query := (&AgentClient{config: wq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	wq.withAgent = query
	return wq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.Whatsapp.Query().
//		GroupBy(whatsapp.FieldCreatedAt).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (wq *WhatsappQuery) GroupBy(field string, fields ...string) *WhatsappGroupBy {
	wq.ctx.Fields = append([]string{field}, fields...)
	grbuild := &WhatsappGroupBy{build: wq}
	grbuild.flds = &wq.ctx.Fields
	grbuild.label = whatsapp.Label
	grbuild.scan = grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//	}
//
//	client.Whatsapp.Query().
//		Select(whatsapp.FieldCreatedAt).
//		Scan(ctx, &v)
func (wq *WhatsappQuery) Select(fields ...string) *WhatsappSelect {
	wq.ctx.Fields = append(wq.ctx.Fields, fields...)
	sbuild := &WhatsappSelect{WhatsappQuery: wq}
	sbuild.label = whatsapp.Label
	sbuild.flds, sbuild.scan = &wq.ctx.Fields, sbuild.Scan
	return sbuild
}

// Aggregate returns a WhatsappSelect configured with the given aggregations.
func (wq *WhatsappQuery) Aggregate(fns ...AggregateFunc) *WhatsappSelect {
	return wq.Select().Aggregate(fns...)
}

func (wq *WhatsappQuery) prepareQuery(ctx context.Context) error {
	for _, inter := range wq.inters {
		if inter == nil {
			return fmt.Errorf("ent: uninitialized interceptor (forgotten import ent/runtime?)")
		}
		if trv, ok := inter.(Traverser); ok {
			if err := trv.Traverse(ctx, wq); err != nil {
				return err
			}
		}
	}
	for _, f := range wq.ctx.Fields {
		if !whatsapp.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if wq.path != nil {
		prev, err := wq.path(ctx)
		if err != nil {
			return err
		}
		wq.sql = prev
	}
	return nil
}

func (wq *WhatsappQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*Whatsapp, error) {
	var (
		nodes       = []*Whatsapp{}
		_spec       = wq.querySpec()
		loadedTypes = [1]bool{
			wq.withAgent != nil,
		}
	)
	_spec.ScanValues = func(columns []string) ([]any, error) {
		return (*Whatsapp).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []any) error {
		node := &Whatsapp{config: wq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, wq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	if query := wq.withAgent; query != nil {
		if err := wq.loadAgent(ctx, query, nodes, nil,
			func(n *Whatsapp, e *Agent) { n.Edges.Agent = e }); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

func (wq *WhatsappQuery) loadAgent(ctx context.Context, query *AgentQuery, nodes []*Whatsapp, init func(*Whatsapp), assign func(*Whatsapp, *Agent)) error {
	ids := make([]uint64, 0, len(nodes))
	nodeids := make(map[uint64][]*Whatsapp)
	for i := range nodes {
		fk := nodes[i].AgentID
		if _, ok := nodeids[fk]; !ok {
			ids = append(ids, fk)
		}
		nodeids[fk] = append(nodeids[fk], nodes[i])
	}
	if len(ids) == 0 {
		return nil
	}
	query.Where(agent.IDIn(ids...))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		nodes, ok := nodeids[n.ID]
		if !ok {
			return fmt.Errorf(`unexpected foreign-key "agent_id" returned %v`, n.ID)
		}
		for i := range nodes {
			assign(nodes[i], n)
		}
	}
	return nil
}

func (wq *WhatsappQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := wq.querySpec()
	_spec.Node.Columns = wq.ctx.Fields
	if len(wq.ctx.Fields) > 0 {
		_spec.Unique = wq.ctx.Unique != nil && *wq.ctx.Unique
	}
	return sqlgraph.CountNodes(ctx, wq.driver, _spec)
}

func (wq *WhatsappQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := sqlgraph.NewQuerySpec(whatsapp.Table, whatsapp.Columns, sqlgraph.NewFieldSpec(whatsapp.FieldID, field.TypeUint64))
	_spec.From = wq.sql
	if unique := wq.ctx.Unique; unique != nil {
		_spec.Unique = *unique
	} else if wq.path != nil {
		_spec.Unique = true
	}
	if fields := wq.ctx.Fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, whatsapp.FieldID)
		for i := range fields {
			if fields[i] != whatsapp.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
		if wq.withAgent != nil {
			_spec.Node.AddColumnOnce(whatsapp.FieldAgentID)
		}
	}
	if ps := wq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := wq.ctx.Limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := wq.ctx.Offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := wq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (wq *WhatsappQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(wq.driver.Dialect())
	t1 := builder.Table(whatsapp.Table)
	columns := wq.ctx.Fields
	if len(columns) == 0 {
		columns = whatsapp.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if wq.sql != nil {
		selector = wq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if wq.ctx.Unique != nil && *wq.ctx.Unique {
		selector.Distinct()
	}
	for _, p := range wq.predicates {
		p(selector)
	}
	for _, p := range wq.order {
		p(selector)
	}
	if offset := wq.ctx.Offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := wq.ctx.Limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// WhatsappGroupBy is the group-by builder for Whatsapp entities.
type WhatsappGroupBy struct {
	selector
	build *WhatsappQuery
}

// Aggregate adds the given aggregation functions to the group-by query.
func (wgb *WhatsappGroupBy) Aggregate(fns ...AggregateFunc) *WhatsappGroupBy {
	wgb.fns = append(wgb.fns, fns...)
	return wgb
}

// Scan applies the selector query and scans the result into the given value.
func (wgb *WhatsappGroupBy) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, wgb.build.ctx, "GroupBy")
	if err := wgb.build.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*WhatsappQuery, *WhatsappGroupBy](ctx, wgb.build, wgb, wgb.build.inters, v)
}

func (wgb *WhatsappGroupBy) sqlScan(ctx context.Context, root *WhatsappQuery, v any) error {
	selector := root.sqlQuery(ctx).Select()
	aggregation := make([]string, 0, len(wgb.fns))
	for _, fn := range wgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(*wgb.flds)+len(wgb.fns))
		for _, f := range *wgb.flds {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	selector.GroupBy(selector.Columns(*wgb.flds...)...)
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := wgb.build.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// WhatsappSelect is the builder for selecting fields of Whatsapp entities.
type WhatsappSelect struct {
	*WhatsappQuery
	selector
}

// Aggregate adds the given aggregation functions to the selector query.
func (ws *WhatsappSelect) Aggregate(fns ...AggregateFunc) *WhatsappSelect {
	ws.fns = append(ws.fns, fns...)
	return ws
}

// Scan applies the selector query and scans the result into the given value.
func (ws *WhatsappSelect) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, ws.ctx, "Select")
	if err := ws.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*WhatsappQuery, *WhatsappSelect](ctx, ws.WhatsappQuery, ws, ws.inters, v)
}

func (ws *WhatsappSelect) sqlScan(ctx context.Context, root *WhatsappQuery, v any) error {
	selector := root.sqlQuery(ctx)
	aggregation := make([]string, 0, len(ws.fns))
	for _, fn := range ws.fns {
		aggregation = append(aggregation, fn(selector))
	}
	switch n := len(*ws.selector.flds); {
	case n == 0 && len(aggregation) > 0:
		selector.Select(aggregation...)
	case n != 0 && len(aggregation) > 0:
		selector.AppendSelect(aggregation...)
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := ws.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
