// Code generated by ent, DO NOT EDIT.

package ent

import (
	"encoding/json"
	"fmt"
	"strings"
	"wechat-api/ent/addwechatfriendlog"

	"entgo.io/ent"
	"entgo.io/ent/dialect/sql"
)

// 微信添加好友记录
type AddWechatFriendLog struct {
	config `json:"-"`
	// ID of the ent.
	// 主键id
	ID int64 `json:"id,omitempty"`
	// 属主的wxid
	OwnerWxID string `json:"owner_wx_id,omitempty"`
	// 属主的微信类型（1个微，3企微）
	OwnerWxType int `json:"owner_wx_type,omitempty"`
	// 手机号
	FindContent string `json:"find_content,omitempty"`
	// 添加好友时候填写的申请消息
	Message string `json:"message,omitempty"`
	// 发起查询数据的时候json
	FindRequest map[string]interface{} `json:"find_request,omitempty"`
	// 查询返回结果
	FindResult map[string]interface{} `json:"find_result,omitempty"`
	// 任务执行次数
	IsCanAdd int `json:"is_can_add,omitempty"`
	// 是否可以添加好友（与属主账号非好友且其数据查询正常时 0数据准备中，1 待执行 2成功添加申请 3timeout及其他错误 4用户不存在 5手动取消 6已经是好友）
	TaskCount int `json:"task_count,omitempty"`
	// 添加时候的请求体
	TaskID int64 `json:"task_id,omitempty"`
	// 添加时候的请求体
	AddRequest map[string]interface{} `json:"add_request,omitempty"`
	// 添加请求的结果
	AddResult map[string]interface{} `json:"add_result,omitempty"`
	// 创建时间戳
	CreatedAt int64 `json:"created_at,omitempty"`
	// 修改时间戳
	UpdatedAt int64 `json:"updated_at,omitempty"`
	// 1.api录入 2.人工导入
	Source int `json:"source,omitempty"`
	// 用户名称
	NickName string `json:"nick_name,omitempty"`
	// 用户头像
	Avatar string `json:"avatar,omitempty"`
	// 组织架构id
	OrganizationID int64 `json:"organization_id,omitempty"`
	selectValues   sql.SelectValues
}

// scanValues returns the types for scanning values from sql.Rows.
func (*AddWechatFriendLog) scanValues(columns []string) ([]any, error) {
	values := make([]any, len(columns))
	for i := range columns {
		switch columns[i] {
		case addwechatfriendlog.FieldFindRequest, addwechatfriendlog.FieldFindResult, addwechatfriendlog.FieldAddRequest, addwechatfriendlog.FieldAddResult:
			values[i] = new([]byte)
		case addwechatfriendlog.FieldID, addwechatfriendlog.FieldOwnerWxType, addwechatfriendlog.FieldIsCanAdd, addwechatfriendlog.FieldTaskCount, addwechatfriendlog.FieldTaskID, addwechatfriendlog.FieldCreatedAt, addwechatfriendlog.FieldUpdatedAt, addwechatfriendlog.FieldSource, addwechatfriendlog.FieldOrganizationID:
			values[i] = new(sql.NullInt64)
		case addwechatfriendlog.FieldOwnerWxID, addwechatfriendlog.FieldFindContent, addwechatfriendlog.FieldMessage, addwechatfriendlog.FieldNickName, addwechatfriendlog.FieldAvatar:
			values[i] = new(sql.NullString)
		default:
			values[i] = new(sql.UnknownType)
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the AddWechatFriendLog fields.
func (awfl *AddWechatFriendLog) assignValues(columns []string, values []any) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case addwechatfriendlog.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			awfl.ID = int64(value.Int64)
		case addwechatfriendlog.FieldOwnerWxID:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field owner_wx_id", values[i])
			} else if value.Valid {
				awfl.OwnerWxID = value.String
			}
		case addwechatfriendlog.FieldOwnerWxType:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field owner_wx_type", values[i])
			} else if value.Valid {
				awfl.OwnerWxType = int(value.Int64)
			}
		case addwechatfriendlog.FieldFindContent:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field find_content", values[i])
			} else if value.Valid {
				awfl.FindContent = value.String
			}
		case addwechatfriendlog.FieldMessage:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field message", values[i])
			} else if value.Valid {
				awfl.Message = value.String
			}
		case addwechatfriendlog.FieldFindRequest:
			if value, ok := values[i].(*[]byte); !ok {
				return fmt.Errorf("unexpected type %T for field find_request", values[i])
			} else if value != nil && len(*value) > 0 {
				if err := json.Unmarshal(*value, &awfl.FindRequest); err != nil {
					return fmt.Errorf("unmarshal field find_request: %w", err)
				}
			}
		case addwechatfriendlog.FieldFindResult:
			if value, ok := values[i].(*[]byte); !ok {
				return fmt.Errorf("unexpected type %T for field find_result", values[i])
			} else if value != nil && len(*value) > 0 {
				if err := json.Unmarshal(*value, &awfl.FindResult); err != nil {
					return fmt.Errorf("unmarshal field find_result: %w", err)
				}
			}
		case addwechatfriendlog.FieldIsCanAdd:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field is_can_add", values[i])
			} else if value.Valid {
				awfl.IsCanAdd = int(value.Int64)
			}
		case addwechatfriendlog.FieldTaskCount:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field task_count", values[i])
			} else if value.Valid {
				awfl.TaskCount = int(value.Int64)
			}
		case addwechatfriendlog.FieldTaskID:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field task_id", values[i])
			} else if value.Valid {
				awfl.TaskID = value.Int64
			}
		case addwechatfriendlog.FieldAddRequest:
			if value, ok := values[i].(*[]byte); !ok {
				return fmt.Errorf("unexpected type %T for field add_request", values[i])
			} else if value != nil && len(*value) > 0 {
				if err := json.Unmarshal(*value, &awfl.AddRequest); err != nil {
					return fmt.Errorf("unmarshal field add_request: %w", err)
				}
			}
		case addwechatfriendlog.FieldAddResult:
			if value, ok := values[i].(*[]byte); !ok {
				return fmt.Errorf("unexpected type %T for field add_result", values[i])
			} else if value != nil && len(*value) > 0 {
				if err := json.Unmarshal(*value, &awfl.AddResult); err != nil {
					return fmt.Errorf("unmarshal field add_result: %w", err)
				}
			}
		case addwechatfriendlog.FieldCreatedAt:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field created_at", values[i])
			} else if value.Valid {
				awfl.CreatedAt = value.Int64
			}
		case addwechatfriendlog.FieldUpdatedAt:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field updated_at", values[i])
			} else if value.Valid {
				awfl.UpdatedAt = value.Int64
			}
		case addwechatfriendlog.FieldSource:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field source", values[i])
			} else if value.Valid {
				awfl.Source = int(value.Int64)
			}
		case addwechatfriendlog.FieldNickName:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field nick_name", values[i])
			} else if value.Valid {
				awfl.NickName = value.String
			}
		case addwechatfriendlog.FieldAvatar:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field avatar", values[i])
			} else if value.Valid {
				awfl.Avatar = value.String
			}
		case addwechatfriendlog.FieldOrganizationID:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field organization_id", values[i])
			} else if value.Valid {
				awfl.OrganizationID = value.Int64
			}
		default:
			awfl.selectValues.Set(columns[i], values[i])
		}
	}
	return nil
}

// Value returns the ent.Value that was dynamically selected and assigned to the AddWechatFriendLog.
// This includes values selected through modifiers, order, etc.
func (awfl *AddWechatFriendLog) Value(name string) (ent.Value, error) {
	return awfl.selectValues.Get(name)
}

// Update returns a builder for updating this AddWechatFriendLog.
// Note that you need to call AddWechatFriendLog.Unwrap() before calling this method if this AddWechatFriendLog
// was returned from a transaction, and the transaction was committed or rolled back.
func (awfl *AddWechatFriendLog) Update() *AddWechatFriendLogUpdateOne {
	return NewAddWechatFriendLogClient(awfl.config).UpdateOne(awfl)
}

// Unwrap unwraps the AddWechatFriendLog entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (awfl *AddWechatFriendLog) Unwrap() *AddWechatFriendLog {
	_tx, ok := awfl.config.driver.(*txDriver)
	if !ok {
		panic("ent: AddWechatFriendLog is not a transactional entity")
	}
	awfl.config.driver = _tx.drv
	return awfl
}

// String implements the fmt.Stringer.
func (awfl *AddWechatFriendLog) String() string {
	var builder strings.Builder
	builder.WriteString("AddWechatFriendLog(")
	builder.WriteString(fmt.Sprintf("id=%v, ", awfl.ID))
	builder.WriteString("owner_wx_id=")
	builder.WriteString(awfl.OwnerWxID)
	builder.WriteString(", ")
	builder.WriteString("owner_wx_type=")
	builder.WriteString(fmt.Sprintf("%v", awfl.OwnerWxType))
	builder.WriteString(", ")
	builder.WriteString("find_content=")
	builder.WriteString(awfl.FindContent)
	builder.WriteString(", ")
	builder.WriteString("message=")
	builder.WriteString(awfl.Message)
	builder.WriteString(", ")
	builder.WriteString("find_request=")
	builder.WriteString(fmt.Sprintf("%v", awfl.FindRequest))
	builder.WriteString(", ")
	builder.WriteString("find_result=")
	builder.WriteString(fmt.Sprintf("%v", awfl.FindResult))
	builder.WriteString(", ")
	builder.WriteString("is_can_add=")
	builder.WriteString(fmt.Sprintf("%v", awfl.IsCanAdd))
	builder.WriteString(", ")
	builder.WriteString("task_count=")
	builder.WriteString(fmt.Sprintf("%v", awfl.TaskCount))
	builder.WriteString(", ")
	builder.WriteString("task_id=")
	builder.WriteString(fmt.Sprintf("%v", awfl.TaskID))
	builder.WriteString(", ")
	builder.WriteString("add_request=")
	builder.WriteString(fmt.Sprintf("%v", awfl.AddRequest))
	builder.WriteString(", ")
	builder.WriteString("add_result=")
	builder.WriteString(fmt.Sprintf("%v", awfl.AddResult))
	builder.WriteString(", ")
	builder.WriteString("created_at=")
	builder.WriteString(fmt.Sprintf("%v", awfl.CreatedAt))
	builder.WriteString(", ")
	builder.WriteString("updated_at=")
	builder.WriteString(fmt.Sprintf("%v", awfl.UpdatedAt))
	builder.WriteString(", ")
	builder.WriteString("source=")
	builder.WriteString(fmt.Sprintf("%v", awfl.Source))
	builder.WriteString(", ")
	builder.WriteString("nick_name=")
	builder.WriteString(awfl.NickName)
	builder.WriteString(", ")
	builder.WriteString("avatar=")
	builder.WriteString(awfl.Avatar)
	builder.WriteString(", ")
	builder.WriteString("organization_id=")
	builder.WriteString(fmt.Sprintf("%v", awfl.OrganizationID))
	builder.WriteByte(')')
	return builder.String()
}

// AddWechatFriendLogs is a parsable slice of AddWechatFriendLog.
type AddWechatFriendLogs []*AddWechatFriendLog
