// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"wechat-api/ent/addwechatfriendlog"
	"wechat-api/ent/predicate"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// AddWechatFriendLogDelete is the builder for deleting a AddWechatFriendLog entity.
type AddWechatFriendLogDelete struct {
	config
	hooks    []Hook
	mutation *AddWechatFriendLogMutation
}

// Where appends a list predicates to the AddWechatFriendLogDelete builder.
func (awfld *AddWechatFriendLogDelete) Where(ps ...predicate.AddWechatFriendLog) *AddWechatFriendLogDelete {
	awfld.mutation.Where(ps...)
	return awfld
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (awfld *AddWechatFriendLogDelete) Exec(ctx context.Context) (int, error) {
	return withHooks(ctx, awfld.sqlExec, awfld.mutation, awfld.hooks)
}

// ExecX is like Exec, but panics if an error occurs.
func (awfld *AddWechatFriendLogDelete) ExecX(ctx context.Context) int {
	n, err := awfld.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (awfld *AddWechatFriendLogDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := sqlgraph.NewDeleteSpec(addwechatfriendlog.Table, sqlgraph.NewFieldSpec(addwechatfriendlog.FieldID, field.TypeInt64))
	if ps := awfld.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	affected, err := sqlgraph.DeleteNodes(ctx, awfld.driver, _spec)
	if err != nil && sqlgraph.IsConstraintError(err) {
		err = &ConstraintError{msg: err.Error(), wrap: err}
	}
	awfld.mutation.done = true
	return affected, err
}

// AddWechatFriendLogDeleteOne is the builder for deleting a single AddWechatFriendLog entity.
type AddWechatFriendLogDeleteOne struct {
	awfld *AddWechatFriendLogDelete
}

// Where appends a list predicates to the AddWechatFriendLogDelete builder.
func (awfldo *AddWechatFriendLogDeleteOne) Where(ps ...predicate.AddWechatFriendLog) *AddWechatFriendLogDeleteOne {
	awfldo.awfld.mutation.Where(ps...)
	return awfldo
}

// Exec executes the deletion query.
func (awfldo *AddWechatFriendLogDeleteOne) Exec(ctx context.Context) error {
	n, err := awfldo.awfld.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{addwechatfriendlog.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (awfldo *AddWechatFriendLogDeleteOne) ExecX(ctx context.Context) {
	if err := awfldo.Exec(ctx); err != nil {
		panic(err)
	}
}
