// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"
	"wechat-api/ent/addwechatfriendlog"
	"wechat-api/ent/predicate"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// AddWechatFriendLogQuery is the builder for querying AddWechatFriendLog entities.
type AddWechatFriendLogQuery struct {
	config
	ctx        *QueryContext
	order      []addwechatfriendlog.OrderOption
	inters     []Interceptor
	predicates []predicate.AddWechatFriendLog
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the AddWechatFriendLogQuery builder.
func (awflq *AddWechatFriendLogQuery) Where(ps ...predicate.AddWechatFriendLog) *AddWechatFriendLogQuery {
	awflq.predicates = append(awflq.predicates, ps...)
	return awflq
}

// Limit the number of records to be returned by this query.
func (awflq *AddWechatFriendLogQuery) Limit(limit int) *AddWechatFriendLogQuery {
	awflq.ctx.Limit = &limit
	return awflq
}

// Offset to start from.
func (awflq *AddWechatFriendLogQuery) Offset(offset int) *AddWechatFriendLogQuery {
	awflq.ctx.Offset = &offset
	return awflq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (awflq *AddWechatFriendLogQuery) Unique(unique bool) *AddWechatFriendLogQuery {
	awflq.ctx.Unique = &unique
	return awflq
}

// Order specifies how the records should be ordered.
func (awflq *AddWechatFriendLogQuery) Order(o ...addwechatfriendlog.OrderOption) *AddWechatFriendLogQuery {
	awflq.order = append(awflq.order, o...)
	return awflq
}

// First returns the first AddWechatFriendLog entity from the query.
// Returns a *NotFoundError when no AddWechatFriendLog was found.
func (awflq *AddWechatFriendLogQuery) First(ctx context.Context) (*AddWechatFriendLog, error) {
	nodes, err := awflq.Limit(1).All(setContextOp(ctx, awflq.ctx, "First"))
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{addwechatfriendlog.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (awflq *AddWechatFriendLogQuery) FirstX(ctx context.Context) *AddWechatFriendLog {
	node, err := awflq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first AddWechatFriendLog ID from the query.
// Returns a *NotFoundError when no AddWechatFriendLog ID was found.
func (awflq *AddWechatFriendLogQuery) FirstID(ctx context.Context) (id int64, err error) {
	var ids []int64
	if ids, err = awflq.Limit(1).IDs(setContextOp(ctx, awflq.ctx, "FirstID")); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{addwechatfriendlog.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (awflq *AddWechatFriendLogQuery) FirstIDX(ctx context.Context) int64 {
	id, err := awflq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single AddWechatFriendLog entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one AddWechatFriendLog entity is found.
// Returns a *NotFoundError when no AddWechatFriendLog entities are found.
func (awflq *AddWechatFriendLogQuery) Only(ctx context.Context) (*AddWechatFriendLog, error) {
	nodes, err := awflq.Limit(2).All(setContextOp(ctx, awflq.ctx, "Only"))
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{addwechatfriendlog.Label}
	default:
		return nil, &NotSingularError{addwechatfriendlog.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (awflq *AddWechatFriendLogQuery) OnlyX(ctx context.Context) *AddWechatFriendLog {
	node, err := awflq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only AddWechatFriendLog ID in the query.
// Returns a *NotSingularError when more than one AddWechatFriendLog ID is found.
// Returns a *NotFoundError when no entities are found.
func (awflq *AddWechatFriendLogQuery) OnlyID(ctx context.Context) (id int64, err error) {
	var ids []int64
	if ids, err = awflq.Limit(2).IDs(setContextOp(ctx, awflq.ctx, "OnlyID")); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{addwechatfriendlog.Label}
	default:
		err = &NotSingularError{addwechatfriendlog.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (awflq *AddWechatFriendLogQuery) OnlyIDX(ctx context.Context) int64 {
	id, err := awflq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of AddWechatFriendLogs.
func (awflq *AddWechatFriendLogQuery) All(ctx context.Context) ([]*AddWechatFriendLog, error) {
	ctx = setContextOp(ctx, awflq.ctx, "All")
	if err := awflq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	qr := querierAll[[]*AddWechatFriendLog, *AddWechatFriendLogQuery]()
	return withInterceptors[[]*AddWechatFriendLog](ctx, awflq, qr, awflq.inters)
}

// AllX is like All, but panics if an error occurs.
func (awflq *AddWechatFriendLogQuery) AllX(ctx context.Context) []*AddWechatFriendLog {
	nodes, err := awflq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of AddWechatFriendLog IDs.
func (awflq *AddWechatFriendLogQuery) IDs(ctx context.Context) (ids []int64, err error) {
	if awflq.ctx.Unique == nil && awflq.path != nil {
		awflq.Unique(true)
	}
	ctx = setContextOp(ctx, awflq.ctx, "IDs")
	if err = awflq.Select(addwechatfriendlog.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (awflq *AddWechatFriendLogQuery) IDsX(ctx context.Context) []int64 {
	ids, err := awflq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (awflq *AddWechatFriendLogQuery) Count(ctx context.Context) (int, error) {
	ctx = setContextOp(ctx, awflq.ctx, "Count")
	if err := awflq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return withInterceptors[int](ctx, awflq, querierCount[*AddWechatFriendLogQuery](), awflq.inters)
}

// CountX is like Count, but panics if an error occurs.
func (awflq *AddWechatFriendLogQuery) CountX(ctx context.Context) int {
	count, err := awflq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (awflq *AddWechatFriendLogQuery) Exist(ctx context.Context) (bool, error) {
	ctx = setContextOp(ctx, awflq.ctx, "Exist")
	switch _, err := awflq.FirstID(ctx); {
	case IsNotFound(err):
		return false, nil
	case err != nil:
		return false, fmt.Errorf("ent: check existence: %w", err)
	default:
		return true, nil
	}
}

// ExistX is like Exist, but panics if an error occurs.
func (awflq *AddWechatFriendLogQuery) ExistX(ctx context.Context) bool {
	exist, err := awflq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the AddWechatFriendLogQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (awflq *AddWechatFriendLogQuery) Clone() *AddWechatFriendLogQuery {
	if awflq == nil {
		return nil
	}
	return &AddWechatFriendLogQuery{
		config:     awflq.config,
		ctx:        awflq.ctx.Clone(),
		order:      append([]addwechatfriendlog.OrderOption{}, awflq.order...),
		inters:     append([]Interceptor{}, awflq.inters...),
		predicates: append([]predicate.AddWechatFriendLog{}, awflq.predicates...),
		// clone intermediate query.
		sql:  awflq.sql.Clone(),
		path: awflq.path,
	}
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		OwnerWxID string `json:"owner_wx_id,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.AddWechatFriendLog.Query().
//		GroupBy(addwechatfriendlog.FieldOwnerWxID).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (awflq *AddWechatFriendLogQuery) GroupBy(field string, fields ...string) *AddWechatFriendLogGroupBy {
	awflq.ctx.Fields = append([]string{field}, fields...)
	grbuild := &AddWechatFriendLogGroupBy{build: awflq}
	grbuild.flds = &awflq.ctx.Fields
	grbuild.label = addwechatfriendlog.Label
	grbuild.scan = grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		OwnerWxID string `json:"owner_wx_id,omitempty"`
//	}
//
//	client.AddWechatFriendLog.Query().
//		Select(addwechatfriendlog.FieldOwnerWxID).
//		Scan(ctx, &v)
func (awflq *AddWechatFriendLogQuery) Select(fields ...string) *AddWechatFriendLogSelect {
	awflq.ctx.Fields = append(awflq.ctx.Fields, fields...)
	sbuild := &AddWechatFriendLogSelect{AddWechatFriendLogQuery: awflq}
	sbuild.label = addwechatfriendlog.Label
	sbuild.flds, sbuild.scan = &awflq.ctx.Fields, sbuild.Scan
	return sbuild
}

// Aggregate returns a AddWechatFriendLogSelect configured with the given aggregations.
func (awflq *AddWechatFriendLogQuery) Aggregate(fns ...AggregateFunc) *AddWechatFriendLogSelect {
	return awflq.Select().Aggregate(fns...)
}

func (awflq *AddWechatFriendLogQuery) prepareQuery(ctx context.Context) error {
	for _, inter := range awflq.inters {
		if inter == nil {
			return fmt.Errorf("ent: uninitialized interceptor (forgotten import ent/runtime?)")
		}
		if trv, ok := inter.(Traverser); ok {
			if err := trv.Traverse(ctx, awflq); err != nil {
				return err
			}
		}
	}
	for _, f := range awflq.ctx.Fields {
		if !addwechatfriendlog.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if awflq.path != nil {
		prev, err := awflq.path(ctx)
		if err != nil {
			return err
		}
		awflq.sql = prev
	}
	return nil
}

func (awflq *AddWechatFriendLogQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*AddWechatFriendLog, error) {
	var (
		nodes = []*AddWechatFriendLog{}
		_spec = awflq.querySpec()
	)
	_spec.ScanValues = func(columns []string) ([]any, error) {
		return (*AddWechatFriendLog).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []any) error {
		node := &AddWechatFriendLog{config: awflq.config}
		nodes = append(nodes, node)
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, awflq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	return nodes, nil
}

func (awflq *AddWechatFriendLogQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := awflq.querySpec()
	_spec.Node.Columns = awflq.ctx.Fields
	if len(awflq.ctx.Fields) > 0 {
		_spec.Unique = awflq.ctx.Unique != nil && *awflq.ctx.Unique
	}
	return sqlgraph.CountNodes(ctx, awflq.driver, _spec)
}

func (awflq *AddWechatFriendLogQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := sqlgraph.NewQuerySpec(addwechatfriendlog.Table, addwechatfriendlog.Columns, sqlgraph.NewFieldSpec(addwechatfriendlog.FieldID, field.TypeInt64))
	_spec.From = awflq.sql
	if unique := awflq.ctx.Unique; unique != nil {
		_spec.Unique = *unique
	} else if awflq.path != nil {
		_spec.Unique = true
	}
	if fields := awflq.ctx.Fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, addwechatfriendlog.FieldID)
		for i := range fields {
			if fields[i] != addwechatfriendlog.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := awflq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := awflq.ctx.Limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := awflq.ctx.Offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := awflq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (awflq *AddWechatFriendLogQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(awflq.driver.Dialect())
	t1 := builder.Table(addwechatfriendlog.Table)
	columns := awflq.ctx.Fields
	if len(columns) == 0 {
		columns = addwechatfriendlog.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if awflq.sql != nil {
		selector = awflq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if awflq.ctx.Unique != nil && *awflq.ctx.Unique {
		selector.Distinct()
	}
	for _, p := range awflq.predicates {
		p(selector)
	}
	for _, p := range awflq.order {
		p(selector)
	}
	if offset := awflq.ctx.Offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := awflq.ctx.Limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// AddWechatFriendLogGroupBy is the group-by builder for AddWechatFriendLog entities.
type AddWechatFriendLogGroupBy struct {
	selector
	build *AddWechatFriendLogQuery
}

// Aggregate adds the given aggregation functions to the group-by query.
func (awflgb *AddWechatFriendLogGroupBy) Aggregate(fns ...AggregateFunc) *AddWechatFriendLogGroupBy {
	awflgb.fns = append(awflgb.fns, fns...)
	return awflgb
}

// Scan applies the selector query and scans the result into the given value.
func (awflgb *AddWechatFriendLogGroupBy) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, awflgb.build.ctx, "GroupBy")
	if err := awflgb.build.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*AddWechatFriendLogQuery, *AddWechatFriendLogGroupBy](ctx, awflgb.build, awflgb, awflgb.build.inters, v)
}

func (awflgb *AddWechatFriendLogGroupBy) sqlScan(ctx context.Context, root *AddWechatFriendLogQuery, v any) error {
	selector := root.sqlQuery(ctx).Select()
	aggregation := make([]string, 0, len(awflgb.fns))
	for _, fn := range awflgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(*awflgb.flds)+len(awflgb.fns))
		for _, f := range *awflgb.flds {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	selector.GroupBy(selector.Columns(*awflgb.flds...)...)
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := awflgb.build.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// AddWechatFriendLogSelect is the builder for selecting fields of AddWechatFriendLog entities.
type AddWechatFriendLogSelect struct {
	*AddWechatFriendLogQuery
	selector
}

// Aggregate adds the given aggregation functions to the selector query.
func (awfls *AddWechatFriendLogSelect) Aggregate(fns ...AggregateFunc) *AddWechatFriendLogSelect {
	awfls.fns = append(awfls.fns, fns...)
	return awfls
}

// Scan applies the selector query and scans the result into the given value.
func (awfls *AddWechatFriendLogSelect) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, awfls.ctx, "Select")
	if err := awfls.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*AddWechatFriendLogQuery, *AddWechatFriendLogSelect](ctx, awfls.AddWechatFriendLogQuery, awfls, awfls.inters, v)
}

func (awfls *AddWechatFriendLogSelect) sqlScan(ctx context.Context, root *AddWechatFriendLogQuery, v any) error {
	selector := root.sqlQuery(ctx)
	aggregation := make([]string, 0, len(awfls.fns))
	for _, fn := range awfls.fns {
		aggregation = append(aggregation, fn(selector))
	}
	switch n := len(*awfls.selector.flds); {
	case n == 0 && len(aggregation) > 0:
		selector.Select(aggregation...)
	case n != 0 && len(aggregation) > 0:
		selector.AppendSelect(aggregation...)
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := awfls.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
