// Code generated by ent, DO NOT EDIT.

package agent

import (
	"time"
	"wechat-api/ent/predicate"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

// ID filters vertices based on their ID field.
func ID(id uint64) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uint64) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uint64) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uint64) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uint64) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uint64) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uint64) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uint64) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uint64) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldID, id))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldUpdatedAt, v))
}

// DeletedAt applies equality check predicate on the "deleted_at" field. It's identical to DeletedAtEQ.
func DeletedAt(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldDeletedAt, v))
}

// Name applies equality check predicate on the "name" field. It's identical to NameEQ.
func Name(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldName, v))
}

// Role applies equality check predicate on the "role" field. It's identical to RoleEQ.
func Role(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldRole, v))
}

// Status applies equality check predicate on the "status" field. It's identical to StatusEQ.
func Status(v int) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldStatus, v))
}

// Background applies equality check predicate on the "background" field. It's identical to BackgroundEQ.
func Background(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldBackground, v))
}

// Examples applies equality check predicate on the "examples" field. It's identical to ExamplesEQ.
func Examples(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldExamples, v))
}

// OrganizationID applies equality check predicate on the "organization_id" field. It's identical to OrganizationIDEQ.
func OrganizationID(v uint64) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldOrganizationID, v))
}

// DatasetID applies equality check predicate on the "dataset_id" field. It's identical to DatasetIDEQ.
func DatasetID(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldDatasetID, v))
}

// CollectionID applies equality check predicate on the "collection_id" field. It's identical to CollectionIDEQ.
func CollectionID(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldCollectionID, v))
}

// Model applies equality check predicate on the "model" field. It's identical to ModelEQ.
func Model(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldModel, v))
}

// APIBase applies equality check predicate on the "api_base" field. It's identical to APIBaseEQ.
func APIBase(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldAPIBase, v))
}

// APIKey applies equality check predicate on the "api_key" field. It's identical to APIKeyEQ.
func APIKey(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldAPIKey, v))
}

// Type applies equality check predicate on the "type" field. It's identical to TypeEQ.
func Type(v int) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldType, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldUpdatedAt, v))
}

// DeletedAtEQ applies the EQ predicate on the "deleted_at" field.
func DeletedAtEQ(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldDeletedAt, v))
}

// DeletedAtNEQ applies the NEQ predicate on the "deleted_at" field.
func DeletedAtNEQ(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldDeletedAt, v))
}

// DeletedAtIn applies the In predicate on the "deleted_at" field.
func DeletedAtIn(vs ...time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldDeletedAt, vs...))
}

// DeletedAtNotIn applies the NotIn predicate on the "deleted_at" field.
func DeletedAtNotIn(vs ...time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldDeletedAt, vs...))
}

// DeletedAtGT applies the GT predicate on the "deleted_at" field.
func DeletedAtGT(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldDeletedAt, v))
}

// DeletedAtGTE applies the GTE predicate on the "deleted_at" field.
func DeletedAtGTE(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldDeletedAt, v))
}

// DeletedAtLT applies the LT predicate on the "deleted_at" field.
func DeletedAtLT(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldDeletedAt, v))
}

// DeletedAtLTE applies the LTE predicate on the "deleted_at" field.
func DeletedAtLTE(v time.Time) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldDeletedAt, v))
}

// DeletedAtIsNil applies the IsNil predicate on the "deleted_at" field.
func DeletedAtIsNil() predicate.Agent {
	return predicate.Agent(sql.FieldIsNull(FieldDeletedAt))
}

// DeletedAtNotNil applies the NotNil predicate on the "deleted_at" field.
func DeletedAtNotNil() predicate.Agent {
	return predicate.Agent(sql.FieldNotNull(FieldDeletedAt))
}

// NameEQ applies the EQ predicate on the "name" field.
func NameEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldName, v))
}

// NameNEQ applies the NEQ predicate on the "name" field.
func NameNEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldName, v))
}

// NameIn applies the In predicate on the "name" field.
func NameIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldName, vs...))
}

// NameNotIn applies the NotIn predicate on the "name" field.
func NameNotIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldName, vs...))
}

// NameGT applies the GT predicate on the "name" field.
func NameGT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldName, v))
}

// NameGTE applies the GTE predicate on the "name" field.
func NameGTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldName, v))
}

// NameLT applies the LT predicate on the "name" field.
func NameLT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldName, v))
}

// NameLTE applies the LTE predicate on the "name" field.
func NameLTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldName, v))
}

// NameContains applies the Contains predicate on the "name" field.
func NameContains(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContains(FieldName, v))
}

// NameHasPrefix applies the HasPrefix predicate on the "name" field.
func NameHasPrefix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasPrefix(FieldName, v))
}

// NameHasSuffix applies the HasSuffix predicate on the "name" field.
func NameHasSuffix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasSuffix(FieldName, v))
}

// NameEqualFold applies the EqualFold predicate on the "name" field.
func NameEqualFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEqualFold(FieldName, v))
}

// NameContainsFold applies the ContainsFold predicate on the "name" field.
func NameContainsFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContainsFold(FieldName, v))
}

// RoleEQ applies the EQ predicate on the "role" field.
func RoleEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldRole, v))
}

// RoleNEQ applies the NEQ predicate on the "role" field.
func RoleNEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldRole, v))
}

// RoleIn applies the In predicate on the "role" field.
func RoleIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldRole, vs...))
}

// RoleNotIn applies the NotIn predicate on the "role" field.
func RoleNotIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldRole, vs...))
}

// RoleGT applies the GT predicate on the "role" field.
func RoleGT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldRole, v))
}

// RoleGTE applies the GTE predicate on the "role" field.
func RoleGTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldRole, v))
}

// RoleLT applies the LT predicate on the "role" field.
func RoleLT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldRole, v))
}

// RoleLTE applies the LTE predicate on the "role" field.
func RoleLTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldRole, v))
}

// RoleContains applies the Contains predicate on the "role" field.
func RoleContains(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContains(FieldRole, v))
}

// RoleHasPrefix applies the HasPrefix predicate on the "role" field.
func RoleHasPrefix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasPrefix(FieldRole, v))
}

// RoleHasSuffix applies the HasSuffix predicate on the "role" field.
func RoleHasSuffix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasSuffix(FieldRole, v))
}

// RoleIsNil applies the IsNil predicate on the "role" field.
func RoleIsNil() predicate.Agent {
	return predicate.Agent(sql.FieldIsNull(FieldRole))
}

// RoleNotNil applies the NotNil predicate on the "role" field.
func RoleNotNil() predicate.Agent {
	return predicate.Agent(sql.FieldNotNull(FieldRole))
}

// RoleEqualFold applies the EqualFold predicate on the "role" field.
func RoleEqualFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEqualFold(FieldRole, v))
}

// RoleContainsFold applies the ContainsFold predicate on the "role" field.
func RoleContainsFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContainsFold(FieldRole, v))
}

// StatusEQ applies the EQ predicate on the "status" field.
func StatusEQ(v int) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldStatus, v))
}

// StatusNEQ applies the NEQ predicate on the "status" field.
func StatusNEQ(v int) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldStatus, v))
}

// StatusIn applies the In predicate on the "status" field.
func StatusIn(vs ...int) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldStatus, vs...))
}

// StatusNotIn applies the NotIn predicate on the "status" field.
func StatusNotIn(vs ...int) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldStatus, vs...))
}

// StatusGT applies the GT predicate on the "status" field.
func StatusGT(v int) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldStatus, v))
}

// StatusGTE applies the GTE predicate on the "status" field.
func StatusGTE(v int) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldStatus, v))
}

// StatusLT applies the LT predicate on the "status" field.
func StatusLT(v int) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldStatus, v))
}

// StatusLTE applies the LTE predicate on the "status" field.
func StatusLTE(v int) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldStatus, v))
}

// StatusIsNil applies the IsNil predicate on the "status" field.
func StatusIsNil() predicate.Agent {
	return predicate.Agent(sql.FieldIsNull(FieldStatus))
}

// StatusNotNil applies the NotNil predicate on the "status" field.
func StatusNotNil() predicate.Agent {
	return predicate.Agent(sql.FieldNotNull(FieldStatus))
}

// BackgroundEQ applies the EQ predicate on the "background" field.
func BackgroundEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldBackground, v))
}

// BackgroundNEQ applies the NEQ predicate on the "background" field.
func BackgroundNEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldBackground, v))
}

// BackgroundIn applies the In predicate on the "background" field.
func BackgroundIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldBackground, vs...))
}

// BackgroundNotIn applies the NotIn predicate on the "background" field.
func BackgroundNotIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldBackground, vs...))
}

// BackgroundGT applies the GT predicate on the "background" field.
func BackgroundGT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldBackground, v))
}

// BackgroundGTE applies the GTE predicate on the "background" field.
func BackgroundGTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldBackground, v))
}

// BackgroundLT applies the LT predicate on the "background" field.
func BackgroundLT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldBackground, v))
}

// BackgroundLTE applies the LTE predicate on the "background" field.
func BackgroundLTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldBackground, v))
}

// BackgroundContains applies the Contains predicate on the "background" field.
func BackgroundContains(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContains(FieldBackground, v))
}

// BackgroundHasPrefix applies the HasPrefix predicate on the "background" field.
func BackgroundHasPrefix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasPrefix(FieldBackground, v))
}

// BackgroundHasSuffix applies the HasSuffix predicate on the "background" field.
func BackgroundHasSuffix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasSuffix(FieldBackground, v))
}

// BackgroundIsNil applies the IsNil predicate on the "background" field.
func BackgroundIsNil() predicate.Agent {
	return predicate.Agent(sql.FieldIsNull(FieldBackground))
}

// BackgroundNotNil applies the NotNil predicate on the "background" field.
func BackgroundNotNil() predicate.Agent {
	return predicate.Agent(sql.FieldNotNull(FieldBackground))
}

// BackgroundEqualFold applies the EqualFold predicate on the "background" field.
func BackgroundEqualFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEqualFold(FieldBackground, v))
}

// BackgroundContainsFold applies the ContainsFold predicate on the "background" field.
func BackgroundContainsFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContainsFold(FieldBackground, v))
}

// ExamplesEQ applies the EQ predicate on the "examples" field.
func ExamplesEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldExamples, v))
}

// ExamplesNEQ applies the NEQ predicate on the "examples" field.
func ExamplesNEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldExamples, v))
}

// ExamplesIn applies the In predicate on the "examples" field.
func ExamplesIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldExamples, vs...))
}

// ExamplesNotIn applies the NotIn predicate on the "examples" field.
func ExamplesNotIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldExamples, vs...))
}

// ExamplesGT applies the GT predicate on the "examples" field.
func ExamplesGT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldExamples, v))
}

// ExamplesGTE applies the GTE predicate on the "examples" field.
func ExamplesGTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldExamples, v))
}

// ExamplesLT applies the LT predicate on the "examples" field.
func ExamplesLT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldExamples, v))
}

// ExamplesLTE applies the LTE predicate on the "examples" field.
func ExamplesLTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldExamples, v))
}

// ExamplesContains applies the Contains predicate on the "examples" field.
func ExamplesContains(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContains(FieldExamples, v))
}

// ExamplesHasPrefix applies the HasPrefix predicate on the "examples" field.
func ExamplesHasPrefix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasPrefix(FieldExamples, v))
}

// ExamplesHasSuffix applies the HasSuffix predicate on the "examples" field.
func ExamplesHasSuffix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasSuffix(FieldExamples, v))
}

// ExamplesIsNil applies the IsNil predicate on the "examples" field.
func ExamplesIsNil() predicate.Agent {
	return predicate.Agent(sql.FieldIsNull(FieldExamples))
}

// ExamplesNotNil applies the NotNil predicate on the "examples" field.
func ExamplesNotNil() predicate.Agent {
	return predicate.Agent(sql.FieldNotNull(FieldExamples))
}

// ExamplesEqualFold applies the EqualFold predicate on the "examples" field.
func ExamplesEqualFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEqualFold(FieldExamples, v))
}

// ExamplesContainsFold applies the ContainsFold predicate on the "examples" field.
func ExamplesContainsFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContainsFold(FieldExamples, v))
}

// OrganizationIDEQ applies the EQ predicate on the "organization_id" field.
func OrganizationIDEQ(v uint64) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldOrganizationID, v))
}

// OrganizationIDNEQ applies the NEQ predicate on the "organization_id" field.
func OrganizationIDNEQ(v uint64) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldOrganizationID, v))
}

// OrganizationIDIn applies the In predicate on the "organization_id" field.
func OrganizationIDIn(vs ...uint64) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldOrganizationID, vs...))
}

// OrganizationIDNotIn applies the NotIn predicate on the "organization_id" field.
func OrganizationIDNotIn(vs ...uint64) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldOrganizationID, vs...))
}

// OrganizationIDGT applies the GT predicate on the "organization_id" field.
func OrganizationIDGT(v uint64) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldOrganizationID, v))
}

// OrganizationIDGTE applies the GTE predicate on the "organization_id" field.
func OrganizationIDGTE(v uint64) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldOrganizationID, v))
}

// OrganizationIDLT applies the LT predicate on the "organization_id" field.
func OrganizationIDLT(v uint64) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldOrganizationID, v))
}

// OrganizationIDLTE applies the LTE predicate on the "organization_id" field.
func OrganizationIDLTE(v uint64) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldOrganizationID, v))
}

// DatasetIDEQ applies the EQ predicate on the "dataset_id" field.
func DatasetIDEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldDatasetID, v))
}

// DatasetIDNEQ applies the NEQ predicate on the "dataset_id" field.
func DatasetIDNEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldDatasetID, v))
}

// DatasetIDIn applies the In predicate on the "dataset_id" field.
func DatasetIDIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldDatasetID, vs...))
}

// DatasetIDNotIn applies the NotIn predicate on the "dataset_id" field.
func DatasetIDNotIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldDatasetID, vs...))
}

// DatasetIDGT applies the GT predicate on the "dataset_id" field.
func DatasetIDGT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldDatasetID, v))
}

// DatasetIDGTE applies the GTE predicate on the "dataset_id" field.
func DatasetIDGTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldDatasetID, v))
}

// DatasetIDLT applies the LT predicate on the "dataset_id" field.
func DatasetIDLT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldDatasetID, v))
}

// DatasetIDLTE applies the LTE predicate on the "dataset_id" field.
func DatasetIDLTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldDatasetID, v))
}

// DatasetIDContains applies the Contains predicate on the "dataset_id" field.
func DatasetIDContains(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContains(FieldDatasetID, v))
}

// DatasetIDHasPrefix applies the HasPrefix predicate on the "dataset_id" field.
func DatasetIDHasPrefix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasPrefix(FieldDatasetID, v))
}

// DatasetIDHasSuffix applies the HasSuffix predicate on the "dataset_id" field.
func DatasetIDHasSuffix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasSuffix(FieldDatasetID, v))
}

// DatasetIDEqualFold applies the EqualFold predicate on the "dataset_id" field.
func DatasetIDEqualFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEqualFold(FieldDatasetID, v))
}

// DatasetIDContainsFold applies the ContainsFold predicate on the "dataset_id" field.
func DatasetIDContainsFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContainsFold(FieldDatasetID, v))
}

// CollectionIDEQ applies the EQ predicate on the "collection_id" field.
func CollectionIDEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldCollectionID, v))
}

// CollectionIDNEQ applies the NEQ predicate on the "collection_id" field.
func CollectionIDNEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldCollectionID, v))
}

// CollectionIDIn applies the In predicate on the "collection_id" field.
func CollectionIDIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldCollectionID, vs...))
}

// CollectionIDNotIn applies the NotIn predicate on the "collection_id" field.
func CollectionIDNotIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldCollectionID, vs...))
}

// CollectionIDGT applies the GT predicate on the "collection_id" field.
func CollectionIDGT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldCollectionID, v))
}

// CollectionIDGTE applies the GTE predicate on the "collection_id" field.
func CollectionIDGTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldCollectionID, v))
}

// CollectionIDLT applies the LT predicate on the "collection_id" field.
func CollectionIDLT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldCollectionID, v))
}

// CollectionIDLTE applies the LTE predicate on the "collection_id" field.
func CollectionIDLTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldCollectionID, v))
}

// CollectionIDContains applies the Contains predicate on the "collection_id" field.
func CollectionIDContains(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContains(FieldCollectionID, v))
}

// CollectionIDHasPrefix applies the HasPrefix predicate on the "collection_id" field.
func CollectionIDHasPrefix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasPrefix(FieldCollectionID, v))
}

// CollectionIDHasSuffix applies the HasSuffix predicate on the "collection_id" field.
func CollectionIDHasSuffix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasSuffix(FieldCollectionID, v))
}

// CollectionIDEqualFold applies the EqualFold predicate on the "collection_id" field.
func CollectionIDEqualFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEqualFold(FieldCollectionID, v))
}

// CollectionIDContainsFold applies the ContainsFold predicate on the "collection_id" field.
func CollectionIDContainsFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContainsFold(FieldCollectionID, v))
}

// ModelEQ applies the EQ predicate on the "model" field.
func ModelEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldModel, v))
}

// ModelNEQ applies the NEQ predicate on the "model" field.
func ModelNEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldModel, v))
}

// ModelIn applies the In predicate on the "model" field.
func ModelIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldModel, vs...))
}

// ModelNotIn applies the NotIn predicate on the "model" field.
func ModelNotIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldModel, vs...))
}

// ModelGT applies the GT predicate on the "model" field.
func ModelGT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldModel, v))
}

// ModelGTE applies the GTE predicate on the "model" field.
func ModelGTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldModel, v))
}

// ModelLT applies the LT predicate on the "model" field.
func ModelLT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldModel, v))
}

// ModelLTE applies the LTE predicate on the "model" field.
func ModelLTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldModel, v))
}

// ModelContains applies the Contains predicate on the "model" field.
func ModelContains(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContains(FieldModel, v))
}

// ModelHasPrefix applies the HasPrefix predicate on the "model" field.
func ModelHasPrefix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasPrefix(FieldModel, v))
}

// ModelHasSuffix applies the HasSuffix predicate on the "model" field.
func ModelHasSuffix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasSuffix(FieldModel, v))
}

// ModelIsNil applies the IsNil predicate on the "model" field.
func ModelIsNil() predicate.Agent {
	return predicate.Agent(sql.FieldIsNull(FieldModel))
}

// ModelNotNil applies the NotNil predicate on the "model" field.
func ModelNotNil() predicate.Agent {
	return predicate.Agent(sql.FieldNotNull(FieldModel))
}

// ModelEqualFold applies the EqualFold predicate on the "model" field.
func ModelEqualFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEqualFold(FieldModel, v))
}

// ModelContainsFold applies the ContainsFold predicate on the "model" field.
func ModelContainsFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContainsFold(FieldModel, v))
}

// APIBaseEQ applies the EQ predicate on the "api_base" field.
func APIBaseEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldAPIBase, v))
}

// APIBaseNEQ applies the NEQ predicate on the "api_base" field.
func APIBaseNEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldAPIBase, v))
}

// APIBaseIn applies the In predicate on the "api_base" field.
func APIBaseIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldAPIBase, vs...))
}

// APIBaseNotIn applies the NotIn predicate on the "api_base" field.
func APIBaseNotIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldAPIBase, vs...))
}

// APIBaseGT applies the GT predicate on the "api_base" field.
func APIBaseGT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldAPIBase, v))
}

// APIBaseGTE applies the GTE predicate on the "api_base" field.
func APIBaseGTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldAPIBase, v))
}

// APIBaseLT applies the LT predicate on the "api_base" field.
func APIBaseLT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldAPIBase, v))
}

// APIBaseLTE applies the LTE predicate on the "api_base" field.
func APIBaseLTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldAPIBase, v))
}

// APIBaseContains applies the Contains predicate on the "api_base" field.
func APIBaseContains(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContains(FieldAPIBase, v))
}

// APIBaseHasPrefix applies the HasPrefix predicate on the "api_base" field.
func APIBaseHasPrefix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasPrefix(FieldAPIBase, v))
}

// APIBaseHasSuffix applies the HasSuffix predicate on the "api_base" field.
func APIBaseHasSuffix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasSuffix(FieldAPIBase, v))
}

// APIBaseIsNil applies the IsNil predicate on the "api_base" field.
func APIBaseIsNil() predicate.Agent {
	return predicate.Agent(sql.FieldIsNull(FieldAPIBase))
}

// APIBaseNotNil applies the NotNil predicate on the "api_base" field.
func APIBaseNotNil() predicate.Agent {
	return predicate.Agent(sql.FieldNotNull(FieldAPIBase))
}

// APIBaseEqualFold applies the EqualFold predicate on the "api_base" field.
func APIBaseEqualFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEqualFold(FieldAPIBase, v))
}

// APIBaseContainsFold applies the ContainsFold predicate on the "api_base" field.
func APIBaseContainsFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContainsFold(FieldAPIBase, v))
}

// APIKeyEQ applies the EQ predicate on the "api_key" field.
func APIKeyEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldAPIKey, v))
}

// APIKeyNEQ applies the NEQ predicate on the "api_key" field.
func APIKeyNEQ(v string) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldAPIKey, v))
}

// APIKeyIn applies the In predicate on the "api_key" field.
func APIKeyIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldAPIKey, vs...))
}

// APIKeyNotIn applies the NotIn predicate on the "api_key" field.
func APIKeyNotIn(vs ...string) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldAPIKey, vs...))
}

// APIKeyGT applies the GT predicate on the "api_key" field.
func APIKeyGT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldAPIKey, v))
}

// APIKeyGTE applies the GTE predicate on the "api_key" field.
func APIKeyGTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldAPIKey, v))
}

// APIKeyLT applies the LT predicate on the "api_key" field.
func APIKeyLT(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldAPIKey, v))
}

// APIKeyLTE applies the LTE predicate on the "api_key" field.
func APIKeyLTE(v string) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldAPIKey, v))
}

// APIKeyContains applies the Contains predicate on the "api_key" field.
func APIKeyContains(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContains(FieldAPIKey, v))
}

// APIKeyHasPrefix applies the HasPrefix predicate on the "api_key" field.
func APIKeyHasPrefix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasPrefix(FieldAPIKey, v))
}

// APIKeyHasSuffix applies the HasSuffix predicate on the "api_key" field.
func APIKeyHasSuffix(v string) predicate.Agent {
	return predicate.Agent(sql.FieldHasSuffix(FieldAPIKey, v))
}

// APIKeyIsNil applies the IsNil predicate on the "api_key" field.
func APIKeyIsNil() predicate.Agent {
	return predicate.Agent(sql.FieldIsNull(FieldAPIKey))
}

// APIKeyNotNil applies the NotNil predicate on the "api_key" field.
func APIKeyNotNil() predicate.Agent {
	return predicate.Agent(sql.FieldNotNull(FieldAPIKey))
}

// APIKeyEqualFold applies the EqualFold predicate on the "api_key" field.
func APIKeyEqualFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldEqualFold(FieldAPIKey, v))
}

// APIKeyContainsFold applies the ContainsFold predicate on the "api_key" field.
func APIKeyContainsFold(v string) predicate.Agent {
	return predicate.Agent(sql.FieldContainsFold(FieldAPIKey, v))
}

// TypeEQ applies the EQ predicate on the "type" field.
func TypeEQ(v int) predicate.Agent {
	return predicate.Agent(sql.FieldEQ(FieldType, v))
}

// TypeNEQ applies the NEQ predicate on the "type" field.
func TypeNEQ(v int) predicate.Agent {
	return predicate.Agent(sql.FieldNEQ(FieldType, v))
}

// TypeIn applies the In predicate on the "type" field.
func TypeIn(vs ...int) predicate.Agent {
	return predicate.Agent(sql.FieldIn(FieldType, vs...))
}

// TypeNotIn applies the NotIn predicate on the "type" field.
func TypeNotIn(vs ...int) predicate.Agent {
	return predicate.Agent(sql.FieldNotIn(FieldType, vs...))
}

// TypeGT applies the GT predicate on the "type" field.
func TypeGT(v int) predicate.Agent {
	return predicate.Agent(sql.FieldGT(FieldType, v))
}

// TypeGTE applies the GTE predicate on the "type" field.
func TypeGTE(v int) predicate.Agent {
	return predicate.Agent(sql.FieldGTE(FieldType, v))
}

// TypeLT applies the LT predicate on the "type" field.
func TypeLT(v int) predicate.Agent {
	return predicate.Agent(sql.FieldLT(FieldType, v))
}

// TypeLTE applies the LTE predicate on the "type" field.
func TypeLTE(v int) predicate.Agent {
	return predicate.Agent(sql.FieldLTE(FieldType, v))
}

// TypeIsNil applies the IsNil predicate on the "type" field.
func TypeIsNil() predicate.Agent {
	return predicate.Agent(sql.FieldIsNull(FieldType))
}

// TypeNotNil applies the NotNil predicate on the "type" field.
func TypeNotNil() predicate.Agent {
	return predicate.Agent(sql.FieldNotNull(FieldType))
}

// HasWxAgent applies the HasEdge predicate on the "wx_agent" edge.
func HasWxAgent() predicate.Agent {
	return predicate.Agent(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, WxAgentTable, WxAgentColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasWxAgentWith applies the HasEdge predicate on the "wx_agent" edge with a given conditions (other predicates).
func HasWxAgentWith(preds ...predicate.Wx) predicate.Agent {
	return predicate.Agent(func(s *sql.Selector) {
		step := newWxAgentStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasTokenAgent applies the HasEdge predicate on the "token_agent" edge.
func HasTokenAgent() predicate.Agent {
	return predicate.Agent(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, TokenAgentTable, TokenAgentColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasTokenAgentWith applies the HasEdge predicate on the "token_agent" edge with a given conditions (other predicates).
func HasTokenAgentWith(preds ...predicate.Token) predicate.Agent {
	return predicate.Agent(func(s *sql.Selector) {
		step := newTokenAgentStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasWaAgent applies the HasEdge predicate on the "wa_agent" edge.
func HasWaAgent() predicate.Agent {
	return predicate.Agent(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, WaAgentTable, WaAgentColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasWaAgentWith applies the HasEdge predicate on the "wa_agent" edge with a given conditions (other predicates).
func HasWaAgentWith(preds ...predicate.Whatsapp) predicate.Agent {
	return predicate.Agent(func(s *sql.Selector) {
		step := newWaAgentStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasXjsAgent applies the HasEdge predicate on the "xjs_agent" edge.
func HasXjsAgent() predicate.Agent {
	return predicate.Agent(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, XjsAgentTable, XjsAgentColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasXjsAgentWith applies the HasEdge predicate on the "xjs_agent" edge with a given conditions (other predicates).
func HasXjsAgentWith(preds ...predicate.XunjiService) predicate.Agent {
	return predicate.Agent(func(s *sql.Selector) {
		step := newXjsAgentStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasKeyAgent applies the HasEdge predicate on the "key_agent" edge.
func HasKeyAgent() predicate.Agent {
	return predicate.Agent(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, KeyAgentTable, KeyAgentColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasKeyAgentWith applies the HasEdge predicate on the "key_agent" edge with a given conditions (other predicates).
func HasKeyAgentWith(preds ...predicate.ApiKey) predicate.Agent {
	return predicate.Agent(func(s *sql.Selector) {
		step := newKeyAgentStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Agent) predicate.Agent {
	return predicate.Agent(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Agent) predicate.Agent {
	return predicate.Agent(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Agent) predicate.Agent {
	return predicate.Agent(sql.NotPredicates(p))
}
