package custom_types

type Condition struct {
	Equal       int      `json:"equal"`
	LabelIdList []uint64 `json:"labelIdList"`
}

type Action struct {
	Type    int    `json:"type"`
	Content string `json:"content"`
	Meta    *Meta  `json:"meta,omitempty"`
}

type Meta struct {
	Filename string `json:"filename,omitempty"`
}

type ActionForward struct {
	Wxid   string   `json:"wxid"`
	Action []Action `json:"action"`
}

type LabelDist struct {
	LabelID uint64 `json:"label_id"`
	Count   uint64 `json:"count"`
}

type OriginalData struct {
	Request   interface{} `json:"request"`
	Response  interface{} `json:"response"`
	VResponse *VResponse  `json:"vResponse"`
}

type ContactFieldTemplate struct {
	Type    *string                       `json:"type,omitempty"`
	Id      *string                       `json:"id,omitempty"`
	Label   *string                       `json:"label,omitempty"`
	Options []ContactFieldTemplateOptions `json:"options,omitempty"`
	Value   []string                      `json:"value,omitempty"`
}

type ContactFieldTemplateOptions struct {
	Label *string `json:"type,omitempty"`
	Value *string `json:"value,omitempty"`
}

type VResponse struct {
	ID           string          `json:"id"`
	Model        string          `json:"model"`
	ResponseData []VResponseData `json:"responseData"`
}

type VResponseData struct {
	ID    string `json:"id"`
	Model string `json:"model,omitempty"`
}
