// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"
	"wechat-api/ent/xunji"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// XunjiCreate is the builder for creating a Xunji entity.
type XunjiCreate struct {
	config
	mutation *XunjiMutation
	hooks    []Hook
	conflict []sql.ConflictOption
}

// SetCreatedAt sets the "created_at" field.
func (xc *XunjiCreate) SetCreatedAt(t time.Time) *XunjiCreate {
	xc.mutation.SetCreatedAt(t)
	return xc
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (xc *XunjiCreate) SetNillableCreatedAt(t *time.Time) *XunjiCreate {
	if t != nil {
		xc.SetCreatedAt(*t)
	}
	return xc
}

// SetUpdatedAt sets the "updated_at" field.
func (xc *XunjiCreate) SetUpdatedAt(t time.Time) *XunjiCreate {
	xc.mutation.SetUpdatedAt(t)
	return xc
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (xc *XunjiCreate) SetNillableUpdatedAt(t *time.Time) *XunjiCreate {
	if t != nil {
		xc.SetUpdatedAt(*t)
	}
	return xc
}

// SetStatus sets the "status" field.
func (xc *XunjiCreate) SetStatus(u uint8) *XunjiCreate {
	xc.mutation.SetStatus(u)
	return xc
}

// SetNillableStatus sets the "status" field if the given value is not nil.
func (xc *XunjiCreate) SetNillableStatus(u *uint8) *XunjiCreate {
	if u != nil {
		xc.SetStatus(*u)
	}
	return xc
}

// SetDeletedAt sets the "deleted_at" field.
func (xc *XunjiCreate) SetDeletedAt(t time.Time) *XunjiCreate {
	xc.mutation.SetDeletedAt(t)
	return xc
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (xc *XunjiCreate) SetNillableDeletedAt(t *time.Time) *XunjiCreate {
	if t != nil {
		xc.SetDeletedAt(*t)
	}
	return xc
}

// SetAppKey sets the "app_key" field.
func (xc *XunjiCreate) SetAppKey(s string) *XunjiCreate {
	xc.mutation.SetAppKey(s)
	return xc
}

// SetNillableAppKey sets the "app_key" field if the given value is not nil.
func (xc *XunjiCreate) SetNillableAppKey(s *string) *XunjiCreate {
	if s != nil {
		xc.SetAppKey(*s)
	}
	return xc
}

// SetAppSecret sets the "app_secret" field.
func (xc *XunjiCreate) SetAppSecret(s string) *XunjiCreate {
	xc.mutation.SetAppSecret(s)
	return xc
}

// SetNillableAppSecret sets the "app_secret" field if the given value is not nil.
func (xc *XunjiCreate) SetNillableAppSecret(s *string) *XunjiCreate {
	if s != nil {
		xc.SetAppSecret(*s)
	}
	return xc
}

// SetToken sets the "token" field.
func (xc *XunjiCreate) SetToken(s string) *XunjiCreate {
	xc.mutation.SetToken(s)
	return xc
}

// SetNillableToken sets the "token" field if the given value is not nil.
func (xc *XunjiCreate) SetNillableToken(s *string) *XunjiCreate {
	if s != nil {
		xc.SetToken(*s)
	}
	return xc
}

// SetEncodingKey sets the "encoding_key" field.
func (xc *XunjiCreate) SetEncodingKey(s string) *XunjiCreate {
	xc.mutation.SetEncodingKey(s)
	return xc
}

// SetNillableEncodingKey sets the "encoding_key" field if the given value is not nil.
func (xc *XunjiCreate) SetNillableEncodingKey(s *string) *XunjiCreate {
	if s != nil {
		xc.SetEncodingKey(*s)
	}
	return xc
}

// SetOrganizationID sets the "organization_id" field.
func (xc *XunjiCreate) SetOrganizationID(u uint64) *XunjiCreate {
	xc.mutation.SetOrganizationID(u)
	return xc
}

// SetID sets the "id" field.
func (xc *XunjiCreate) SetID(u uint64) *XunjiCreate {
	xc.mutation.SetID(u)
	return xc
}

// Mutation returns the XunjiMutation object of the builder.
func (xc *XunjiCreate) Mutation() *XunjiMutation {
	return xc.mutation
}

// Save creates the Xunji in the database.
func (xc *XunjiCreate) Save(ctx context.Context) (*Xunji, error) {
	if err := xc.defaults(); err != nil {
		return nil, err
	}
	return withHooks(ctx, xc.sqlSave, xc.mutation, xc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (xc *XunjiCreate) SaveX(ctx context.Context) *Xunji {
	v, err := xc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (xc *XunjiCreate) Exec(ctx context.Context) error {
	_, err := xc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (xc *XunjiCreate) ExecX(ctx context.Context) {
	if err := xc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (xc *XunjiCreate) defaults() error {
	if _, ok := xc.mutation.CreatedAt(); !ok {
		if xunji.DefaultCreatedAt == nil {
			return fmt.Errorf("ent: uninitialized xunji.DefaultCreatedAt (forgotten import ent/runtime?)")
		}
		v := xunji.DefaultCreatedAt()
		xc.mutation.SetCreatedAt(v)
	}
	if _, ok := xc.mutation.UpdatedAt(); !ok {
		if xunji.DefaultUpdatedAt == nil {
			return fmt.Errorf("ent: uninitialized xunji.DefaultUpdatedAt (forgotten import ent/runtime?)")
		}
		v := xunji.DefaultUpdatedAt()
		xc.mutation.SetUpdatedAt(v)
	}
	if _, ok := xc.mutation.Status(); !ok {
		v := xunji.DefaultStatus
		xc.mutation.SetStatus(v)
	}
	return nil
}

// check runs all checks and user-defined validators on the builder.
func (xc *XunjiCreate) check() error {
	if _, ok := xc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "Xunji.created_at"`)}
	}
	if _, ok := xc.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "Xunji.updated_at"`)}
	}
	if _, ok := xc.mutation.OrganizationID(); !ok {
		return &ValidationError{Name: "organization_id", err: errors.New(`ent: missing required field "Xunji.organization_id"`)}
	}
	if v, ok := xc.mutation.OrganizationID(); ok {
		if err := xunji.OrganizationIDValidator(v); err != nil {
			return &ValidationError{Name: "organization_id", err: fmt.Errorf(`ent: validator failed for field "Xunji.organization_id": %w`, err)}
		}
	}
	return nil
}

func (xc *XunjiCreate) sqlSave(ctx context.Context) (*Xunji, error) {
	if err := xc.check(); err != nil {
		return nil, err
	}
	_node, _spec := xc.createSpec()
	if err := sqlgraph.CreateNode(ctx, xc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	if _spec.ID.Value != _node.ID {
		id := _spec.ID.Value.(int64)
		_node.ID = uint64(id)
	}
	xc.mutation.id = &_node.ID
	xc.mutation.done = true
	return _node, nil
}

func (xc *XunjiCreate) createSpec() (*Xunji, *sqlgraph.CreateSpec) {
	var (
		_node = &Xunji{config: xc.config}
		_spec = sqlgraph.NewCreateSpec(xunji.Table, sqlgraph.NewFieldSpec(xunji.FieldID, field.TypeUint64))
	)
	_spec.OnConflict = xc.conflict
	if id, ok := xc.mutation.ID(); ok {
		_node.ID = id
		_spec.ID.Value = id
	}
	if value, ok := xc.mutation.CreatedAt(); ok {
		_spec.SetField(xunji.FieldCreatedAt, field.TypeTime, value)
		_node.CreatedAt = value
	}
	if value, ok := xc.mutation.UpdatedAt(); ok {
		_spec.SetField(xunji.FieldUpdatedAt, field.TypeTime, value)
		_node.UpdatedAt = value
	}
	if value, ok := xc.mutation.Status(); ok {
		_spec.SetField(xunji.FieldStatus, field.TypeUint8, value)
		_node.Status = value
	}
	if value, ok := xc.mutation.DeletedAt(); ok {
		_spec.SetField(xunji.FieldDeletedAt, field.TypeTime, value)
		_node.DeletedAt = value
	}
	if value, ok := xc.mutation.AppKey(); ok {
		_spec.SetField(xunji.FieldAppKey, field.TypeString, value)
		_node.AppKey = value
	}
	if value, ok := xc.mutation.AppSecret(); ok {
		_spec.SetField(xunji.FieldAppSecret, field.TypeString, value)
		_node.AppSecret = value
	}
	if value, ok := xc.mutation.Token(); ok {
		_spec.SetField(xunji.FieldToken, field.TypeString, value)
		_node.Token = value
	}
	if value, ok := xc.mutation.EncodingKey(); ok {
		_spec.SetField(xunji.FieldEncodingKey, field.TypeString, value)
		_node.EncodingKey = value
	}
	if value, ok := xc.mutation.OrganizationID(); ok {
		_spec.SetField(xunji.FieldOrganizationID, field.TypeUint64, value)
		_node.OrganizationID = value
	}
	return _node, _spec
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.Xunji.Create().
//		SetCreatedAt(v).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.XunjiUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (xc *XunjiCreate) OnConflict(opts ...sql.ConflictOption) *XunjiUpsertOne {
	xc.conflict = opts
	return &XunjiUpsertOne{
		create: xc,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.Xunji.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (xc *XunjiCreate) OnConflictColumns(columns ...string) *XunjiUpsertOne {
	xc.conflict = append(xc.conflict, sql.ConflictColumns(columns...))
	return &XunjiUpsertOne{
		create: xc,
	}
}

type (
	// XunjiUpsertOne is the builder for "upsert"-ing
	//  one Xunji node.
	XunjiUpsertOne struct {
		create *XunjiCreate
	}

	// XunjiUpsert is the "OnConflict" setter.
	XunjiUpsert struct {
		*sql.UpdateSet
	}
)

// SetUpdatedAt sets the "updated_at" field.
func (u *XunjiUpsert) SetUpdatedAt(v time.Time) *XunjiUpsert {
	u.Set(xunji.FieldUpdatedAt, v)
	return u
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *XunjiUpsert) UpdateUpdatedAt() *XunjiUpsert {
	u.SetExcluded(xunji.FieldUpdatedAt)
	return u
}

// SetStatus sets the "status" field.
func (u *XunjiUpsert) SetStatus(v uint8) *XunjiUpsert {
	u.Set(xunji.FieldStatus, v)
	return u
}

// UpdateStatus sets the "status" field to the value that was provided on create.
func (u *XunjiUpsert) UpdateStatus() *XunjiUpsert {
	u.SetExcluded(xunji.FieldStatus)
	return u
}

// AddStatus adds v to the "status" field.
func (u *XunjiUpsert) AddStatus(v uint8) *XunjiUpsert {
	u.Add(xunji.FieldStatus, v)
	return u
}

// ClearStatus clears the value of the "status" field.
func (u *XunjiUpsert) ClearStatus() *XunjiUpsert {
	u.SetNull(xunji.FieldStatus)
	return u
}

// SetDeletedAt sets the "deleted_at" field.
func (u *XunjiUpsert) SetDeletedAt(v time.Time) *XunjiUpsert {
	u.Set(xunji.FieldDeletedAt, v)
	return u
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *XunjiUpsert) UpdateDeletedAt() *XunjiUpsert {
	u.SetExcluded(xunji.FieldDeletedAt)
	return u
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *XunjiUpsert) ClearDeletedAt() *XunjiUpsert {
	u.SetNull(xunji.FieldDeletedAt)
	return u
}

// SetAppKey sets the "app_key" field.
func (u *XunjiUpsert) SetAppKey(v string) *XunjiUpsert {
	u.Set(xunji.FieldAppKey, v)
	return u
}

// UpdateAppKey sets the "app_key" field to the value that was provided on create.
func (u *XunjiUpsert) UpdateAppKey() *XunjiUpsert {
	u.SetExcluded(xunji.FieldAppKey)
	return u
}

// ClearAppKey clears the value of the "app_key" field.
func (u *XunjiUpsert) ClearAppKey() *XunjiUpsert {
	u.SetNull(xunji.FieldAppKey)
	return u
}

// SetAppSecret sets the "app_secret" field.
func (u *XunjiUpsert) SetAppSecret(v string) *XunjiUpsert {
	u.Set(xunji.FieldAppSecret, v)
	return u
}

// UpdateAppSecret sets the "app_secret" field to the value that was provided on create.
func (u *XunjiUpsert) UpdateAppSecret() *XunjiUpsert {
	u.SetExcluded(xunji.FieldAppSecret)
	return u
}

// ClearAppSecret clears the value of the "app_secret" field.
func (u *XunjiUpsert) ClearAppSecret() *XunjiUpsert {
	u.SetNull(xunji.FieldAppSecret)
	return u
}

// SetToken sets the "token" field.
func (u *XunjiUpsert) SetToken(v string) *XunjiUpsert {
	u.Set(xunji.FieldToken, v)
	return u
}

// UpdateToken sets the "token" field to the value that was provided on create.
func (u *XunjiUpsert) UpdateToken() *XunjiUpsert {
	u.SetExcluded(xunji.FieldToken)
	return u
}

// ClearToken clears the value of the "token" field.
func (u *XunjiUpsert) ClearToken() *XunjiUpsert {
	u.SetNull(xunji.FieldToken)
	return u
}

// SetEncodingKey sets the "encoding_key" field.
func (u *XunjiUpsert) SetEncodingKey(v string) *XunjiUpsert {
	u.Set(xunji.FieldEncodingKey, v)
	return u
}

// UpdateEncodingKey sets the "encoding_key" field to the value that was provided on create.
func (u *XunjiUpsert) UpdateEncodingKey() *XunjiUpsert {
	u.SetExcluded(xunji.FieldEncodingKey)
	return u
}

// ClearEncodingKey clears the value of the "encoding_key" field.
func (u *XunjiUpsert) ClearEncodingKey() *XunjiUpsert {
	u.SetNull(xunji.FieldEncodingKey)
	return u
}

// SetOrganizationID sets the "organization_id" field.
func (u *XunjiUpsert) SetOrganizationID(v uint64) *XunjiUpsert {
	u.Set(xunji.FieldOrganizationID, v)
	return u
}

// UpdateOrganizationID sets the "organization_id" field to the value that was provided on create.
func (u *XunjiUpsert) UpdateOrganizationID() *XunjiUpsert {
	u.SetExcluded(xunji.FieldOrganizationID)
	return u
}

// AddOrganizationID adds v to the "organization_id" field.
func (u *XunjiUpsert) AddOrganizationID(v uint64) *XunjiUpsert {
	u.Add(xunji.FieldOrganizationID, v)
	return u
}

// UpdateNewValues updates the mutable fields using the new values that were set on create except the ID field.
// Using this option is equivalent to using:
//
//	client.Xunji.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(xunji.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *XunjiUpsertOne) UpdateNewValues() *XunjiUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		if _, exists := u.create.mutation.ID(); exists {
			s.SetIgnore(xunji.FieldID)
		}
		if _, exists := u.create.mutation.CreatedAt(); exists {
			s.SetIgnore(xunji.FieldCreatedAt)
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.Xunji.Create().
//	    OnConflict(sql.ResolveWithIgnore()).
//	    Exec(ctx)
func (u *XunjiUpsertOne) Ignore() *XunjiUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *XunjiUpsertOne) DoNothing() *XunjiUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the XunjiCreate.OnConflict
// documentation for more info.
func (u *XunjiUpsertOne) Update(set func(*XunjiUpsert)) *XunjiUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&XunjiUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *XunjiUpsertOne) SetUpdatedAt(v time.Time) *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *XunjiUpsertOne) UpdateUpdatedAt() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetStatus sets the "status" field.
func (u *XunjiUpsertOne) SetStatus(v uint8) *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.SetStatus(v)
	})
}

// AddStatus adds v to the "status" field.
func (u *XunjiUpsertOne) AddStatus(v uint8) *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.AddStatus(v)
	})
}

// UpdateStatus sets the "status" field to the value that was provided on create.
func (u *XunjiUpsertOne) UpdateStatus() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateStatus()
	})
}

// ClearStatus clears the value of the "status" field.
func (u *XunjiUpsertOne) ClearStatus() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearStatus()
	})
}

// SetDeletedAt sets the "deleted_at" field.
func (u *XunjiUpsertOne) SetDeletedAt(v time.Time) *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.SetDeletedAt(v)
	})
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *XunjiUpsertOne) UpdateDeletedAt() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateDeletedAt()
	})
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *XunjiUpsertOne) ClearDeletedAt() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearDeletedAt()
	})
}

// SetAppKey sets the "app_key" field.
func (u *XunjiUpsertOne) SetAppKey(v string) *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.SetAppKey(v)
	})
}

// UpdateAppKey sets the "app_key" field to the value that was provided on create.
func (u *XunjiUpsertOne) UpdateAppKey() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateAppKey()
	})
}

// ClearAppKey clears the value of the "app_key" field.
func (u *XunjiUpsertOne) ClearAppKey() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearAppKey()
	})
}

// SetAppSecret sets the "app_secret" field.
func (u *XunjiUpsertOne) SetAppSecret(v string) *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.SetAppSecret(v)
	})
}

// UpdateAppSecret sets the "app_secret" field to the value that was provided on create.
func (u *XunjiUpsertOne) UpdateAppSecret() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateAppSecret()
	})
}

// ClearAppSecret clears the value of the "app_secret" field.
func (u *XunjiUpsertOne) ClearAppSecret() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearAppSecret()
	})
}

// SetToken sets the "token" field.
func (u *XunjiUpsertOne) SetToken(v string) *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.SetToken(v)
	})
}

// UpdateToken sets the "token" field to the value that was provided on create.
func (u *XunjiUpsertOne) UpdateToken() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateToken()
	})
}

// ClearToken clears the value of the "token" field.
func (u *XunjiUpsertOne) ClearToken() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearToken()
	})
}

// SetEncodingKey sets the "encoding_key" field.
func (u *XunjiUpsertOne) SetEncodingKey(v string) *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.SetEncodingKey(v)
	})
}

// UpdateEncodingKey sets the "encoding_key" field to the value that was provided on create.
func (u *XunjiUpsertOne) UpdateEncodingKey() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateEncodingKey()
	})
}

// ClearEncodingKey clears the value of the "encoding_key" field.
func (u *XunjiUpsertOne) ClearEncodingKey() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearEncodingKey()
	})
}

// SetOrganizationID sets the "organization_id" field.
func (u *XunjiUpsertOne) SetOrganizationID(v uint64) *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.SetOrganizationID(v)
	})
}

// AddOrganizationID adds v to the "organization_id" field.
func (u *XunjiUpsertOne) AddOrganizationID(v uint64) *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.AddOrganizationID(v)
	})
}

// UpdateOrganizationID sets the "organization_id" field to the value that was provided on create.
func (u *XunjiUpsertOne) UpdateOrganizationID() *XunjiUpsertOne {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateOrganizationID()
	})
}

// Exec executes the query.
func (u *XunjiUpsertOne) Exec(ctx context.Context) error {
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for XunjiCreate.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *XunjiUpsertOne) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}

// Exec executes the UPSERT query and returns the inserted/updated ID.
func (u *XunjiUpsertOne) ID(ctx context.Context) (id uint64, err error) {
	node, err := u.create.Save(ctx)
	if err != nil {
		return id, err
	}
	return node.ID, nil
}

// IDX is like ID, but panics if an error occurs.
func (u *XunjiUpsertOne) IDX(ctx context.Context) uint64 {
	id, err := u.ID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// XunjiCreateBulk is the builder for creating many Xunji entities in bulk.
type XunjiCreateBulk struct {
	config
	err      error
	builders []*XunjiCreate
	conflict []sql.ConflictOption
}

// Save creates the Xunji entities in the database.
func (xcb *XunjiCreateBulk) Save(ctx context.Context) ([]*Xunji, error) {
	if xcb.err != nil {
		return nil, xcb.err
	}
	specs := make([]*sqlgraph.CreateSpec, len(xcb.builders))
	nodes := make([]*Xunji, len(xcb.builders))
	mutators := make([]Mutator, len(xcb.builders))
	for i := range xcb.builders {
		func(i int, root context.Context) {
			builder := xcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*XunjiMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, xcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					spec.OnConflict = xcb.conflict
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, xcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil && nodes[i].ID == 0 {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = uint64(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, xcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (xcb *XunjiCreateBulk) SaveX(ctx context.Context) []*Xunji {
	v, err := xcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (xcb *XunjiCreateBulk) Exec(ctx context.Context) error {
	_, err := xcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (xcb *XunjiCreateBulk) ExecX(ctx context.Context) {
	if err := xcb.Exec(ctx); err != nil {
		panic(err)
	}
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.Xunji.CreateBulk(builders...).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.XunjiUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (xcb *XunjiCreateBulk) OnConflict(opts ...sql.ConflictOption) *XunjiUpsertBulk {
	xcb.conflict = opts
	return &XunjiUpsertBulk{
		create: xcb,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.Xunji.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (xcb *XunjiCreateBulk) OnConflictColumns(columns ...string) *XunjiUpsertBulk {
	xcb.conflict = append(xcb.conflict, sql.ConflictColumns(columns...))
	return &XunjiUpsertBulk{
		create: xcb,
	}
}

// XunjiUpsertBulk is the builder for "upsert"-ing
// a bulk of Xunji nodes.
type XunjiUpsertBulk struct {
	create *XunjiCreateBulk
}

// UpdateNewValues updates the mutable fields using the new values that
// were set on create. Using this option is equivalent to using:
//
//	client.Xunji.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(xunji.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *XunjiUpsertBulk) UpdateNewValues() *XunjiUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		for _, b := range u.create.builders {
			if _, exists := b.mutation.ID(); exists {
				s.SetIgnore(xunji.FieldID)
			}
			if _, exists := b.mutation.CreatedAt(); exists {
				s.SetIgnore(xunji.FieldCreatedAt)
			}
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.Xunji.Create().
//		OnConflict(sql.ResolveWithIgnore()).
//		Exec(ctx)
func (u *XunjiUpsertBulk) Ignore() *XunjiUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *XunjiUpsertBulk) DoNothing() *XunjiUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the XunjiCreateBulk.OnConflict
// documentation for more info.
func (u *XunjiUpsertBulk) Update(set func(*XunjiUpsert)) *XunjiUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&XunjiUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *XunjiUpsertBulk) SetUpdatedAt(v time.Time) *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *XunjiUpsertBulk) UpdateUpdatedAt() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetStatus sets the "status" field.
func (u *XunjiUpsertBulk) SetStatus(v uint8) *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.SetStatus(v)
	})
}

// AddStatus adds v to the "status" field.
func (u *XunjiUpsertBulk) AddStatus(v uint8) *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.AddStatus(v)
	})
}

// UpdateStatus sets the "status" field to the value that was provided on create.
func (u *XunjiUpsertBulk) UpdateStatus() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateStatus()
	})
}

// ClearStatus clears the value of the "status" field.
func (u *XunjiUpsertBulk) ClearStatus() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearStatus()
	})
}

// SetDeletedAt sets the "deleted_at" field.
func (u *XunjiUpsertBulk) SetDeletedAt(v time.Time) *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.SetDeletedAt(v)
	})
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *XunjiUpsertBulk) UpdateDeletedAt() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateDeletedAt()
	})
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *XunjiUpsertBulk) ClearDeletedAt() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearDeletedAt()
	})
}

// SetAppKey sets the "app_key" field.
func (u *XunjiUpsertBulk) SetAppKey(v string) *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.SetAppKey(v)
	})
}

// UpdateAppKey sets the "app_key" field to the value that was provided on create.
func (u *XunjiUpsertBulk) UpdateAppKey() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateAppKey()
	})
}

// ClearAppKey clears the value of the "app_key" field.
func (u *XunjiUpsertBulk) ClearAppKey() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearAppKey()
	})
}

// SetAppSecret sets the "app_secret" field.
func (u *XunjiUpsertBulk) SetAppSecret(v string) *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.SetAppSecret(v)
	})
}

// UpdateAppSecret sets the "app_secret" field to the value that was provided on create.
func (u *XunjiUpsertBulk) UpdateAppSecret() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateAppSecret()
	})
}

// ClearAppSecret clears the value of the "app_secret" field.
func (u *XunjiUpsertBulk) ClearAppSecret() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearAppSecret()
	})
}

// SetToken sets the "token" field.
func (u *XunjiUpsertBulk) SetToken(v string) *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.SetToken(v)
	})
}

// UpdateToken sets the "token" field to the value that was provided on create.
func (u *XunjiUpsertBulk) UpdateToken() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateToken()
	})
}

// ClearToken clears the value of the "token" field.
func (u *XunjiUpsertBulk) ClearToken() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearToken()
	})
}

// SetEncodingKey sets the "encoding_key" field.
func (u *XunjiUpsertBulk) SetEncodingKey(v string) *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.SetEncodingKey(v)
	})
}

// UpdateEncodingKey sets the "encoding_key" field to the value that was provided on create.
func (u *XunjiUpsertBulk) UpdateEncodingKey() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateEncodingKey()
	})
}

// ClearEncodingKey clears the value of the "encoding_key" field.
func (u *XunjiUpsertBulk) ClearEncodingKey() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.ClearEncodingKey()
	})
}

// SetOrganizationID sets the "organization_id" field.
func (u *XunjiUpsertBulk) SetOrganizationID(v uint64) *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.SetOrganizationID(v)
	})
}

// AddOrganizationID adds v to the "organization_id" field.
func (u *XunjiUpsertBulk) AddOrganizationID(v uint64) *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.AddOrganizationID(v)
	})
}

// UpdateOrganizationID sets the "organization_id" field to the value that was provided on create.
func (u *XunjiUpsertBulk) UpdateOrganizationID() *XunjiUpsertBulk {
	return u.Update(func(s *XunjiUpsert) {
		s.UpdateOrganizationID()
	})
}

// Exec executes the query.
func (u *XunjiUpsertBulk) Exec(ctx context.Context) error {
	if u.create.err != nil {
		return u.create.err
	}
	for i, b := range u.create.builders {
		if len(b.conflict) != 0 {
			return fmt.Errorf("ent: OnConflict was set for builder %d. Set it on the XunjiCreateBulk instead", i)
		}
	}
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for XunjiCreateBulk.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *XunjiUpsertBulk) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}
