package config

import (
	"github.com/suyuan32/simple-admin-common/config"
	"github.com/suyuan32/simple-admin-common/plugins/casbin"
	"github.com/suyuan32/simple-admin-common/utils/captcha"
	"github.com/zeromicro/go-zero/rest"
	"github.com/zeromicro/go-zero/zrpc"
	"wechat-api/internal/types"
)

type Config struct {
	rest.RestConf
	Auth               rest.AuthConf
	CROSConf           config.CROSConf
	CasbinDatabaseConf config.DatabaseConf
	RedisConf          config.RedisConf
	CasbinConf         casbin.CasbinConf
	DatabaseConf       config.DatabaseConf
	Miniprogram        types.Miniprogram
	Fastgpt            types.Fastgpt
	Aliyun             types.Aliyun
	CoreRpc            zrpc.RpcClientConf
	Xiaoice            types.Xiaoice
	WebSocket          []types.WebSocketConfig
	OpenAI             types.OpenAI
	FastgptMongoConf   types.MongoDB
	//验证码设置
	Captcha captcha.Conf
	//登录类型设置
	LoginConf LoginConf
}

type LoginConf struct {
	LoginVerify string `json:",default=captcha,options=[captcha,email,sms,sms_or_email,all]"`
}
