package Wx

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/Wx"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /wx/changeOrganization Wx ChangeOrganization
//
// Change wx organization | 切换租户
//
// Change wx organization | 切换租户
//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: WxInfo
//
// Responses:
//  200: BaseMsgResp

func ChangeOrganizationHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.WxInfo
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := Wx.NewChangeOrganizationLogic(r.Context(), svcCtx)
		resp, err := l.ChangeOrganization(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
