package add_friend

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/add_friend"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /add_friend/cancel_by_ids add_friend CancelByIds
//
// cancel task add friend
//
// cancel task add friend
//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: CancelByIdsReq
//
// Responses:
//  200: BaseMsgResp

func CancelByIdsHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.CancelByIdsReq
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := add_friend.NewCancelByIdsLogic(r.Context(), svcCtx)
		resp, err := l.CancelByIds(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
