package allocagent

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/allocagent"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /alloc_agent/query allocagent QueryAllocAgent
//
// Get alloc agent by ID | 通过ID获取AllocAgent
//
// Get alloc agent by ID | 通过ID获取AllocAgent
//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: AllocAgentQuery
//
// Responses:
//  200: AllocAgentInfoResp

func QueryAllocAgentHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.AllocAgentQuery
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := allocagent.NewQueryAllocAgentLogic(r.Context(), svcCtx)
		resp, err := l.QueryAllocAgent(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
