package chat

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/chat"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /wx/add_friend_by_phone chat AddFriendByPhone
//

//

//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: AddFriendByPhoneReq
//
// Responses:
//  200: BaseMsgResp

func AddFriendByPhoneHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.AddFriendByPhoneReq
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := chat.NewAddFriendByPhoneLogic(r.Context(), svcCtx)
		resp, err := l.AddFriendByPhone(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
