package contact

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/contact"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /contact/analyzeContactField contact AnalyzeContactField
//
// 分析联系人自定义字段
//
// 分析联系人自定义字段
//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: AnalyzeContactFieldReq
//
// Responses:
//  200: AnalyzeContactFieldResp

func AnalyzeContactFieldHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.AnalyzeContactFieldReq
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := contact.NewAnalyzeContactFieldLogic(r.Context(), svcCtx)
		resp, err := l.AnalyzeContactField(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
