package label

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/label"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /label/import label LabelImport
//
//label import | 导出Label
//
//label import | 导出Label
//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: labelImportReq
//
// Responses:
//  200: BaseMsgResp

func LabelImportHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.LabelImportReq
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := label.NewLabelImportLogic(r.Context(), svcCtx)
		resp, err := l.LabelImport(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
