package sop_task

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/sop_task"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /sop_task/get_bot_by_task_id sop_task GetBotByTaskId
//

//

//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: GetBotByTaskIdReq
//
// Responses:
//  200: GetBotByTaskIdResp

func GetBotByTaskIdHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.GetBotByTaskIdReq
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := sop_task.NewGetBotByTaskIdLogic(r.Context(), svcCtx)
		resp, err := l.GetBotByTaskId(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
