package contact

import (
	"context"
	"github.com/suyuan32/simple-admin-common/msg/errormsg"
	"wechat-api/internal/service/wechat"

	"wechat-api/internal/svc"
	"wechat-api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type AnalyzeContactFieldLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewAnalyzeContactFieldLogic(ctx context.Context, svcCtx *svc.ServiceContext) *AnalyzeContactFieldLogic {
	return &AnalyzeContactFieldLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx}
}

func (l *AnalyzeContactFieldLogic) AnalyzeContactField(req *types.AnalyzeContactFieldReq) (resp *types.BaseMsgResp, err error) {
	wechat.NewAnalyzeContactField(l.ctx, l.svcCtx).Analyze(req.WxWxid, req.Wxid)

	return &types.BaseMsgResp{Msg: errormsg.Success}, nil
}
