package channel

import (
	"time"
	"wechat-api/internal/pkg/customer_of_im/proto"
)

type ChatMessage struct {
	UserId           string                //该消息所属用户id
	MsgId            string                //该消息id
	CreateTime       time.Time             //消息创建时间
	Type             proto.EnumContentType //消息类型
	Content          string                //消息内容
	FromUserId       string                //消息发送者id
	FromUserNickname string                //消息发送者昵称
	ToUserId         string                //消息接收者id,正常情况和UserId相同
	ToUserNickname   string                //消息接收者昵称
	GroupId          string                //群组id
	GroupName        string                //群组名称
	IsGroup          bool                  //是否为群组消息
	IsAt             bool                  //是否被@
}

type ReplyMessage struct {
	*ChatMessage
}

type RelevantContext struct {
	BaseURL   string
	APIKey    string
	IsFastGPT bool
}

type ReplyJson struct {
	Type    string `json:"type"`
	Content string `json:"content"`
}
