// Code generated by goctl. DO NOT EDIT.
package types

// The basic response with data | 基础带数据信息
// swagger:model BaseDataInfo
type BaseDataInfo struct {
	// Error code | 错误代码
	Code int `json:"code"`
	// Message | 提示信息
	Msg string `json:"msg"`
	// Data | 数据
	Data string `json:"data,omitempty"`
}

// The basic response with data | 基础带数据信息
// swagger:model BaseListInfo
type BaseListInfo struct {
	// The total number of data | 数据总数
	Total uint64 `json:"total"`
	// Data | 数据
	Data string `json:"data,omitempty"`
}

// The basic response without data | 基础不带数据信息
// swagger:model BaseMsgResp
type BaseMsgResp struct {
	// Error code | 错误代码
	Code int `json:"code"`
	// Message | 提示信息
	Msg string `json:"msg"`
}

// The page request parameters | 列表请求参数
// swagger:model PageInfo
type PageInfo struct {
	// Page number | 第几页
	// required : true
	// min : 0
	Page uint64 `json:"page" validate:"required,number,gt=0"`
	// Page size | 单页数据行数
	// required : true
	// max : 100000
	PageSize uint64 `json:"pageSize" validate:"required,number,lt=100000"`
}

// Basic ID request | 基础ID参数请求
// swagger:model IDReq
type IDReq struct {
	// ID
	// Required: true
	Id uint64 `json:"id" validate:"number"`
}

// Basic IDs request | 基础ID数组参数请求
// swagger:model IDsReq
type IDsReq struct {
	// IDs
	// Required: true
	Ids []uint64 `json:"ids"`
}

// Basic ID request | 基础ID地址参数请求
// swagger:model IDPathReq
type IDPathReq struct {
	// ID
	// Required: true
	Id uint64 `path:"id"`
}

// Basic ID request (int32) | 基础ID参数请求 (int32)
// swagger:model IDInt32Req
type IDInt32Req struct {
	// ID
	// Required: true
	Id int32 `json:"id" validate:"number"`
}

// Basic IDs request (int32) | 基础ID数组参数请求 (int32)
// swagger:model IDsInt32Req
type IDsInt32Req struct {
	// IDs
	// Required: true
	Ids []int32 `json:"ids"`
}

// Basic ID request (int32) | 基础ID地址参数请求 (int32)
// swagger:model IDInt32PathReq
type IDInt32PathReq struct {
	// ID
	// Required: true
	Id int32 `path:"id"`
}

// Basic ID request (uint32) | 基础ID参数请求 (uint32)
// swagger:model IDUint32Req
type IDUint32Req struct {
	// ID
	// Required: true
	Id uint32 `json:"id" validate:"number"`
}

// Basic IDs request (uint32) | 基础ID数组参数请求 (uint32)
// swagger:model IDsUint32Req
type IDsUint32Req struct {
	// IDs
	// Required: true
	Ids []uint32 `json:"ids"`
}

// Basic ID request (uint32) | 基础ID地址参数请求 (uint32)
// swagger:model IDUint32PathReq
type IDUint32PathReq struct {
	// ID
	// Required: true
	Id uint32 `path:"id"`
}

// Basic ID request (int64) | 基础ID参数请求 (int64)
// swagger:model IDInt64Req
type IDInt64Req struct {
	// ID
	// Required: true
	Id int64 `json:"id" validate:"number"`
}

// Basic IDs request (int64) | 基础ID数组参数请求 (int64)
// swagger:model IDsInt64Req
type IDsInt64Req struct {
	// IDs
	// Required: true
	Ids []int64 `json:"ids"`
}

// Basic ID request (int64) | 基础ID地址参数请求 (int64)
// swagger:model IDInt64PathReq
type IDInt64PathReq struct {
	// ID
	// Required: true
	Id int64 `path:"id"`
}

// Basic UUID request in path | 基础UUID地址参数请求
// swagger:model UUIDPathReq
type UUIDPathReq struct {
	// ID
	// Required: true
	Id string `path:"id"`
}

// Basic UUID request | 基础UUID参数请求
// swagger:model UUIDReq
type UUIDReq struct {
	// ID
	// required : true
	// max length : 36
	// min length : 36
	Id string `json:"id" validate:"required,len=36"`
}

// Basic UUID array request | 基础UUID数组参数请求
// swagger:model UUIDsReq
type UUIDsReq struct {
	// Ids
	// Required: true
	Ids []string `json:"ids"`
}

// The base ID response data | 基础ID信息
// swagger:model BaseIDInfo
type BaseIDInfo struct {
	// ID
	Id *uint64 `json:"id,optional"`
	// Create date | 创建日期
	CreatedAt *int64 `json:"createdAt,optional"`
	// Update date | 更新日期
	UpdatedAt *int64 `json:"updatedAt,optional"`
}

// The base ID response data (int64) | 基础ID信息 (int64)
// swagger:model BaseIDInt64Info
type BaseIDInt64Info struct {
	// ID
	Id *int64 `json:"id,optional"`
	// Create date | 创建日期
	CreatedAt *int64 `json:"createdAt,optional"`
	// Update date | 更新日期
	UpdatedAt *int64 `json:"updatedAt,optional"`
}

// The base ID response data (int32) | 基础ID信息 (int32)
// swagger:model BaseIDInt32Info
type BaseIDInt32Info struct {
	// ID
	Id *int32 `json:"id,optional"`
	// Create date | 创建日期
	CreatedAt *int64 `json:"createdAt,optional"`
	// Update date | 更新日期
	UpdatedAt *int64 `json:"updatedAt,optional"`
}

// The base ID response data (uint32) | 基础ID信息 (uint32)
// swagger:model BaseIDUint32Info
type BaseIDUint32Info struct {
	// ID
	Id *uint32 `json:"id,optional"`
	// Create date | 创建日期
	CreatedAt *int64 `json:"createdAt,optional"`
	// Update date | 更新日期
	UpdatedAt *int64 `json:"updatedAt,optional"`
}

// The base UUID response data | 基础UUID信息
// swagger:model BaseUUIDInfo
type BaseUUIDInfo struct {
	// ID
	Id *string `json:"id,optional"`
	// Create date | 创建日期
	CreatedAt *int64 `json:"createdAt,optional"`
	// Update date | 更新日期
	UpdatedAt *int64 `json:"updatedAt,optional"`
}

type Condition struct {
	Equal       int      `json:"equal"`
	LabelIdList []uint64 `json:"labelIdList"`
}

type Action struct {
	Type    int    `json:"type"`
	Content string `json:"content"`
	Meta    Meta   `json:"meta,optional"`
}

type Meta struct {
	Filename string `json:"filename,optional"`
}

type ActionForward struct {
	Wxid   string   `json:"wxid"`
	Action []Action `json:"action"`
}

// The response data of server information | Server信息
// swagger:model ServerInfo
type ServerInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 名称
	Name *string `json:"name,optional"`
	// 公网ip
	PublicIp *string `json:"publicIp,optional"`
	// 内网ip
	PrivateIp *string `json:"privateIp,optional"`
	// 管理端口
	AdminPort *string `json:"adminPort,optional"`
}

// The response data of server list | Server列表数据
// swagger:model ServerListResp
type ServerListResp struct {
	BaseDataInfo
	// Server list data | Server列表数据
	Data ServerListInfo `json:"data"`
}

// Server list data | Server列表数据
// swagger:model ServerListInfo
type ServerListInfo struct {
	BaseListInfo
	// The API list data | Server列表数据
	Data []ServerInfo `json:"data"`
}

// Get server list request params | Server列表请求参数
// swagger:model ServerListReq
type ServerListReq struct {
	PageInfo
	// 名称
	Name *string `json:"name,optional"`
	// 公网ip
	PublicIp *string `json:"publicIp,optional"`
	// 内网ip
	PrivateIp *string `json:"privateIp,optional"`
}

// Server information response | Server信息返回体
// swagger:model ServerInfoResp
type ServerInfoResp struct {
	BaseDataInfo
	// Server information | Server数据
	Data ServerInfo `json:"data"`
}

// The response data of wx information | Wx信息
// swagger:model WxInfo
type WxInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 服务器id
	ServerId *uint64 `json:"serverId,optional"`
	// 服务器名称
	ServerName *string `json:"serverName,optional"`
	// 端口号
	Port *string `json:"port,optional"`
	// 进程号
	ProcessId *string `json:"processId,optional"`
	// 回调地址
	Callback *string `json:"callback,optional"`
	// 微信id
	Wxid *string `json:"wxid,optional"`
	// 微信账号
	Account *string `json:"account,optional"`
	// 微信昵称
	Nickname *string `json:"nickname,optional"`
	// 手机号
	Tel *string `json:"tel,optional"`
	// 微信头像
	HeadBig *string `json:"headBig,optional"`
	// 组织ID
	OrganizationId *uint64 `json:"organizationId,optional"`
	// 组织名称
	OrganizationName *string `json:"organizationName,optional"`
	// 模式ID
	AgentId *uint64 `json:"agentId,optional"`
	// 模式信息
	AgentInfo *AgentInfo `json:"agentInfo,optional"`
	// 大模型服务地址
	ApiBase *string `json:"apiBase,optional"`
	// 大模型服务密钥
	ApiKey *string `json:"apiKey,optional"`
	// 白名单
	AllowList []ContactInfo `json:"allowList,optional"`
	// 群白名单
	GroupAllowList []ContactInfo `json:"groupAllowList,optional"`
	// 黑名单
	BlockList []ContactInfo `json:"blockList,optional"`
	// 群黑名单
	GroupBlockList []ContactInfo `json:"groupBlockList,optional"`
	// 使用token总数
	TotalTokens *uint64 `json:"totalTokens,optional"`
	// 使用积分总数
	Credits *float64 `json:"credits,optional"`
	Ctype   *uint64  `json:"ctype,optional"`
}

// swagger:model UpdateBlockAndAllowListReq
type UpdateBlockAndAllowListReq struct {
	BaseIDInfo
	// 白名单
	AllowList []string `json:"allowList,optional"`
	// 群白名单
	GroupAllowList []string `json:"groupAllowList,optional"`
	// 黑名单
	BlockList []string `json:"blockList,optional"`
	// 群黑名单
	GroupBlockList []string `json:"groupBlockList,optional"`
}

// The response data of wx list | Wx列表数据
// swagger:model WxListResp
type WxListResp struct {
	BaseDataInfo
	// Wx list data | Wx列表数据
	Data WxListInfo `json:"data"`
}

// Wx list data | Wx列表数据
// swagger:model WxListInfo
type WxListInfo struct {
	BaseListInfo
	// The API list data | Wx列表数据
	Data []WxInfo `json:"data"`
}

// Get wx list request params | Wx列表请求参数
// swagger:model WxListReq
type WxListReq struct {
	PageInfo
	// 服务器id
	ServerId *uint64 `json:"serverId,optional"`
	// 租户id
	OrganizationId *uint64 `json:"organizationId,optional"`
	// 租户名称
	OrganizationName *string `json:"organizationName,optional"`
	// 端口号
	Port *string `json:"port,optional"`
	// 进程号
	ProcessId *string `json:"processId,optional"`
	// 回调地址
	Callback *string `json:"callback,optional"`
	// 账号类型 1-个微 3-企微
	Ctype *uint64 `json:"ctype,optional"`
}

// Get wx list request params | Wx列表请求参数
// swagger:model WxSelectListReq
type WxSelectListReq struct {
	// 租户id
	OrganizationId *uint64 `json:"organizationId,optional"`
	// 账号类型 1-个微 3-企微
	Ctype *uint64 `json:"ctype,optional"`
}

// The response data of wx list | Wx列表数据
// swagger:model WxSelectListResp
type WxSelectListResp struct {
	BaseDataInfo
	// Wx list data | Wx列表数据
	Data []WxSelectListInfo `json:"data"`
}

// swagger:model WxSelectListInfo
type WxSelectListInfo struct {
	BaseIDInfo
	// 微信id
	Wxid *string `json:"wxid,optional"`
	// 微信昵称
	Nickname *string `json:"nickname,optional"`
	// 内容类型：1-个微 3-企微
	Ctype *uint64 `json:"ctype,optional"`
}

// Wx information response | Wx信息返回体
// swagger:model WxInfoResp
type WxInfoResp struct {
	BaseDataInfo
	// Wx information | Wx数据
	Data WxInfo `json:"data"`
}

// 获取黑白名单列表返回体
// swagger:model AllowBlockListResp
type AllowBlockListResp struct {
	BaseDataInfo
	// Wx information | Wx数据
	Data AllowBlockListRespData `json:"data"`
}

// AllowBlockListRespData
type AllowBlockListRespData struct {
	// 白名单
	AllowList []*AllowBlockData `json:"allowList,optional"`
	// 群白名单
	GroupAllowList []*AllowBlockData `json:"groupAllowList,optional"`
	// 黑名单
	BlockList []*AllowBlockData `json:"blockList,optional"`
	// 群黑名单
	GroupBlockList []*AllowBlockData `json:"groupBlockList,optional"`
}

// AllowBlockData
type AllowBlockData struct {
	// 微信id 公众号微信ID
	Wxid string `json:"wxid,optional"`
	// 微信昵称 群备注名称
	Nickname string `json:"nickname,optional"`
}

// The data of agent information | Agent信息
// swagger:model AgentInfo
type AgentInfo struct {
	BaseIDInfo
	// name | 角色名称
	Name *string `json:"name,optional"`
	// role | 角色设定
	Role *string `json:"role,optional"`
	// status | 状态 1-正常 2-禁用
	Status *int `json:"status,optional"`
	// background | 背景介绍
	Background *string `json:"background,optional"`
	// examples | 对话案例
	Examples     *string `json:"examples,optional"`
	DatasetId    *string `json:"dataset_id,optional"`
	CollectionId *string `json:"collection_id,optional"`
	// model | model
	Model *string `json:"model,optional"`
	// api_base | api_base
	ApiBase *string `json:"api_base,optional"`
	// api_key | api_key
	ApiKey *string `json:"api_key,optional"`
	// type | 类型 1. 内置 2. 接入
	Type *int `json:"type,optional"`
}

// The response data of agent list | Agent列表数据
// swagger:model AgentListResp
type AgentListResp struct {
	BaseDataInfo
	// Agent list data | Agent列表数据
	Data AgentListInfo `json:"data"`
}

// Agent list data | Agent列表数据
// swagger:model AgentListInfo
type AgentListInfo struct {
	BaseListInfo
	// The API list data | Agent列表数据
	Data []AgentInfo `json:"data"`
}

// Get agent list request params | Agent列表请求参数
// swagger:model AgentListReq
type AgentListReq struct {
	PageInfo
	// name | 角色名称
	Name *string `json:"name,optional"`
	// role | 角色设定
	Role *string `json:"role,optional"`
	// background | 背景介绍
	Background *string `json:"background,optional"`
	// status | 状态 1-可用 2-不可用
	Status *int `json:"status,optional"`
	// 租户id
	OrganizationId *uint64 `json:"organizationId,optional"`
	// model | model
	Model *string `json:"model,optional"`
	// api_base | api_base
	ApiBase *string `json:"api_base,optional"`
	// api_key | api_key
	ApiKey *string `json:"api_key,optional"`
	// type | 类型 1. 内置 2. 接入
	Type *int `json:"type,optional"`
}

// Agent information response | Agent信息返回体
// swagger:model AgentInfoResp
type AgentInfoResp struct {
	BaseDataInfo
	// Agent information | Agent数据
	Data AgentInfo `json:"data"`
}

type VectorModel struct {
	Model            *string `json:"model"`
	Name             *string `json:"name"`
	CharsPointsPrice *uint64 `json:"charsPointsPrice"`
	DefaultToken     *uint64 `json:"defaultToken"`
	MaxToken         *uint64 `json:"maxToken"`
	Weight           *uint64 `json:"weight"`
}

type AgentModel struct {
	Model            *string `json:"model"`
	Name             *string `json:"name"`
	MaxContext       *uint64 `json:"maxContext"`
	MaxResponse      *uint64 `json:"maxResponse"`
	CharsPointsPrice *uint64 `json:"charsPointsPrice"`
}

type DatasetId struct {
	ID          *string `json:"id"`
	ParentID    *string `json:"parentId"`
	TeamId      *string `json:"teamId"`
	TmbId       *string `json:"tmbId"`
	Type        *string `json:"type"`
	Status      *string `json:"status"`
	Avatar      *string `json:"avatar"`
	Name        *string `json:"name"`
	VectorModel *string `json:"vectorModel"`
	AgentModel  *string `json:"agentModel"`
	Intro       *string `json:"intro"`
}

// Dataset info | 知识库详情
// swagger:model DatasetInfo
type DatasetInfo struct {
	ID          *string     `json:"id"`
	ParentID    *string     `json:"parentId"`
	TeamId      *string     `json:"teamId"`
	TmbId       *string     `json:"tmbId"`
	Type        *string     `json:"type"`
	Name        *string     `json:"name"`
	Intro       *string     `json:"intro"`
	Status      *string     `json:"status"`
	Avatar      *string     `json:"avatar"`
	VectorModel VectorModel `json:"vectorModel"`
	AgentModel  AgentModel  `json:"agentModel"`
	Permission  *string     `json:"permission"`
	CanWrite    *bool       `json:"canWrite"`
	IsOwner     *bool       `json:"isOwner"`
}

type Index struct {
	DefaultIndex *bool   `json:"defaultIndex"`
	Type         *string `json:"type"`
	DataId       *string `json:"dataId"`
	Text         *string `json:"text"`
	ID           *string `json:"id"`
}

// Collection Info | 集合详情
// swagger:model CollectionInfo
type CollectionInfo struct {
	ID             *string   `json:"id"`
	ParentID       *string   `json:"parentId"`
	TmbId          *string   `json:"tmbId,optional"`
	Type           *string   `json:"type"`
	Name           *string   `json:"name"`
	DataAmount     *uint64   `json:"dataAmount,optional"`
	TrainingAmount *uint64   `json:"trainingAmount,optional"`
	TrainingType   *string   `json:"trainingType,optional"`
	ChunkSize      *uint64   `json:"chunkSize,optional"`
	ChunkSplitter  *string   `json:"chunkSplitter,optional"`
	QaPrompt       *string   `json:"qaPrompt,optional"`
	RawTextLength  *uint64   `json:"rawTextLength,optional"`
	CanWrite       *bool     `json:"canWrite,optional"`
	SourceName     *string   `json:"sourceName,optional"`
	DatasetId      DatasetId `json:"datasetId,optional"`
}

// swagger:model CollectionDetailReq
type CollectionDetailReq struct {
	ID *string `json:"id"`
}

// swagger:model CollectionInfoResp
type CollectionInfoResp struct {
	BaseDataInfo
	Data CollectionInfo `json:"data"`
}

// swagger:model DataDetailReq
type DataDetailReq struct {
	ID *string `json:"id"`
}

// swagger:model DataDetailResp
type DataDetailResp struct {
	BaseDataInfo
	Data DataInfo `json:"data"`
}

// swagger:model CollectionSimpleInfo
type CollectionSimpleInfo struct {
	ID             *string `json:"id"`
	ParentID       *string `json:"parentId"`
	TmbId          *string `json:"tmbId,optional"`
	Type           *string `json:"type"`
	Name           *string `json:"name"`
	DataAmount     *uint64 `json:"dataAmount,optional"`
	TrainingAmount *uint64 `json:"trainingAmount,optional"`
}

// swagger:model DataInfo
type DataInfo struct {
	ID           *string `json:"id"`
	Q            *string `json:"q"`
	A            *string `json:"a"`
	ChunkIndex   *uint64 `json:"chunkIndex"`
	Indexes      []Index `json:"indexes"`
	DatasetId    *string `json:"datasetId"`
	CollectionId *string `json:"collectionId"`
	SourceName   *string `json:"sourceName"`
	CanWrite     *bool   `json:"canWrite"`
	IsOwner      *bool   `json:"isOwner"`
}

// swagger:model DataSimpleInfo
type DataSimpleInfo struct {
	ID           *string `json:"id"`
	Q            *string `json:"q"`
	A            *string `json:"a"`
	ChunkIndex   *uint64 `json:"chunkIndex"`
	DatasetId    *string `json:"datasetId"`
	CollectionId *string `json:"collectionId"`
}

// Get collection list request params | Collection列表请求参数
// swagger:model CollectionListReq
type CollectionListReq struct {
	// required : true
	// min : 0
	PageNum *int `json:"pageNum" validate:"required,number,gt=0"`
	// required : true
	// max : 100000
	PageSize *int `json:"pageSize" validate:"required,number,lt=100000"`
	// required : true
	DatasetId *string `json:"datasetId" validate:"required"`
}

// Collection list response | Collection List信息返回体
// swagger:model CollectionListResp
type CollectionListResp struct {
	BaseDataInfo
	// Agent information | Agent数据
	Data []CollectionSimpleInfo `json:"data"`
	// required : true
	// min : 0
	PageNum *int `json:"pageNum" validate:"required,number,gt=0"`
	// required : true
	// max : 100000
	PageSize *int `json:"pageSize" validate:"required,number,lt=100000"`
	Total    *int `json:"total"`
}

// Get collection list request params | Collection列表请求参数
// swagger:model DataListReq
type DataListReq struct {
	// required : true
	// min : 0
	Page *int `json:"page" validate:"required,number,gt=0"`
	// required : true
	// max : 100000
	PageSize *int `json:"pageSize" validate:"required,number,lt=100000"`
	// required : true
	CollectionId *string `json:"collectionId" validate:"required"`
	Keyword      *string `json:"keyword,optional"`
}

// Data list response | Data List信息返回体
// swagger:model DataListResp
type DataListResp struct {
	BaseDataInfo
	// Agent information | Agent数据
	Data BatchSimpleInfo `json:"data"`
}

// swagger:model BatchSimpleInfo
type BatchSimpleInfo struct {
	BaseListInfo
	// The API list data | BatchMsg列表数据
	Data      []DataSimpleInfo `json:"data"`
	UpdatedAt int64            `json:"updatedAt,optional"`
}

// Data create request | 信息请求体
// swagger:model CreateDataInfoReq
type CreateDataInfoReq struct {
	// required : true
	CollectionId *string `json:"collectionId" validate:"required"`
	// Q
	// required : true
	Q *string `json:"q" validate:"required"`
	// A
	// required : true
	A *string `json:"a" validate:"required"`
}

//	IndexSingle {
//		Text A *string `json:"text"`
//	}
//
// Data create request | 信息返回体
// swagger:model UpdateDataInfoReq
type UpdateDataInfoReq struct {
	// ID
	// required : true
	DataId *string `json:"id" validate:"required"`
	// Q
	// required : true
	Q *string `json:"q" validate:"required"`
	// A
	// required : true
	A *string `json:"a" validate:"required"`
}

// swagger:model DeleteDataReq
type DeleteDataReq struct {
	// required : true
	ID *string `json:"id" validate:"required"`
}

// swagger:model UploadDataReq
type UploadDataReq struct {
	AgentId *string `form:"agentId"`
}

type BatchDeleteIds struct {
	Ids []string `json:"ids"`
}

// ContactLabelList | Contact标签列表
type ContactLabelList struct {
	// label
	Label *string `json:"label,optional"`
	// value
	Value *uint64 `json:"value,optional"`
}

// The response data of contact information | Contact信息
// swagger:model ContactInfo
type ContactInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 属主微信id
	WxWxid *string `json:"wxWxid,optional"`
	// 属主微信昵称
	WxWxidNickname *string `json:"wxWxidNickname,optional"`
	// 联系人类型：1好友，2群组，3公众号，4企业微信联系人
	Type *int `json:"type,optional"`
	// 微信id 公众号微信ID
	Wxid *string `json:"wxid,optional"`
	// 微信账号
	Account *string `json:"account,optional"`
	// 微信昵称 群备注名称
	Nickname *string `json:"nickname,optional"`
	// 备注名
	Markname *string `json:"markname,optional"`
	// 头像
	Headimg *string `json:"headimg,optional"`
	// 性别 0未知 1男 2女
	Sex *int `json:"sex,optional"`
	// 星标 65/67=星标 1/3=未星标
	Starrole *string `json:"starrole,optional"`
	// 不让他看我的朋友圈 0可以看 1不让看
	Dontseeit *int `json:"dontseeit,optional"`
	// 不看他的朋友圈 0可以看 1不看 1=开启了不看他 128/129=仅聊天
	Dontseeme *int `json:"dontseeme,optional"`
	// 所属标签id清单，多开会用逗号隔开
	Lag *string `json:"lag,optional"`
	// 群组id
	Gid *string `json:"gid,optional"`
	// 群组名称
	Gname *string `json:"gname,optional"`
	// v3数据
	V3 *string `json:"v3,optional"`
	// Label Relationships | 标签关系
	LabelRelationships []ContactLabelList `json:"labelRelationships,optional"`
	// 组织ID
	OrganizationId *uint64 `json:"organizationId,optional"`
	// 是否在黑名单中
	IsInBlockList *bool                  `json:"isInBlockList,optional"`
	Ctype         *uint64                `json:"ctype,optional"`
	Cname         *string                `json:"cname,optional"`
	Cage          *int                   `json:"cage,optional"`
	Carea         *string                `json:"carea,optional"`
	Cbirthday     *string                `json:"cbirthday,optional"`
	Cbirtharea    *string                `json:"cbirtharea,optional"`
	CidcardNo     *string                `json:"cidcardNo,optional"`
	Ctitle        *string                `json:"ctitle,optional"`
	Cc            *string                `json:"cc,optional"`
	Phone         *string                `json:"phone,optional"`
	CustomFields  []ContactFieldTemplate `json:"customFields,optional"`
}

// The response data of label information | Label信息
// swagger:model LabelInfo
type LabelInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 标签类型：1好友，2群组，3公众号，4企业微信联系人
	Type *int `json:"type,optional"`
	// 标签名称
	Name *string `json:"name,optional"`
	// 标签来源：1后台创建 2个微同步
	From *int `json:"from,optional"`
	// 标签模式：1动态 2静态
	Mode *int `json:"mode,optional"`
	// 标签的触达条件
	Conditions *string `json:"conditions,optional"`
	// 组织ID
	OrganizationId *uint64 `json:"organizationId,optional"`
	// Label Relationships | 标签关系
	LabelRelationships []LabelRelationshipInfo `json:"labelRelationships,optional"`
}

// The response data of label relationship information | LabelRelationship信息
// swagger:model LabelRelationshipInfo
type LabelRelationshipInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 标签 ID
	LabelId *uint64 `json:"labelId,optional"`
	// 联系人 ID
	ContactId *uint64 `json:"contactId,optional"`
	// Contact information | 联系人信息
	Contact ContactInfo `json:"contact,optional"`
	// Label information | 标签信息
	Label LabelInfo `json:"label,optional"`
	// 组织ID
	OrganizationId *uint64 `json:"organizationId,optional"`
}

// The response data of label relationship information | LabelRelationship信息
// swagger:model LabelRelationshipsInfo
type LabelRelationshipsInfo struct {
	BaseIDInfo
	// 更新类型：为空或“all”时表示全量更新，为 “add” 时表示仅追加
	UpdateType *string `json:"updateType,optional"`
	// 标签 ID
	LabelIds []uint64 `json:"labelIds,optional"`
	// 联系人 ID
	ContactId *uint64 `json:"contactId,optional"`
}

// swagger:model BatchLabelRelationshipsInfo
type BatchLabelRelationshipsInfo struct {
	// 更新类型：为1 时表示增加标签，为 -1 时表示移除标签
	UpdateType int `json:"updateType,optional"`
	// 标签 ID
	LabelIds []uint64 `json:"labelIds,optional"`
	// 联系人 ID
	ContactIds []uint64 `json:"contactIds,optional"`
}

// The response data of label relationship list | LabelRelationship列表数据
// swagger:model LabelRelationshipListResp
type LabelRelationshipListResp struct {
	BaseDataInfo
	// LabelRelationship list data | LabelRelationship列表数据
	Data LabelRelationshipListInfo `json:"data"`
}

// LabelRelationship list data | LabelRelationship列表数据
// swagger:model LabelRelationshipListInfo
type LabelRelationshipListInfo struct {
	BaseListInfo
	// The API list data | LabelRelationship列表数据
	Data []ContactInfo `json:"data"`
}

// Get label relationship list request params | LabelRelationship列表请求参数
// swagger:model LabelRelationshipListReq
type LabelRelationshipListReq struct {
	PageInfo
	// 内容类型：1-个微 3-企微
	Ctype *uint64 `json:"ctype,optional"`
	// 属主微信id
	WxWxid *string `json:"wxWxid,optional"`
	// 联系人类型：1好友，2群组，3公众号，4企业微信联系人
	Type *int `json:"type,optional"`
	// 微信id 公众号微信ID
	Wxid *string `json:"wxid,optional"`
	// 昵称
	Nickname *string `json:"nickname,optional"`
	// Label ID list | 标签ID列表
	LabelIDs []uint64 `json:"labelIDs,optional"`
	//标签搜索开始结束日期
	SearchDate []*string `json:"date,optional"`
}

// LabelRelationship information response | LabelRelationship信息返回体
// swagger:model LabelRelationshipInfoResp
type LabelRelationshipInfoResp struct {
	BaseDataInfo
	// LabelRelationship information | LabelRelationship数据
	Data LabelRelationshipInfo `json:"data"`
}

type ContactFieldTemplateOptions struct {
	Label *string `json:"label,optional"`
	Value *string `json:"value,optional"`
}

type ContactFieldTemplate struct {
	Type    *string                       `json:"type,optional"`
	Id      *string                       `json:"id,optional"`
	Label   *string                       `json:"label,optional"`
	Options []ContactFieldTemplateOptions `json:"options,optional"`
	Value   []string                      `json:"value,optional"`
}

// swagger:model ContactFieldTemplateInfo
type ContactFieldTemplateInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 组织ID
	OrganizationId *uint64                `json:"organizationId,optional"`
	Template       []ContactFieldTemplate `json:"template,optional"`
}

// Contact information response | Contact信息返回体
// swagger:model ContactFieldTemplateInfoResp
type ContactFieldTemplateInfoResp struct {
	BaseDataInfo
	// Contact information | Contact数据
	Data []ContactFieldTemplate `json:"data"`
}

type LoginQRStatus struct {
	// 登陆二维码
	QRCode string `json:"qRCode,optional"`
	// 登陆二维码状态
	Status string `json:"status,optional"`
	// 登陆二维码状态描述
	StatusDesc string `json:"statusDesc,optional"`
}

// 刷新登陆二维码请求参数
// swagger:model RefreshLoginQRReq
type RefreshLoginQRReq struct {
	// 服务器id
	ServerId *uint64 `json:"serverId,optional"`
	// 端口号
	Port *string `json:"port,optional"`
	// 回调地址
	Callback *string `json:"callback,optional"`
}

// 刷新登陆二维码返回参数
// swagger:model RefreshLoginQRResp
type RefreshLoginQRResp struct {
	BaseDataInfo
	// 二维码Base64
	Data LoginQRStatus `json:"data,optional"`
}

// 发送微信文本消息请求参数
// swagger:model SendTextMsgReq
type SendTextMsgReq struct {
	// 属主微信id
	WxWxid *string `json:"senderWxId"`
	// 微信id 公众号微信ID
	Wxid *string `json:"receiverWxId"`
	// 微信文本消息内容
	Msg   *string `json:"msg"`
	Ctype *uint64 `json:"ctype,optional"`
}

// 发送微信图片消息请求参数
// swagger:model SendPicMsgReq
type SendPicMsgReq struct {
	// 属主微信id
	WxWxid *string `json:"wxWxid"`
	// 微信id 公众号微信ID
	Wxid *string `json:"wxid"`
	// 微信图片路径（本地或网络，本地需要上传操作，如：C:\\x.jpg）
	Picpath *string `json:"picpath"`
	// 微信图片自定义名称（此属性只有网络图片有）
	Diyfilename *string `json:"diyfilename,optional"`
}

// 发送微信图片（本地）请求参数
// swagger:model SendPicMsgLocalReq
type SendPicMsgLocalReq struct {
	// 属主微信id
	WxWxid *string `json:"wxWxid"`
	// 微信id 公众号微信ID
	Wxid *string `json:"wxid"`
	// 微信图片路径（本地或网络，本地需要上传操作，如：C:\\x.jpg）
	Picpath *string `json:"picpath"`
}

// The response data of contact list | Contact列表数据
// swagger:model ContactListResp
type ContactListResp struct {
	BaseDataInfo
	// Contact list data | Contact列表数据
	Data ContactListInfo `json:"data"`
}

// Contact list data | Contact列表数据
// swagger:model ContactListInfo
type ContactListInfo struct {
	BaseListInfo
	// The API list data | Contact列表数据
	Data []ContactInfo `json:"data"`
}

// swagger:model ContactSimpleListResp
type ContactSimpleListResp struct {
	BaseDataInfo
	// Contact list data | Contact列表数据
	Data ContactSimpleListInfo `json:"data"`
}

// swagger:model ContactSimpleListInfo
type ContactSimpleListInfo struct {
	BaseListInfo
	// The API list data | Contact列表数据
	Data []ContactSimpleInfo `json:"data"`
}

// swagger:model ContactSimpleInfo
type ContactSimpleInfo struct {
	// 微信id 公众号微信ID
	Wxid *string `json:"wxid,optional"`
	// 微信昵称 群备注名称
	Nickname *string `json:"nickname,optional"`
}

// Get contact list request params | Contact列表请求参数
// swagger:model ContactListReq
type ContactListReq struct {
	PageInfo
	// Label ID list | 标签ID列表
	LabelIDs []uint64 `json:"labelIDs,optional"`
	// 属主微信id
	WxWxid *string `json:"wxWxid,optional"`
	// 微信id 公众号微信ID
	Wxid *string `json:"wxid,optional"`
	// 微信账号
	Account *string `json:"account,optional"`
	// 昵称
	Nickname *string `json:"nickname,optional"`
	// 备注
	Markname *string `json:"markname,optional"`
	// 联系人类型：1好友，2群组，3公众号，4企业微信联系人
	Type *int `json:"type,optional"`
	// 内容类型：1-个微 3-企微
	Ctype *uint64 `json:"ctype,optional"`
	//标签搜索开始结束日期
	SearchDate []*string `json:"date,optional"`
	Status     *uint8    `json:"status,optional"`
}

// Contact information response | Contact信息返回体
// swagger:model ContactInfoResp
type ContactInfoResp struct {
	BaseDataInfo
	// Contact information | Contact数据
	Data ContactInfo `json:"data"`
}

// swagger:model AddNewFriendReq
type AddNewFriendReq struct {
	OwnerWxid string `json:"ownerWxid"`
	Wxid      string `json:"wxid"`
	Gid       string `json:"gid"`
	Desc      string `json:"desc"`
	AddType   string `json:"addType"`
}

// swagger:model changeBlockListReq
type ChangeBlockListReq struct {
	OwnerWxid string `json:"ownerWxid"`
	Wxid      string `json:"wxid"`
	Type      *int   `json:"type,optional"`
	Ai        *bool  `json:"ai,optional"`
}

// swagger:model ImportWhatsappContactReq
type ImportWhatsappContactReq struct {
	File *string `form:"file,optional"`
}

// swagger:model WhatsappContactListReq
type WhatsappContactListReq struct {
	PageInfo
	// 标签ID列表
	LabelIDs []uint64 `json:"labelIDs,optional"`
	// 电话
	Phone *string `json:"phone,optional"`
	// 名称
	Name *string `json:"name,optional"`
}

// swagger:model CreateWhatsappContactReq
type CreateWhatsappContactReq struct {
	BaseIDInfo
	// 国家区号
	Cc    *string `json:"cc"`
	Phone *string `json:"phone"`
	// 备注名
	Markname   *string `json:"markname,optional"`
	Ctype      *uint64 `json:"ctype,optional"`
	Cname      *string `json:"cname,optional"`
	Sex        *int    `json:"sex,optional"`
	Cage       *int    `json:"cage,optional"`
	Carea      *string `json:"carea,optional"`
	Cbirthday  *string `json:"cbirthday,optional"`
	Cbirtharea *string `json:"cbirtharea,optional"`
	CidcardNo  *string `json:"cidcardNo,optional"`
	Ctitle     *string `json:"ctitle,optional"`
}

// swagger:model AnalyzeContactFieldReq
type AnalyzeContactFieldReq struct {
	WxWxid *string `json:"wxWxid,optional"`
	Wxid   *string `json:"wxid,optional"`
}

// swagger:model AnalyzeContactFieldResp
type AnalyzeContactFieldResp struct {
	CustomFields []ContactFieldTemplate `json:"customFields,optional"`
}

// The response data of message information | Message信息
// swagger:model MessageInfo
type MessageInfo struct {
	BaseIDInfo
	// 属主微信id
	WxWxid *string `json:"wxWxid"`
	// 微信id 公众号微信ID
	Wxid *string `json:"wxid"`
	// 微信消息内容
	Msg *string `json:"msg"`
}

// The response data of message list | Message列表数据
// swagger:model MessageListResp
type MessageListResp struct {
	BaseDataInfo
	// Message list data | Message列表数据
	Data MessageListInfo `json:"data"`
}

// Message list data | Message列表数据
// swagger:model MessageListInfo
type MessageListInfo struct {
	BaseListInfo
	// The API list data | Message列表数据
	Data []MessageInfo `json:"data"`
}

// Get message list request params | Message列表请求参数
// swagger:model MessageListReq
type MessageListReq struct {
	PageInfo
	// 属主微信id
	WxWxid *string `json:"wxWxid,optional"`
	// 微信id 公众号微信ID
	Wxid *string `json:"wxid,optional"`
}

// Message information response | Message信息返回体
// swagger:model MessageInfoResp
type MessageInfoResp struct {
	BaseDataInfo
	// Message information | Message数据
	Data MessageInfo `json:"data"`
}

// The response data of label list | Label列表数据
// swagger:model LabelSelectListResp
type LabelSelectListResp struct {
	BaseDataInfo
	// Label list data | Label列表数据
	Data []LabelSelectListInfo `json:"data"`
}

// The response data of label list | Label群发列表数据
// swagger:model LabelBatchSelectListResp
type LabelBatchSelectListResp struct {
	BaseDataInfo
	// Label list data | Label列表数据
	Data LabelBatchSelectListData `json:"data"`
}

// The response data of label list | Label群发列表数据
type LabelBatchSelectListData struct {
	Contact []LabelSelectListInfo `json:"contact"`
	Group   []LabelSelectListInfo `json:"group"`
}

// The response data of label list | Label列表数据
// swagger:model LabelListResp
type LabelListResp struct {
	BaseDataInfo
	// Label list data | Label列表数据
	Data LabelListInfo `json:"data"`
}

// Label list data | Label列表数据
// swagger:model LabelListInfo
type LabelListInfo struct {
	BaseListInfo
	// The API list data | Label列表数据
	Data []LabelInfo `json:"data"`
}

// Get label list request params | Label列表请求参数
// swagger:model LabelListReq
type LabelListReq struct {
	PageInfo
	// Label ID list | Label ID列表
	LabelIDs []uint64 `json:"labelIDs,optional"`
	// 标签类型：1好友，2群组，3公众号，4企业微信联系人
	Type *int `json:"type,optional"`
	// 标签名称
	Name *string `json:"name,optional"`
	// 标签来源：1后台创建 2个微同步
	From *int `json:"from,optional"`
	// 标签模式：1动态 2静态
	Mode *int `json:"mode,optional"`
}

// Label information response | Label信息返回体
// swagger:model LabelInfoResp
type LabelInfoResp struct {
	BaseDataInfo
	// Label information | Label数据
	Data LabelInfo `json:"data"`
}

// swagger:model LabelSelectListInfo
type LabelSelectListInfo struct {
	// label
	Label *string `json:"label,optional"`
	// value
	Value *uint64 `json:"value,optional"`
}

// swagger:model labelImportReq
type LabelImportReq struct {
	// required : true
	// min : 0
	Type *int `json:"type,optional" validate:"required,gt=0"`
	// Label information | Label数据
	// required : true
	Content string `json:"content,optional" validate:"required"`
}

// swagger:model LabelImportResp
type LabelImportResp struct {
	BaseDataInfo
	Data LabelImportInfo `json:"data"`
}

// swagger:model LabelImportInfo
type LabelImportInfo struct {
	Inserted int `json:"inserted"` // 插入成功的标签
	Existed  int `json:"existed"`  // 已存在的标签
	Failed   int `json:"failed"`   // 插入失败的标签（预留）
}

// The data of label tagging information | LabelTagging信息
// swagger:model LabelTaggingInfo
type LabelTaggingInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 机构 ID
	OrganizationId *uint64 `json:"organizationId,optional"`
	// 标签类型：1好友，2群组，3公众号，4企业微信联系人
	Type *int `json:"type,optional"`
	// 关键词
	Conditions string `json:"conditions,optional"`
	// 命中后需要打的标签
	ActionLabelAdd []uint64 `json:"actionLabelAdd,optional"`
	// 命中后需要移除的标签
	ActionLabelDel []uint64 `json:"actionLabelDel,optional"`
	LabelAddInfo   []string `json:"labelAddInfo,optional"`
}

// The response data of label tagging list | LabelTagging信息列表数据
// swagger:model LabelTaggingListResp
type LabelTaggingListResp struct {
	BaseDataInfo
	// The label tagging list data | LabelTagging信息列表数据
	Data LabelTaggingListInfo `json:"data"`
}

// The label tagging list data | LabelTagging信息列表数据
// swagger:model LabelTaggingListInfo
type LabelTaggingListInfo struct {
	BaseListInfo
	// The label tagging list data | LabelTagging信息列表数据
	Data []LabelTaggingInfo `json:"data"`
}

// Get label tagging list request params | LabelTagging信息列表请求参数
// swagger:model LabelTaggingListReq
type LabelTaggingListReq struct {
	PageInfo
}

// The label tagging information response | LabelTagging信息返回体
// swagger:model LabelTaggingInfoResp
type LabelTaggingInfoResp struct {
	BaseDataInfo
	// label tagging information | LabelTagging信息数据
	Data LabelTaggingInfo `json:"data"`
}

// The response data of sop task list | SopTask列表数据
// swagger:model SopTaskListResp
type SopTaskListResp struct {
	BaseDataInfo
	// SopTask list data | SopTask列表数据
	Data SopTaskListInfo `json:"data"`
}

// The response data of sop task record list | SopTask列表数据
// swagger:model SopTaskRecordListResp
type SopTaskRecordListResp struct {
	BaseDataInfo
	// SopTask list data | SopTask列表数据
	Data []SopTaskRecordInfo `json:"data"`
}

// SopTask list data | SopTask列表数据
// swagger:model SopTaskRecordInfo
type SopTaskRecordInfo struct {
	// NodeId 节点ID
	SourceType *int `json:"sourceType,optional"`
	// NodeId 节点ID
	SourceId *uint64 `json:"sourceId,optional"`
	// 节点名称
	Name *string `json:"name,optional"`
	// 消息总数
	TotalCount *int64 `json:"totalCount,optional"`
	// 成功数
	SuccessCount *int64 `json:"successCount,optional"`
	// 失败数
	FailureCount *int64 `json:"failureCount,optional"`
	// 成功率
	SuccessRate *int64 `json:"successRate,optional"`
}

// SopTask list data | SopTask列表数据
// swagger:model SopTaskListInfo
type SopTaskListInfo struct {
	BaseListInfo
	// The API list data | SopTask列表数据
	Data []SopTaskInfo `json:"data"`
}

// Get sop task list request params | SopTask列表请求参数
// swagger:model SopTaskListReq
type SopTaskListReq struct {
	PageInfo
	// SOP 任务名称
	Name   *string `json:"name,optional"`
	Status *uint8  `json:"status,optional"`
}

// SopTask information response | SopTask信息返回体
// swagger:model SopTaskInfoResp
type SopTaskInfoResp struct {
	BaseDataInfo
	// SopTask information | SopTask数据
	Data SopTaskInfo `json:"data"`
}

// SopTask create response | SopTask创建回体
// swagger:model SopTaskCreateResp
type SopTaskCreateResp struct {
	BaseDataInfo
	// SopTask id | SopTask id
	Data uint64 `json:"data"`
}

// swagger:model CopyReq
type CopyReq struct {
	// SopTask id | SopTask id
	Id uint64 `json:"id"`
	// SOP 任务名称
	Name *string `json:"name,optional"`
	// Organization id | Organization id
	OrganizationId uint64 `json:"organizationId,optional"`
}

// swagger:model MessageVarResp
type MessageVarResp struct {
	BaseDataInfo
	Data MessageVarRespData `json:"data"`
}

type MessageVarRespData struct {
	// 消息变量
	MessageVar []MessageVarInfo `json:"messageVar"`
	// 转发变量
	ForwardVar []MessageVarInfo `json:"forwardVar"`
}

// swagger:model MessageVarInfo
type MessageVarInfo struct {
	// 显示名称
	Label string `json:"label"`
	// 变量
	Value string `json:"value"`
}

// swagger:model SopTaskOutlineResp
type SopTaskOutlineResp struct {
	BaseDataInfo
	Data []SopTaskOutlineInfo `json:"data"`
}

// swagger:model SopTaskOutlineInfo
type SopTaskOutlineInfo struct {
	// 标题
	Title string `json:"title,optional"`
	// key
	Key string `json:"key,optional"`
	// 子节点
	Children []SopTaskOutlineInfo `json:"children,optional"`
}

// swagger:model TestNodeReq
type TestNodeReq struct {
	Type    int    `json:"type"`
	Id      uint64 `json:"id"`
	Content string `json:"content"`
}

// swagger:model TestNodeResp
type TestNodeResp struct {
	BaseDataInfo
	Data []string `json:"data"`
}

// swagger:model SopApiListReq
type SopApiListReq struct {
	// required : true
	// min : 0
	Page uint64 `json:"page" validate:"required,number,gt=0"`
	// required : true
	// max : 2000
	PageSize uint64 `json:"pageSize" validate:"required,number,lt=2000"`
}

// swagger:model GenerateAiAnswerReq
type GenerateAiAnswerReq struct {
	Content string `json:"content"`
}

// swagger:model GenerateAiAnswerResp
type GenerateAiAnswerResp struct {
	BaseDataInfo
	Data string `json:"data"`
}

// swagger:model GetBotByTaskIdReq
type GetBotByTaskIdReq struct {
	// required : true
	// min : 0
	TaskId int `json:"taskId" validate:"required,number,gt=0"`
}

type BotList struct {
	Wxid     string `json:"wxid"`
	Nickname string `json:"nickname"`
}

// swagger:model GetBotByTaskIdResp
type GetBotByTaskIdResp struct {
	BaseDataInfo
	Data []BotList `json:"data"`
}

// The response data of sop stage information | SopStage信息
// swagger:model SopStageInfo
type SopStageInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// SOP 任务 ID
	TaskId *uint64 `json:"taskId,optional"`
	// 阶段名称
	Name *string `json:"name,optional"`
	// 客群筛选条件类型  1 按标签筛选 2 按客户基本信息筛选
	ConditionType *int `json:"conditionType,optional"`
	// 筛选条件关系  1 满足所有条件（and） 2 满足任意条件（or）
	ConditionOperator *int `json:"conditionOperator,optional"`
	// 筛选条件列表
	ConditionList []Condition `json:"conditionList,optional"`
	// 命中后发送的消息内容
	ActionMessage []Action `json:"actionMessage,optional"`
	// 命中后需要打的标签
	ActionLabelAdd []uint64 `json:"actionLabelAdd,optional"`
	// 命中后需要移除的标签
	ActionLabelDel []uint64 `json:"actionLabelDel,optional"`
	// 命中后转发的消息内容
	ActionForward *ActionForward `json:"actionForward,optional"`
	// 阶段顺序
	IndexSort *int `json:"indexSort,optional"`
	// sop 任务信息
	TaskInfo *SopTaskInfo `json:"taskInfo,optional"`
	// node 信息
	NodeList []SopNodeInfo `json:"nodeList,optional"`
}

// The response data of sop task information | SopTask信息
// swagger:model SopTaskInfo
type SopTaskInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// SOP 任务名称
	Name *string `json:"name,optional"`
	// 机器人微信 id 列表
	BotWxidList []string `json:"botWxidList,optional"`
	// 标签类型：1好友，2群组，3企业微信联系人
	Type *int `json:"type,optional"`
	// 任务计划开始时间
	PlanStartTime *int64 `json:"planStartTime,optional"`
	// 任务计划结束时间
	PlanEndTime *int64 `json:"planEndTime,optional"`
	// 创建者 id
	CreatorId *string `json:"creatorId,optional"`
	// 阶段信息
	StageList []SopStageInfo `json:"stageList,optional"`
	// 组织ID
	OrganizationId *uint64 `json:"organizationId,optional"`
	// Token
	Token []string `json:"token,optional"`
}

// The response data of sop node information | SopNode信息
// swagger:model SopNodeInfo
type SopNodeInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 阶段 ID
	StageId *uint64 `json:"stageId,optional"`
	// 父节点 ID
	ParentId *uint64 `json:"parentId,optional"`
	// 节点名称
	Name *string `json:"name,optional"`
	// 触发条件类型 1 客户回复后触发 2 超时后触发
	ConditionType *int `json:"conditionType,optional"`
	// 触发语义列表 当为空时则代表用户回复任意内容后触发
	ConditionList []string `json:"conditionList,optional"`
	// 超时触发时间（分钟）
	NoReplyCondition *uint64 `json:"noReplyCondition,optional"`
	// 超时触发时间单位
	NoReplyUnit *string `json:"noReplyUnit,optional"`
	// 命中后发送的消息内容
	ActionMessage []Action `json:"actionMessage,optional"`
	// 命中后需要打的标签
	ActionLabelAdd []uint64 `json:"actionLabelAdd,optional"`
	// 命中后需要移除的标签
	ActionLabelDel []uint64 `json:"actionLabelDel,optional"`
	// 命中后转发的消息内容
	ActionForward *ActionForward `json:"actionForward,optional"`
	// 阶段信息
	StageInfo *SopStageInfo `json:"stageInfo,optional"`
}

// The response data of sop node information | SopNode信息
type SopNodeInfoWithLable struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 阶段 ID
	StageId *uint64 `json:"stageId,optional"`
	// 父节点 ID
	ParentId *uint64 `json:"parentId,optional"`
	// 节点名称
	Name *string `json:"name,optional"`
	// 触发条件类型 1 客户回复后触发 2 超时后触发
	ConditionType *int `json:"conditionType,optional"`
	// 触发语义列表 当为空时则代表用户回复任意内容后触发
	ConditionList []string `json:"conditionList,optional"`
	// 超时触发时间（分钟）
	NoReplyCondition *uint64 `json:"noReplyCondition,optional"`
	// 超时触发时间单位
	NoReplyUnit *string `json:"noReplyUnit,optional"`
	// 命中后发送的消息内容
	ActionMessage []Action `json:"actionMessage,optional"`
	// 命中后需要打的标签
	ActionLabelAdd []uint64 `json:"actionLabelAdd,optional"`
	// 命中后需要移除的标签
	ActionLabelDel []uint64 `json:"actionLabelDel,optional"`
	// 命中后转发的消息内容
	ActionForward      *ActionForward `json:"actionForward,optional"`
	ActionLabelAddList []string       `json:"actionLabelAddList"`
	ActionLabelDelList []string       `json:"actionLabelDelList"`
}

// The response data of sop stage list | SopStage列表数据
// swagger:model SopStageListResp
type SopStageListResp struct {
	BaseDataInfo
	// SopStage list data | SopStage列表数据
	Data SopStageListInfo `json:"data"`
}

// SopStage list data | SopStage列表数据
// swagger:model SopStageListInfo
type SopStageListInfo struct {
	BaseListInfo
	// The API list data | SopStage列表数据
	Data []SopStageInfo `json:"data"`
}

// Get sop stage list request params | SopStage列表请求参数
// swagger:model SopStageListReq
type SopStageListReq struct {
	TaskId *uint64 `json:"taskId"`
}

// Batch get sop stage list request params | SopStage列表请求参数
// swagger:model BatchSopStageListReq
type BatchSopStageListReq struct {
	TaskIds []uint64 `json:"taskIds"`
}

// SopStage information response | SopStage信息返回体
// swagger:model SopStageInfoResp
type SopStageInfoResp struct {
	BaseDataInfo
	// SopStage information | SopStage数据
	Data SopStageInfo `json:"data"`
}

// SopStage create response | SopStage创建回体
// swagger:model SopStageCreateResp
type SopStageCreateResp struct {
	BaseDataInfo
	// SopStage id | SopStage id
	Data uint64 `json:"data"`
}

// Move sop stage request params | 移动阶段请求参数
// swagger:model SopStageMoveReq
type SopStageMoveReq struct {
	BaseIDInfo
	// 阶段名称
	Offset *int `json:"offset,optional"`
}

// swagger:model StageCopyReq
type StageCopyReq struct {
	// SopStage id | SopStage id
	Id uint64 `json:"id"`
}

// The response data of sop node list | SopNode列表数据
// swagger:model SopNodeListResp
type SopNodeListResp struct {
	BaseDataInfo
	// SopNode list data | SopNode列表数据
	Data []*SopChildNodeInfo `json:"data"`
}

// The response data of sop node list | SopNode列表数据
type SopNodeListResp2 struct {
	BaseDataInfo
	// SopNode list data | SopNode列表数据
	Data []*SopNodeInfoWithLable `json:"data"`
}

// SopNode list data | SopNode列表数据
// swagger:model SopChildNodeInfo
type SopChildNodeInfo struct {
	NodeName  *string           `json:"nodeName,optional"`
	ChildNode *SopChildNodeInfo `json:"childNode,optional"`
	// The API list data | SopNode列表数据
	ConditionNodes []*SopChildNodeInfo `json:"conditionNodes"`
	SopNodeInfo
}

// SopNode list data | SopNode列表数据
// swagger:model SopNodeListInfo
type SopNodeListInfo struct {
	BaseListInfo
	// The API list data | SopNode列表数据
	Data []SopNodeInfo `json:"data"`
}

// Get sop node list request params | SopNode列表请求参数
// swagger:model SopNodeListReq
type SopNodeListReq struct {
	StageId *uint64 `json:"stageId"`
}

// Get sop node list request params | SopNode列表请求参数
// swagger:model BatchSopNodeListReq
type BatchSopNodeListReq struct {
	StageIds []uint64 `json:"stageIds"`
}

// SopNode information response | SopNode信息返回体
// swagger:model SopNodeInfoResp
type SopNodeInfoResp struct {
	BaseDataInfo
	// SopNode information | SopNode数据
	Data SopNodeInfo `json:"data"`
}

// SopNode create response | SopNode创建返回体
// swagger:model SopNodeCreateResp
type SopNodeCreateResp struct {
	BaseDataInfo
	// SopNode id | SopNode id
	Data uint64 `json:"data"`
}

// The response data of message records information | MessageRecords信息
// swagger:model MessageRecordsInfo
type MessageRecordsInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 机器人微信 id
	BotWxid *string `json:"botWxid,optional"`
	// 联系人 id
	ContactId *uint64 `json:"contactId,optional"`
	// 类型：1好友，2群组，3企业微信联系人
	ContactType *int `json:"contactType,optional"`
	// 接收方微信 id
	ContactWxid *string `json:"contactWxid,optional"`
	// 内容类型 1 文本 2 文件
	ContentType *int `json:"contentType,optional"`
	// 发送内容
	Content *string `json:"content,optional"`
	// 元数据
	Meta *Meta `json:"meta,optional"`
	// 异常原因
	ErrorDetail *string `json:"errorDetail,optional"`
	// 发送时间
	SendTime *int64 `json:"sendTime,optional"`
	// 源类型 1 点发 2 群发 3 SOP
	SourceType *int `json:"sourceType,optional"`
	// 源 ID
	SourceId *uint64 `json:"sourceId,optional"`
	// 次源 ID
	SubSourceId *uint64 `json:"subSourceId,optional"`
	// 组织ID
	OrganizationId *uint64 `json:"organizationId,optional"`
}

// The response data of message records list | MessageRecords列表数据
// swagger:model MessageRecordsListResp
type MessageRecordsListResp struct {
	BaseDataInfo
	// MessageRecords list data | MessageRecords列表数据
	Data MessageRecordsListInfo `json:"data"`
}

// MessageRecords list data | MessageRecords列表数据
// swagger:model MessageRecordsListInfo
type MessageRecordsListInfo struct {
	BaseListInfo
	// The API list data | MessageRecords列表数据
	Data []MessageRecordsInfo `json:"data"`
}

// Get message records list request params | MessageRecords列表请求参数
// swagger:model MessageRecordsListReq
type MessageRecordsListReq struct {
	PageInfo
	// 群发消息ID
	BatchMsgId *uint64 `json:"batchMsgId,optional"`
	// 机器人微信 id
	BotWxid *string `json:"botWxid,optional"`
	// 消息类型：源类型 1 点发 2 群发 3 SOP 阶段 4 SOP 节点
	SourceType *int `json:"sourceType,optional"`
	// 消息源ID：
	SourceId *uint64 `json:"sourceId,optional"`
	// 接收方微信 id
	ContactWxid *string `json:"contactWxid,optional"`
	// 发送内容
	Status *uint8 `json:"status,optional"`
}

// MessageRecords information response | MessageRecords信息返回体
// swagger:model MessageRecordsInfoResp
type MessageRecordsInfoResp struct {
	BaseDataInfo
	// MessageRecords information | MessageRecords数据
	Data MessageRecordsInfo `json:"data"`
}

// The response data of chatroom member information | ChatroomMember信息
// swagger:model ChatroomMemberInfo
type ChatroomMemberInfo struct {
	// 名称
	Wxid *string `json:"wxid,optional"`
	// 群组
	ChatRoom *string `json:"chatRoom,optional"`
	// 属主Wxid
	OwnerWxid *string `json:"ownerWxid,optional"`
	// 账号
	Account *string `json:"account,optional"`
}

// The response data of chatroom member list | ChatroomMember列表数据
// swagger:model ChatroomMemberListResp
type ChatroomMemberListResp struct {
	BaseDataInfo
	// chatroom member list data | chatroom member 列表数据
	Data ChatroomMemberListInfo `json:"data"`
}

// chatroom member list data | chatroom member列表数据
// swagger:model ChatroomMemberListInfo
type ChatroomMemberListInfo struct {
	BaseListInfo
	// The API list data | chatroom member列表数据
	Data []ChatroomMemberInfo `json:"data"`
}

// Get chatroom member list request params | ChatroomMember列表请求参数
// swagger:model ChatroomMemberListReq
type ChatroomMemberListReq struct {
	PageInfo
	// 属主Wxid
	OwnerWxid *string `json:"ownerWxid,optional"`
	// 群组
	ChatRoom *string `json:"chatRoom,optional"`
}

// chatroom member information response | ChatroomMember信息返回体
// swagger:model ChatroomMemberInfoResp
type ChatroomMemberInfoResp struct {
	BaseDataInfo
	// Server information | Server数据
	Data ChatroomMemberInfo `json:"data"`
}

// The response data of user information | 用户信息
// swagger:model UserInfo
type UserInfo struct {
	BaseUUIDInfo
	// Status | 状态
	// max : 20
	Status *uint32 `json:"status,optional" validate:"omitempty,lt=20"`
	// Username | 用户名
	// max length : 50
	Username *string `json:"username,optional" validate:"omitempty,max=50"`
	// Nickname | 昵称
	// max length : 40
	Nickname *string `json:"nickname,optional" validate:"omitempty,max=40"`
	// Password | 密码
	// min length : 6
	Password *string `json:"password,optional" validate:"omitempty,min=6"`
	// Description | 描述
	// max length : 100
	Description *string `json:"description,optional" validate:"omitempty,max=100"`
	// HomePath | 首页
	// max length : 70
	HomePath *string `json:"homePath,optional" validate:"omitempty,max=70"`
	// RoleId | 角色ID
	RoleIds []uint64 `json:"roleIds,optional"`
	// Mobile | 手机号
	// max length : 18
	Mobile *string `json:"mobile,optional" validate:"omitempty,max=18"`
	// Email | 邮箱
	// max length : 80
	Email *string `json:"email,optional" validate:"omitempty,max=80"`
	// Avatar | 头像地址
	// max length : 300
	Avatar *string `json:"avatar,optional" validate:"omitempty,max=300"`
	// Department ID | 部门ID
	DepartmentId *uint64 `json:"departmentId,optional,omitempty"`
	// Position ID | 职位ID
	PositionIds []uint64 `json:"positionId,optional,omitempty"`
}

// User information response | 用户信息返回体
// swagger:model UserInfoResp
type UserInfoResp struct {
	BaseDataInfo
	// User information | User数据
	Data UserInfo `json:"data"`
}

// The response data of user's basic information | 用户基本信息返回数据
// swagger:model UserBaseIDInfoResp
type UserBaseIDInfoResp struct {
	BaseDataInfo
	// The  data of user's basic information | 用户基本信息
	Data UserBaseIDInfo `json:"data"`
}

// The  data of user's basic information | 用户基本信息
// swagger:model UserBaseIDInfo
type UserBaseIDInfo struct {
	// User's UUID | 用户的UUID
	UUID *string `json:"userId"`
	// User's name | 用户名
	Username *string `json:"username"`
	// User's nickname | 用户的昵称
	Nickname *string `json:"nickname"`
	// The user's avatar path | 用户的头像路径
	Avatar *string `json:"avatar"`
	// The home page that the user enters after logging in | 用户登陆后进入的首页
	HomePath *string `json:"homePath"`
	// The description of user | 用户的描述信息
	Description *string `json:"desc"`
	// User's Role Name | 用户的角色名称
	RoleName []string `json:"roleName"`
	// Department Name | 部门名称
	DepartmentName string `json:"departmentName,optional"`
	// Department Name | 部门备注
	DepartmentRemark string `json:"departmentRemark,optional"`
}

// swagger:model UserLoginReq
type UserLoginReq struct {
	JsCode *string `json:"js_code,optional"`
}

// swagger:model UserLoginResp
type UserLoginResp struct {
	BaseDataInfo
	Data UserToken `json:"data,optional"`
}

// swagger:model GptsUserLoginReq
type GptsUserLoginReq struct {
	Username *string `json:"username"`
	Password *string `json:"password"`
}

// swagger:model GptsUserLoginResp
type GptsUserLoginResp struct {
	BaseDataInfo
	Data GptsUserToken `json:"data,optional"`
}

type GptsUserToken struct {
	ID         string `json:"id,optional"`
	Token      string `json:"token,optional"`
	Username   string `json:"username,optional"`
	ExpireTime uint64 `json:"expireTime,optional"`
}

// swagger:model PasswordReq
type PasswordReq struct {
	Password  *string `json:"password"`
	Password2 *string `json:"password2"`
}

type UserToken struct {
	Token    *string `json:"token,optional"`
	ID       *uint64 `json:"id,optional"`
	Avatar   *string `json:"avatar,optional"`
	Nickname *string `json:"nickname,optional"`
	IsVip    *bool   `json:"isVip,optional"`
}

// swagger:model UserVipResp
type UserVipResp struct {
	BaseDataInfo
	Data UserVip `json:"data,optional"`
}

type UserVip struct {
	IsVip         *bool   `json:"isVip,optional"`
	WechatAccount *string `json:"wechatAccount"`
}

// swagger:model UserBalanceResp
type UserBalanceResp struct {
	BaseDataInfo
	// User information | User数据
	Data BalanceInfo `json:"data"`
}

// swagger:model BalanceInfo
type BalanceInfo struct {
	Balance *float64 `json:"balance"`
}

// swagger:model WxidReq
type WxidReq struct {
	Wxid string `json:"wxid"`
}

// add_friend_by_phone api接口请求值
// swagger:model AddFriendByPhoneReq
type AddFriendByPhoneReq struct {
	Type        int      `json:"type,options=1|3,default=1"`
	WeChatIds   []string `json:"wechat_ids,optional,omitempty"`
	Phones      []string `json:"phones"`
	Message     string   `json:"message"`
	CallbackURL string   `json:"callback_url,optional"`
}

// swagger:model NullReq
type NullReq struct {
}

// 以下是API请求类型
// swagger:model CompApiReq
type CompApiReq struct {
	CompCtlReq
	StdCompApiReq
	FastGptSpecReq
}

// FastGpt Completions请求信息
// swagger:model FastGptApiReq
type FastGptApiReq struct {
	StdCompApiReq
	FastGptSpecReq
}

// 标准Completions请求信息
// swagger:model StdCompApiReq
type StdCompApiReq struct {
	//model,like 'gpt-4o'
	Model string `json:"model,optional"`
	//Message list
	Messages []StdCompMessage `json:"messages"`
	//Stream 是否流式输出
	Stream bool `json:"stream,default=false"`
	//格式化输出定义
	ResponseFormat interface{} `json:"response_format,omitempty"`
}

// 关于工作流配置的请求信息
// swagger:model CompCtlReq
type CompCtlReq struct {
	//EventType事件类型
	EventType string `json:"event_type,default=fastgpt"`
	//WorkId工作流ID
	WorkId string `json:"work_id,optional,omitempty"`
	//IsBatch 是同步还是异步，默认及取值false表明同步
	IsBatch bool `json:"is_batch,default=false"`
	//异步回调地址
	Callback string `json:"callback,optional,omitempty"`
}

// swagger:model FastGptSpecReq
type FastGptSpecReq struct {
	//ChatId
	ChatId string `json:"chat_id,optional,omitempty"`
	//FastgptChatId
	FastgptChatId string `json:"chatId,optional,omitempty"`
	//ResponseChatItemId
	ResponseChatItemId string `json:"response_chat_item_id,optional,omitempty"`
	//Detail 详情开关
	Detail bool `json:"detail,default=false"`
	//Variables
	Variables map[string]string `json:"variables,optional,omitempty"`
}

type StdCompMessage struct {
	Role    string      `json:"role"`
	Content interface{} `json:"content"`
}

// 以下是API响应类型
// swagger:model CompOpenApiResp
type CompOpenApiResp struct {
	StdCompApiResp
	FastgptSpecResp
	FastgptErrResp
}

// swagger:model StdCompApiResp
type StdCompApiResp struct {
	// A unique identifier for the chat completion.
	ID string `json:"id"`
	// A list of chat completion choices. Can be more than one if `n` is greater
	// than 1.
	Choices []ChatCompletionChoice `json:"choices"`
	// The Unix timestamp (in seconds) of when the chat completion was created.
	Created int64 `json:"created"`
	// The model used for the chat completion.
	Model string `json:"model"`
	// The object type, which is always `chat.completion`.
	Object string `json:"object"`
	// The service tier used for processing the request.
	ServiceTier string `json:"service_tier,omitempty"`
	// This fingerprint represents the backend configuration that the model runs with.
	//
	// Can be used in conjunction with the `seed` request parameter to understand when
	// backend changes have been made that might impact determinism.
	SystemFingerprint string `json:"system_fingerprint"`
	// Usage statistics for the completion request.
	Usage CompletionUsage `json:"usage,omitempty"`
}

// swagger:model FastgptSpecResp
type FastgptSpecResp struct {
	ResponseData []map[string]interface{} `json:"responseData,omitempty"`
	NewVariables map[string]interface{}   `json:"newVariables,omitempty"`
}

// swagger:model FastgptErrResp
type FastgptErrResp struct {
	FgtErrCode      *int    `json:"code,omitempty"`
	FgtErrStatusTxt *string `json:"statusText,omitempty"`
	FgtErrMessage   *string `json:"message,omitempty"`
}

// swagger:model DeepseekErrResp
type DeepseekErrResp struct {
	DSErr DeepseekErrInfo `json:"error,omitempty"`
}

// swagger:model DeepseekErrInfo
type DeepseekErrInfo struct {
	Message string      `json:"message,omitempty"`
	Type    string      `json:"type,omitempty"`
	Code    string      `json:"code,omitempty"`
	Param   interface{} `json:"param,omitempty"`
}

type ChatCompletionAudio struct {
	// Unique identifier for this audio response.
	ID string `json:"id"`
}

type ChatCompletionMessage struct {
	// The contents of the message.
	Content string `json:"content"`
	//The contents of the reasoning message
	ReasoningContent string `json:"reasoning_content,omitempty"`
	// The refusal message generated by the model.
	Refusal string `json:"refusal"`
	// The role of the author of this message.
	Role string `json:"role"`
	// If the audio output modality is requested, this object contains data about the
	// audio response from the model.
	// [Learn more](https://platform.openai.com/docs/guides/audio).
	Audio ChatCompletionAudio `json:"audio,omitempty"`
}

type ChatCompletionChoice struct {
	// The reason the model stopped generating tokens. This will be `stop` if the model
	// hit a natural stop point or a provided stop sequence, `length` if the maximum
	// number of tokens specified in the request was reached, `content_filter` if
	// content was omitted due to a flag from our content filters, `tool_calls` if the
	// model called a tool, or `function_call` (deprecated) if the model called a
	// function.
	FinishReason string `json:"finish_reason"`
	// The index of the choice in the list of choices.
	Index int64 `json:"index"`
	// A chat completion message generated by the model.
	Message ChatCompletionMessage `json:"message,omitempty"`
	// A chat completion message generated by the model stream mode.
	Delta ChatCompletionMessage `json:"delta,omitempty"`
	//
	Logprobs string `json:"logprobs"`
}

type CompletionUsageCompletionTokensDetails struct {
	// When using Predicted Outputs, the number of tokens in the prediction that
	// appeared in the completion.
	AcceptedPredictionTokens int64 `json:"accepted_prediction_tokens"`
	// Audio input tokens generated by the model.
	AudioTokens int64 `json:"audio_tokens"`
	// Tokens generated by the model for reasoning.
	ReasoningTokens int64 `json:"reasoning_tokens"`
	// When using Predicted Outputs, the number of tokens in the prediction that did
	// not appear in the completion. However, like reasoning tokens, these tokens are
	// still counted in the total completion tokens for purposes of billing, output,
	// and context window limits.
	RejectedPredictionTokens int64 `json:"rejected_prediction_tokens"`
}

type CompletionUsagePromptTokensDetails struct {
	// Audio input tokens present in the prompt.
	AudioTokens int64 `json:"audio_tokens"`
	// Cached tokens present in the prompt.
	CachedTokens int64 `json:"cached_tokens"`
}

type CompletionUsage struct {
	// Number of tokens in the generated completion.
	CompletionTokens int64 `json:"completion_tokens,required"`
	// Number of tokens in the prompt.
	PromptTokens int64 `json:"prompt_tokens,required"`
	// Total number of tokens used in the request (prompt + completion).
	TotalTokens int64 `json:"total_tokens,required"`
	// Breakdown of tokens used in a completion.
	CompletionTokensDetails CompletionUsageCompletionTokensDetails `json:"completion_tokens_details"`
	// Breakdown of tokens used in the prompt.
	PromptTokensDetails CompletionUsagePromptTokensDetails `json:"prompt_tokens_details"`
}

// The data of batch msg information | BatchMsg信息
// swagger:model BatchMsgInfo
type BatchMsgInfo struct {
	BaseIDInfo
	// 状态 0 未开始 1 开始发送 2 发送完成 3 发送中止
	Status *uint8 `json:"status,optional"`
	// 批次号
	BatchNo *string `json:"batchNo,optional"`
	// 任务名称
	TaskName *string `json:"taskName,optional"`
	// 发送方微信ID
	Fromwxid *string `json:"fromwxid,optional"`
	// 发送方微信称呼
	FromName *string `json:"fromName,optional"`
	// 内容
	Msg *string `json:"msg,optional"`
	// 发送规则 all 全部 tag1,tag2 按tag发送
	Tag *string `json:"tag,optional"`
	// 总数
	Total *int32 `json:"total,optional"`
	// 成功数量
	Success *int32 `json:"success,optional"`
	// 失败数量
	Fail *int32 `json:"fail,optional"`
	// 开始时间
	StartTime    *int64  `json:"startTime,optional"`
	StartTimeStr *string `json:"startTimeStr,optional"`
	// 结束时间
	StopTime *int64 `json:"stopTime,optional"`
	// 发送时间
	SendTime *int64 `json:"sendTime,optional"`
	// 标签列表
	Labels      []uint64 `json:"labels,optional"`
	GroupLabels []uint64 `json:"groupLabels,optional"`
	// 标签列表
	Type *int32 `json:"type,optional"`
	// 内容类型：1-微信 2-whatsapp 3-企微
	Ctype        *uint64 `json:"ctype,optional"`
	Cc           *string `json:"cc,optional"`
	Phone        *string `json:"phone,optional"`
	TemplateCode *string `json:"templateCode,optional"`
	TemplateName *string `json:"templateName,optional"`
	Lang         *string `json:"lang,optional"`
}

// The response data of batch msg list | BatchMsg列表数据
// swagger:model BatchMsgListResp
type BatchMsgListResp struct {
	BaseDataInfo
	// BatchMsg list data | BatchMsg列表数据
	Data BatchMsgListInfo `json:"data"`
}

// BatchMsg list data | BatchMsg列表数据
// swagger:model BatchMsgListInfo
type BatchMsgListInfo struct {
	BaseListInfo
	// The API list data | BatchMsg列表数据
	Data []BatchMsgInfo `json:"data"`
}

// Get batch msg list request params | BatchMsg列表请求参数
// swagger:model BatchMsgListReq
type BatchMsgListReq struct {
	PageInfo
	// 批次号
	BatchNo *string `json:"batchNo,optional"`
	// 发送方微信ID
	Fromwxid *string `json:"fromwxid,optional"`
	// 内容
	Msg *string `json:"msg,optional"`
	// 任务名称
	TaskName *string `json:"taskName,optional"`
	// 群发类型
	Type *int32 `json:"type"`
	// 内容类型：1-个微 3-企微
	Ctype *uint64 `json:"ctype,optional"`
}

// BatchMsg information response | BatchMsg信息返回体
// swagger:model BatchMsgInfoResp
type BatchMsgInfoResp struct {
	BaseDataInfo
	// BatchMsg information | BatchMsg数据
	Data BatchMsgInfo `json:"data"`
}

// swagger:model WhatsappBatchMsgListReq
type WhatsappBatchMsgListReq struct {
	PageInfo
	// 批次号
	BatchNo *string `json:"batchNo,optional"`
	// 发送方微信ID
	Phone *string `json:"phone,optional"`
	// 内容
	Msg *string `json:"msg,optional"`
}

// swagger:model WhatsappBatchMsgHistoryReq
type WhatsappBatchMsgHistoryReq struct {
	PageInfo
	IDReq
	Status *uint8  `json:"status,optional"`
	Phone  *string `json:"phone,optional"`
}

// swagger:model WhatsappBatchMsgHistoryResp
type WhatsappBatchMsgHistoryResp struct {
	BaseDataInfo
	Data HistoryListInfo `json:"data"`
}

// swagger:model HistoryListInfo
type HistoryListInfo struct {
	BaseListInfo
	Data []HistoryInfo `json:"data"`
}

// swagger:model HistoryInfo
type HistoryInfo struct {
	Index    *uint64 `json:"index,optional"`
	From     *string `json:"from,optional"`
	To       *string `json:"to,optional"`
	SendTime *int64  `json:"sendTime,optional"`
	BatchNo  *string `json:"batchNo,optional"`
	Cc       *string `json:"cc,optional"`
	Phone    *string `json:"phone,optional"`
	Status   *uint8  `json:"status,optional"`
}

// swagger:model SendMsgReq
type SendMsgReq struct {
	Phone        *string `json:"phone"`
	To           *string `json:"to"`
	Lang         *string `json:"lang"`
	TemplateCode *string `json:"templateCode"`
}

// The data of msg information | Msg信息
// swagger:model MsgInfo
type MsgInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 发送方微信ID
	Fromwxid *string `json:"fromwxid,optional"`
	// 接收人微信ID/群ID
	Toid *string `json:"toid,optional"`
	// 消息类型
	Msgtype *int32 `json:"msgtype,optional"`
	// 消息
	Msg *string `json:"msg,optional"`
	// 批次号
	BatchNo *string `json:"batchNo,optional"`
}

// The response data of msg list | Msg列表数据
// swagger:model MsgListResp
type MsgListResp struct {
	BaseDataInfo
	// Msg list data | Msg列表数据
	Data MsgListInfo `json:"data"`
}

// Msg list data | Msg列表数据
// swagger:model MsgListInfo
type MsgListInfo struct {
	BaseListInfo
	// The API list data | Msg列表数据
	Data []MsgInfo `json:"data"`
}

// Get msg list request params | Msg列表请求参数
// swagger:model MsgListReq
type MsgListReq struct {
	PageInfo
	// 状态
	Status *uint8 `json:"status,optional"`
	// 接收人微信ID/群ID
	Toid *string `json:"toid,optional"`
	// 群发消息ID
	BatchId *uint64 `json:"batchId"`
}

// Msg information response | Msg信息返回体
// swagger:model MsgInfoResp
type MsgInfoResp struct {
	BaseDataInfo
	// Msg information | Msg数据
	Data MsgInfo `json:"data"`
}

// The data of employee information | Employee信息
// swagger:model EmployeeInfo
type EmployeeInfo struct {
	BaseIDInfo
	// title | 标题
	Title *string `json:"title,optional"`
	// avatar | 头像
	Avatar *string `json:"avatar,optional"`
	// tags | 个人标签
	Tags *string `json:"tags,optional"`
	// hire_count | 被雇佣次数
	HireCount *int `json:"hireCount,optional"`
	// service_count | 已服务次数
	ServiceCount *int `json:"serviceCount,optional"`
	// achievement_count | 业绩单数
	AchievementCount *int `json:"achievementCount,optional"`
	// category_id | 分类ID
	CategoryId *uint64 `json:"categoryId,optional"`
	// intro | 个人介绍
	Intro *string `json:"intro,optional"`
	// estimate | 自我评价
	Estimate *string `json:"estimate,optional"`
	// skill | 技能卡
	Skill *string `json:"skill,optional"`
	// ability_type | 能力类型
	AbilityType *string `json:"abilityType,optional"`
	// scene | 使用场景
	Scene     *string              `json:"scene,optional"`
	SceneList []EmployeeConfigInfo `json:"sceneList,optional"`
	// switch_in | 支持介入
	SwitchIn     *string              `json:"switchIn,optional"`
	SwitchInList []EmployeeConfigInfo `json:"switchInList,optional"`
	Tutorial     []TutorialInfo       `json:"tutorial,optional"`
	// video_url | 视频地址
	VideoUrl *string `json:"videoUrl,optional"`
	// work_experience | 工作经验
	WorkExperience []WorkExperienceInfo `json:"workExperience,optional"`
	ApiBase        *string              `json:"apiBase,optional"`
	ApiKey         *string              `json:"apiKey,optional"`
	// AI信息
	AiInfo   *string `json:"aiInfo,optional"`
	ShowChat *bool   `json:"showChat,optional"`
	IsVip    *bool   `json:"isVip,optional"`
	ChatUrl  *string `json:"chatUrl,optional"`
}

// The response data of employee list | Employee列表数据
// swagger:model EmployeeListResp
type EmployeeListResp struct {
	BaseDataInfo
	// Employee list data | Employee列表数据
	Data EmployeeListInfo `json:"data"`
}

// Employee list data | Employee列表数据
// swagger:model EmployeeListInfo
type EmployeeListInfo struct {
	BaseListInfo
	// The API list data | Employee列表数据
	Data []EmployeeInfo `json:"data"`
}

// Get employee list request params | Employee列表请求参数
// swagger:model EmployeeListReq
type EmployeeListReq struct {
	PageInfo
	// title | 标题
	Title *string `json:"title,optional"`
	// tags | 个人标签
	Tags *string `json:"tags,optional"`
	// category_id | 分类ID
	CategoryId *uint64 `json:"categoryId,optional"`
}

// Employee information response | Employee信息返回体
// swagger:model EmployeeInfoResp
type EmployeeInfoResp struct {
	BaseDataInfo
	// Employee information | Employee数据
	Data EmployeeInfo `json:"data"`
}

// swagger:model AuthReq
type AuthReq struct {
	Token *string `json:"token,optional"`
	Data  uint64  `json:"data,optional"`
}

// swagger:model AuthResp
type AuthResp struct {
	Token     *string     `json:"token,optional"`
	Data      *uint64     `json:"data,optional"`
	Original  interface{} `json:"original,optional"`
	OK        interface{} `json:"ok,optional"`
	SecretKey string      `json:"secretKey,optional"`
}

// The data of work experience information | WorkExperience信息
// swagger:model WorkExperienceInfo
type WorkExperienceInfo struct {
	BaseIDInfo
	// employee_id | 员工ID
	EmployeeId *uint64 `json:"employeeId,optional"`
	// start_date | 开始时间
	StartDate    *int64  `json:"startDate,optional"`
	StartDateStr *string `json:"startDateStr,optional"`
	// end_date | 结束时间
	EndDate    *int64  `json:"endDate,optional"`
	EndDateStr *string `json:"endDateStr,optional"`
	// company | 公司名
	Company *string `json:"company,optional"`
	// experience | 工作内容
	Experience *string `json:"experience,optional"`
}

// The response data of work experience list | WorkExperience列表数据
// swagger:model WorkExperienceListResp
type WorkExperienceListResp struct {
	BaseDataInfo
	// WorkExperience list data | WorkExperience列表数据
	Data WorkExperienceListInfo `json:"data"`
}

// WorkExperience list data | WorkExperience列表数据
// swagger:model WorkExperienceListInfo
type WorkExperienceListInfo struct {
	BaseListInfo
	// The API list data | WorkExperience列表数据
	Data []WorkExperienceInfo `json:"data"`
}

// Get work experience list request params | WorkExperience列表请求参数
// swagger:model WorkExperienceListReq
type WorkExperienceListReq struct {
	PageInfo
	// company | 公司名
	Company *string `json:"company,optional"`
}

// WorkExperience information response | WorkExperience信息返回体
// swagger:model WorkExperienceInfoResp
type WorkExperienceInfoResp struct {
	BaseDataInfo
	// WorkExperience information | WorkExperience数据
	Data WorkExperienceInfo `json:"data"`
}

// The data of tutorial information | Tutorial信息
// swagger:model TutorialInfo
type TutorialInfo struct {
	BaseIDInfo
	// employee_id | 员工ID
	EmployeeId *uint64 `json:"employeeId,optional"`
	// index | 序号
	Index *int `json:"index,optional"`
	// title | 标题
	Title *string `json:"title,optional"`
	// content | 内容
	Content *string `json:"content,optional"`
}

// The response data of tutorial list | Tutorial列表数据
// swagger:model TutorialListResp
type TutorialListResp struct {
	BaseDataInfo
	// Tutorial list data | Tutorial列表数据
	Data TutorialListInfo `json:"data"`
}

// Tutorial list data | Tutorial列表数据
// swagger:model TutorialListInfo
type TutorialListInfo struct {
	BaseListInfo
	// The API list data | Tutorial列表数据
	Data []TutorialInfo `json:"data"`
}

// Get tutorial list request params | Tutorial列表请求参数
// swagger:model TutorialListReq
type TutorialListReq struct {
	PageInfo
	// title | 标题
	Title *string `json:"title,optional"`
	// content | 内容
	Content *string `json:"content,optional"`
}

// Tutorial information response | Tutorial信息返回体
// swagger:model TutorialInfoResp
type TutorialInfoResp struct {
	BaseDataInfo
	// Tutorial information | Tutorial数据
	Data TutorialInfo `json:"data"`
}

// The data of employee config information | EmployeeConfig信息
// swagger:model EmployeeConfigInfo
type EmployeeConfigInfo struct {
	BaseIDInfo
	// 类型：scene-场景 switch_in-接入方式
	Stype *string `json:"stype,optional"`
	// 标题
	Title *string `json:"title,optional"`
	// 图片地址
	Photo *string `json:"photo,optional"`
}

// EmployeeConfig list data | EmployeeConfig列表数据
// swagger:model EmployeeConfigListInfo
type EmployeeConfigListInfo struct {
	BaseListInfo
	// The API list data | EmployeeConfig列表数据
	Data []EmployeeConfigInfo `json:"data"`
}

// Employee config response | Employee配置信息返回体
// swagger:model EmployeeConfigListReq
type EmployeeConfigListReq struct {
	/// 类型：scene-场景 switch_in-接入方式
	Stype *string `json:"stype,optional"`
}

// EmployeeConfig information response | EmployeeConfig信息返回体
type EmployeeConfig struct {
	Scene    []EmployeeConfigInfo `json:"scene"`
	SwitchIn []EmployeeConfigInfo `json:"switchIn"`
}

// Employee config response | Employee配置信息返回体
// swagger:model EmployeeConfigListResp
type EmployeeConfigListResp struct {
	BaseDataInfo
	// Employee information | Employee数据
	Data EmployeeConfig `json:"data"`
}

// The data of token information | Token信息
// swagger:model TokenInfo
type TokenInfo struct {
	BaseIDInfo
	// 过期时间
	ExpireAt    *int64  `json:"expireAt,optional"`
	ExpireAtStr *string `json:"expireAtStr,optional"`
	// Token
	Token *string `json:"token,optional"`
	// Mac地址
	Mac *string `json:"mac,optional"`
	// 租户ID
	OrganizationId   *uint64    `json:"organization_id,optional"`
	OrganizationName *string    `json:"organizationName,optional"`
	AgentId          *uint64    `json:"agent_id,optional"`
	AgentInfo        *AgentInfo `json:"agent_info,optional"`
	CustomAgentBase  *string    `json:"custom_agent_base,optional"`
	CustomAgentKey   *string    `json:"custom_agent_key,optional"`
	OpenaiBase       *string    `json:"openai_base,optional"`
	OpenaiKey        *string    `json:"openai_key,optional"`
}

// The response data of token list | Token列表数据
// swagger:model TokenListResp
type TokenListResp struct {
	BaseDataInfo
	// Token list data | Token列表数据
	Data TokenListInfo `json:"data"`
}

// Token list data | Token列表数据
// swagger:model TokenListInfo
type TokenListInfo struct {
	BaseListInfo
	// The API list data | Token列表数据
	Data []TokenInfo `json:"data"`
}

// Get token list request params | Token列表请求参数
// swagger:model TokenListReq
type TokenListReq struct {
	PageInfo
	// Token
	Token *string `json:"token,optional"`
	// Mac地址
	Mac              *string `json:"mac,optional"`
	OrganizationId   *uint64 `json:"organization_id,optional"`
	OrganizationName *string `json:"organizationName,optional"`
}

// Token information response | Token信息返回体
// swagger:model TokenInfoResp
type TokenInfoResp struct {
	BaseDataInfo
	// Token information | Token数据
	Data TokenInfo `json:"data"`
}

// swagger:model CheckTokenReq
type CheckTokenReq struct {
	// Token
	Token *string `json:"token"`
	// Mac地址
	Mac *string `json:"mac"`
}

// swagger:model CheckTokenResp
type CheckTokenResp struct {
	// 是否合法
	Valid *bool `json:"valid"`
	// Sign 签名内容
	Sign *string `json:"sign"`
	// Timestamp 时间戳
	Timestamp       *int64     `json:"timestamp"`
	AgentInfo       *AgentInfo `json:"agent_info"`
	CustomAgentBase *string    `json:"custom_agent_base"`
	CustomAgentKey  *string    `json:"custom_agent_key"`
	OpenaiBase      *string    `json:"openai_base"`
	OpenaiKey       *string    `json:"openai_key"`
	DatasetBase     *string    `json:"dataset_base"`
	DatasetKey      *string    `json:"dataset_key"`
}

// The data of category information | Category信息
// swagger:model CategoryInfo
type CategoryInfo struct {
	BaseIDInfo
	// name | 角色名称
	Name *string `json:"name,optional"`
	// organization_id | 租户ID
	OrganizationId *uint64 `json:"organizationId,optional"`
}

// The response data of category list | Category列表数据
// swagger:model CategoryListResp
type CategoryListResp struct {
	BaseDataInfo
	// Category list data | Category列表数据
	Data CategoryListInfo `json:"data"`
}

// Category list data | Category列表数据
// swagger:model CategoryListInfo
type CategoryListInfo struct {
	BaseListInfo
	// The API list data | Category列表数据
	Data []CategoryInfo `json:"data"`
}

// Get category list request params | Category列表请求参数
// swagger:model CategoryListReq
type CategoryListReq struct {
	PageInfo
	// name | 角色名称
	Name *string `json:"name,optional"`
}

// Category information response | Category信息返回体
// swagger:model CategoryInfoResp
type CategoryInfoResp struct {
	BaseDataInfo
	// Category information | Category数据
	Data CategoryInfo `json:"data"`
}

// The data of agent base information | AgentBase信息
// swagger:model AgentBaseInfo
type AgentBaseInfo struct {
	Id *string `json:"id,optional"`
}

// The response data of agent base list | AgentBase列表数据
// swagger:model AgentBaseListResp
type AgentBaseListResp struct {
	BaseDataInfo
	// AgentBase list data | AgentBase列表数据
	Data AgentBaseListInfo `json:"data"`
}

// AgentBase list data | AgentBase列表数据
// swagger:model AgentBaseListInfo
type AgentBaseListInfo struct {
	BaseListInfo
	// The API list data | AgentBase列表数据
	Data []AgentBaseInfo `json:"data"`
}

// Get agent base list request params | AgentBase列表请求参数
// swagger:model AgentBaseListReq
type AgentBaseListReq struct {
	PageInfo
	// q
	Q *string `json:"q,optional"`
	// a
	A *string `json:"a,optional"`
	// dataset_id
	DatasetId *string `json:"datasetId,optional"`
}

// AgentBase information response | AgentBase信息返回体
// swagger:model AgentBaseInfoResp
type AgentBaseInfoResp struct {
	BaseDataInfo
	// AgentBase information | AgentBase数据
	Data AgentBaseInfo `json:"data"`
}

// The data of chat records information | ChatRecords信息
// swagger:model ChatRecordsInfo
type ChatRecordsInfo struct {
	BaseIDInfo
	// 内容
	Content *string `json:"content,optional"`
	// 内容类型：1-提问 2-回答
	ContentType *uint8 `json:"contentType,optional"`
	// 角色类型：1-用户 2-智能体
	RoleType *string `json:"roleType,optional"`
	// 会话ID
	SessionId *uint64 `json:"sessionId,optional"`
	// 用户ID
	UserId *uint64 `json:"userId,optional"`
	// 聊天ID
	BotId *uint64 `json:"botId,optional"`
	// 类型:1-微信 2-小程序card 3-智能体
	BotType *uint8 `json:"botType,optional,options=1|2|3"`
	Finish  bool   `json:"finish,optional"`
}

// The response data of chat records list | ChatRecords列表数据
// swagger:model ChatRecordsListResp
type ChatRecordsListResp struct {
	BaseDataInfo
	// ChatRecords list data | ChatRecords列表数据
	Data ChatRecordsListInfo `json:"data"`
}

// ChatRecords list data | ChatRecords列表数据
// swagger:model ChatRecordsListInfo
type ChatRecordsListInfo struct {
	BaseListInfo
	// The API list data | ChatRecords列表数据
	Data []ChatRecordsInfo `json:"data"`
}

// Get chat records list request params | ChatRecords列表请求参数
// swagger:model ChatRecordsListReq
type ChatRecordsListReq struct {
	PageInfo
	SessionId *uint64 `json:"sessionId"`
	BotId     *uint64 `json:"botId,optional"`
	BotType   *uint8  `json:"botType,optional"`
}

// ChatRecords information response | ChatRecords信息返回体
// swagger:model ChatRecordsInfoResp
type ChatRecordsInfoResp struct {
	BaseDataInfo
	// ChatRecords information | ChatRecords数据
	Data ChatRecordsInfo `json:"data"`
}

// swagger:model ChatRecommendReq
type ChatRecommendReq struct {
	SessionId *uint64 `json:"sessionId"`
}

// swagger:model ChatRecommendResp
type ChatRecommendResp struct {
	BaseDataInfo
	// The API list data | ChatRecords列表数据
	Data ChatRecommend `json:"data"`
}

type ChatRecommend struct {
	Data      []string `json:"data"`
	SessionId uint64   `json:"sessionId"`
}

// swagger:model ChatAskReq
type ChatAskReq struct {
	CardId    *uint64 `json:"cardId"`
	Question  *string `json:"question"`
	SessionId *int    `json:"sessionId"`
}

// swagger:model ChatAskResp
type ChatAskResp struct {
	BaseDataInfo
	Data *string `json:"data"`
}

// swagger:model GptChatReq
type GptChatReq struct {
	ConversationId *string `json:"conversationId,optional"`
	Content        *string `json:"content"`
	AgentId        *uint64 `json:"agentId"`
}

// swagger:model GptMessageReq
type GptMessageReq struct {
	ConversationId *string `json:"conversationId,optional"`
	FirstId        *string `json:"firstId,optional"`
	Limit          *int    `json:"limit"`
	AgentId        *uint64 `json:"agentId"`
}

// swagger:model GptMessageResp
type GptMessageResp struct {
	BaseDataInfo
	Data GptMessageList `json:"data"`
}

type GptMessageList struct {
	HasMore bool      `json:"hasMore"`
	Data    []Message `json:"data"`
}

type Message struct {
	Id             *string     `json:"id"`
	ConversationId *string     `json:"conversationId,optional"`
	Query          *string     `json:"query"`
	Answer         *string     `json:"answer"`
	Inputs         interface{} `json:"inputs"`
	CreatedAt      *int        `json:"createdAt"`
}

// swagger:model GptsSessionReq
type GptsSessionReq struct {
	Limit   *int    `json:"limit"`
	LastId  *string `json:"lastId,optional"`
	AgentId *uint64 `json:"agentId"`
}

// swagger:model GptsSessionResp
type GptsSessionResp struct {
	BaseDataInfo
	Data GptsSessionList `json:"data"`
}

type GptsSessionList struct {
	HasMore bool      `json:"hasMore"`
	Data    []Session `json:"data"`
}

type Session struct {
	Id        *string     `json:"id"`
	Name      *string     `json:"name"`
	CreatedAt *int        `json:"createdAt"`
	Inputs    interface{} `json:"inputs"`
}

// swagger:model GptsDeleteSessionReq
type GptsDeleteSessionReq struct {
	AgentId        *uint64 `json:"agentId"`
	ConversationId *string `json:"conversationId"`
}

// swagger:model GptsRenameSessionReq
type GptsRenameSessionReq struct {
	AgentId        *uint64 `json:"agentId"`
	ConversationId *string `json:"conversationId"`
	Name           *string `json:"name"`
}

// The data of chat session information | ChatSession信息
// swagger:model ChatSessionInfo
type ChatSessionInfo struct {
	BaseIDInfo
	// 名称
	Name *string `json:"name,optional"`
	// 用户ID
	UserId   *uint64 `json:"userId,optional"`
	UserName *string `json:"userName,optional"`
	// 聊天ID
	BotId *uint64 `json:"botId,optional"`
	// 主体名称
	BotName *string `json:"botName,optional"`
	// 类型:1-微信 2-小程序card 3-智能体
	BotType *uint8 `json:"botType,optional"`
	// 类型:1-微信 2-小程序card 3-智能体
	BotTypeStr *string `json:"botTypeStr,optional"`
}

// The response data of chat session list | ChatSession列表数据
// swagger:model ChatSessionListResp
type ChatSessionListResp struct {
	BaseDataInfo
	// ChatSession list data | ChatSession列表数据
	Data ChatSessionListInfo `json:"data"`
}

// ChatSession list data | ChatSession列表数据
// swagger:model ChatSessionListInfo
type ChatSessionListInfo struct {
	BaseListInfo
	// The API list data | ChatSession列表数据
	Data []ChatSessionInfo `json:"data"`
}

// Get chat session list request params | ChatSession列表请求参数
// swagger:model ChatSessionListReq
type ChatSessionListReq struct {
	PageInfo
	BotId   *uint64 `json:"botId,optional"`
	BotType *uint8  `json:"botType,optional"`
	BotName *string `json:"botName,optional"`
}

// ChatSession information response | ChatSession信息返回体
// swagger:model ChatSessionInfoResp
type ChatSessionInfoResp struct {
	BaseDataInfo
	// ChatSession information | ChatSession数据
	Data ChatSessionInfo `json:"data"`
}

// The data of wx card information | WxCard信息
// swagger:model WxCardInfo
type WxCardInfo struct {
	BaseIDInfo
	// user表ID
	UserId *uint64 `json:"userId,optional"`
	// wx表ID
	WxUserId *uint64 `json:"wxUserId,optional"`
	// 头像
	Avatar *string `json:"avatar,optional"`
	// logo
	Logo *string `json:"logo,optional"`
	// 名称
	Name *string `json:"name,optional"`
	// 公司
	Company *string `json:"company,optional"`
	// 地址
	Address *string `json:"address,optional"`
	// 手机号
	Phone *string `json:"phone,optional"`
	// 公众号
	OfficialAccount *string `json:"officialAccount,optional"`
	// 微信号
	WechatAccount *string `json:"wechatAccount,optional"`
	// 邮箱
	Email *string `json:"email,optional"`
	// 聊天信息
	ApiBase *string `json:"apiBase,optional"`
	ApiKey  *string `json:"apiKey,optional"`
	// AI信息
	AiInfo *string `json:"aiInfo,optional"`
	// 个人介绍
	Intro    *string `json:"intro,optional"`
	ShowChat *bool   `json:"showChat,optional"`
	ShowAi   *bool   `json:"showAi,optional"`
	IsVip    *bool   `json:"isVip,optional"`
}

// swagger:model WxCardSimpleInfo
type WxCardSimpleInfo struct {
	ID *uint64 `json:"id,optional"`
	// 头像
	Avatar *string `json:"avatar,optional"`
	// 名称
	Name *string `json:"name,optional"`
	Type *string `json:"type,optional"`
}

// The response data of wx card list | WxCard列表数据
// swagger:model WxCardListResp
type WxCardListResp struct {
	BaseDataInfo
	// WxCard list data | WxCard列表数据
	Data WxCardListInfo `json:"data"`
}

// WxCard list data | WxCard列表数据
// swagger:model WxCardListInfo
type WxCardListInfo struct {
	BaseListInfo
	// The API list data | WxCard列表数据
	Data []WxCardInfo `json:"data"`
}

// Get wx card list request params | WxCard列表请求参数
// swagger:model WxCardListReq
type WxCardListReq struct {
	PageInfo
	// 头像
	Avatar *string `json:"avatar,optional"`
	// logo
	Logo *string `json:"logo,optional"`
	// 名称
	Name *string `json:"name,optional"`
}

// WxCard information response | WxCard信息返回体
// swagger:model WxCardInfoResp
type WxCardInfoResp struct {
	BaseDataInfo
	// WxCard information | WxCard数据
	Data WxCardInfo `json:"data"`
}

// swagger:model QrcodeReq
type QrcodeReq struct {
	Path       string `form:"path"`
	Width      int64  `form:"width"`
	EnvVersion string `form:"envVersion"`
}

// The data of wx card user information | WxCardUser信息
// swagger:model WxCardUserInfo
type WxCardUserInfo struct {
	BaseIDInfo
	// 微信id
	Wxid *string `json:"wxid,optional"`
	// 微信号
	Account *string `json:"account,optional"`
	// 头像
	Avatar *string `json:"avatar,optional"`
	// 昵称
	Nickname *string `json:"nickname,optional"`
	// 备注名
	Remark *string `json:"remark,optional"`
	// 手机号
	Phone *string `json:"phone,optional"`
	// OpenID
	OpenId *string `json:"openId,optional"`
	// UnionID
	UnionId *string `json:"unionId,optional"`
	// SessionKey
	SessionKey *string `json:"sessionKey,optional"`
	// IsVip
	IsVip *string `json:"isVip,optional"`
}

// The response data of wx card user list | WxCardUser列表数据
// swagger:model WxCardUserListResp
type WxCardUserListResp struct {
	BaseDataInfo
	// WxCardUser list data | WxCardUser列表数据
	Data WxCardUserListInfo `json:"data"`
}

// WxCardUser list data | WxCardUser列表数据
// swagger:model WxCardUserListInfo
type WxCardUserListInfo struct {
	BaseListInfo
	// The API list data | WxCardUser列表数据
	Data []WxCardUserInfo `json:"data"`
}

// Get wx card user list request params | WxCardUser列表请求参数
// swagger:model WxCardUserListReq
type WxCardUserListReq struct {
	PageInfo
	// 微信id
	Wxid *string `json:"wxid,optional"`
	// 微信号
	Account *string `json:"account,optional"`
	// 头像
	Avatar *string `json:"avatar,optional"`
	// 昵称
	Nickname *string `json:"nickname,optional"`
}

// WxCardUser information response | WxCardUser信息返回体
// swagger:model WxCardUserInfoResp
type WxCardUserInfoResp struct {
	BaseDataInfo
	// WxCardUser information | WxCardUser数据
	Data WxCardUserInfo `json:"data"`
}

// The data of wx card visit information | WxCardVisit信息
// swagger:model WxCardVisitInfo
type WxCardVisitInfo struct {
	BaseIDInfo
	// user表ID
	UserId *uint64 `json:"userId,optional"`
	// user名
	UserName *string `json:"userName,optional"`
	// 被访ID
	BotId *uint64 `json:"botId,optional"`
	// 类型:1-微信 2-小程序 3-智能体
	BotType *uint8 `json:"botType,optional"`
	// 类型:1-微信 2-小程序 3-智能体
	BotTypeStr *string          `json:"botTypeStr,optional"`
	CardInfo   WxCardSimpleInfo `json:"cardInfo,optional,omitempty"`
}

// swagger:model WxCardVisitReq
type WxCardVisitReq struct {
	BaseIDInfo
	// user表ID
	UserId *uint64 `json:"userId,optional"`
	// 被访ID
	BotId *uint64 `json:"botId,optional"`
	// 类型:1-微信 2-小程序 3-智能体
	BotType *uint8 `json:"botType,optional"`
}

// swagger:model WxCardVisitSingleInfo
type WxCardVisitSingleInfo struct {
	BaseIDInfo
	// user表ID
	UserId *uint64 `json:"userId,optional"`
	// 被访ID
	BotId *uint64 `json:"botId,optional"`
	// 类型:1-微信 2-小程序 3-智能体
	BotType  *uint8     `json:"botType,optional"`
	CardInfo WxCardInfo `json:"cardInfo,optional"`
}

// The response data of wx card visit list | WxCardVisit列表数据
// swagger:model WxCardVisitListResp
type WxCardVisitListResp struct {
	BaseDataInfo
	// WxCardVisit list data | WxCardVisit列表数据
	Data WxCardVisitListInfo `json:"data"`
}

// WxCardVisit list data | WxCardVisit列表数据
// swagger:model WxCardVisitListInfo
type WxCardVisitListInfo struct {
	BaseListInfo
	// The API list data | WxCardVisit列表数据
	Data []WxCardVisitInfo `json:"data"`
}

// Get wx card visit list request params | WxCardVisit列表请求参数
// swagger:model WxCardVisitListReq
type WxCardVisitListReq struct {
	PageInfo
	BotId   *uint64 `json:"botId,optional"`
	BotType *uint8  `json:"botType,optional"`
	BotName *string `json:"botName,optional"`
}

// WxCardVisit information response | WxCardVisit信息返回体
// swagger:model WxCardVisitInfoResp
type WxCardVisitInfoResp struct {
	BaseDataInfo
	// WxCardVisit information | WxCardVisit数据
	Data WxCardVisitInfo `json:"data"`
}

// swagger:model AvatarInfo
type AvatarInfo struct {
	RequestId *string `json:"requestId"`
	SessionId *string `json:"SessionId"`
	Token     *string `json:"token"`
	Channel   Channel `json:"channel"`
}

type Channel struct {
	ChannelId         *string   `json:"channelId"`
	Token             *string   `json:"token"`
	Type              *string   `json:"type"`
	ExpiredTime       *string   `json:"expiredTime"`
	Nonce             *string   `json:"nonce"`
	UserId            *string   `json:"userId"`
	AppId             *string   `json:"appId"`
	UserInfoInChannel *string   `json:"userInfoInChannel"`
	Gslb              []*string `json:"gslb"`
}

// start avatar request | 启动数字人
// swagger:model AvatarConfigReq
type AvatarConfigReq struct {
	// 名片 ID
	CardId *uint64 `json:"card_id,optional"`
}

// start avatar response | 启动数字人
// swagger:model AvatarConfigResp
type AvatarConfigResp struct {
	BaseDataInfo
	// Agent information | Agent数据
	Data  AvatarInfo `json:"data"`
	Extra Extra      `json:"extra"`
}

type Extra struct {
	Live  int64 `json:"live"`
	Total int64 `json:"total"`
}

// swagger:model AvatarStsResp
type AvatarStsResp struct {
	BaseDataInfo
	// Sts information | Sts 数据
	Data StsInfo `json:"data"`
}

// swagger:model StsInfo
type StsInfo struct {
	Expiration      *string `json:"expiration"`
	AccessKeyId     *string `json:"accessKeyId"`
	AccessKeySecret *string `json:"accessKeySecret"`
	SecurityToken   *string `json:"securityToken"`
	RequestId       *string `json:"requestId"`
}

// swagger:model AvatarSignatureResp
type AvatarSignatureResp struct {
	BaseDataInfo
	// Sts information | Sts 数据
	Data SignatureInfo `json:"data"`
}

// swagger:model SignatureInfo
type SignatureInfo struct {
	Key            *string `json:"key"`
	OSSAccessKeyId *string `json:"OSSAccessKeyId"`
	Policy         *string `json:"policy"`
	Signature      *string `json:"signature"`
}

// send text | 数字人-发送消息
// swagger:model SendTextReq
type SendTextReq struct {
	CardId    *uint64 `json:"cardId"`
	SessionId *string `json:"sessionId"`
	Text      *string `json:"text"`
	IsStream  *bool   `json:"isStream,optional"`
	Index     *int32  `json:"index,optional"`
	Position  *string `json:"position,optional"`
}

// swagger:model SendTextResp
type SendTextResp struct {
	BaseDataInfo
	Data SendText `json:"data"`
}

type SendText struct {
	SessionId  *string `json:"sessionId"`
	UniqueCode *string `json:"uniqueCode"`
}

// stop instance | 数字人-停止实例
// swagger:model StopInstanceReq
type StopInstanceReq struct {
	CardId    *uint64 `json:"cardId"`
	SessionId *string `json:"sessionId"`
}

// swagger:model StopInstanceResp
type StopInstanceResp struct {
	BaseDataInfo
	Data StopInstance `json:"data"`
}

type StopInstance struct {
	SessionId *string `json:"sessionId"`
	RequestId *string `json:"requestId"`
}

// The data of aliyun avatar information | AliyunAvatar信息
// swagger:model AliyunAvatarInfo
type AliyunAvatarInfo struct {
	BaseIDInfo
	// user_id | wx_card_user_id
	UserId *uint64 `json:"userId,optional"`
	// biz_id | BizId
	BizId *string `json:"bizId,optional"`
	// access_key_id | AccessKeyId
	AccessKeyId *string `json:"accessKeyId,optional"`
	// access_key_secret | AccessKeySecret
	AccessKeySecret *string `json:"accessKeySecret,optional"`
	// app_id | AppId
	AppId *string `json:"appId,optional"`
	// tenant_id | TenantId
	TenantId *uint64 `json:"TenantId,optional"`
	// response | 阿里云avatar响应
	Response *string `json:"response,optional"`
	// token | Token
	Token *string `json:"token,optional"`
	// session_id | SessionId
	SessionId *string `json:"sessionId,optional"`
}

// The response data of aliyun avatar list | AliyunAvatar列表数据
// swagger:model AliyunAvatarListResp
type AliyunAvatarListResp struct {
	BaseDataInfo
	// AliyunAvatar list data | AliyunAvatar列表数据
	Data AliyunAvatarListInfo `json:"data"`
}

// AliyunAvatar list data | AliyunAvatar列表数据
// swagger:model AliyunAvatarListInfo
type AliyunAvatarListInfo struct {
	BaseListInfo
	// The API list data | AliyunAvatar列表数据
	Data []AliyunAvatarInfo `json:"data"`
}

// Get aliyun avatar list request params | AliyunAvatar列表请求参数
// swagger:model AliyunAvatarListReq
type AliyunAvatarListReq struct {
	PageInfo
	// biz_id | BizId
	BizId *string `json:"bizId,optional"`
	// access_key_id | AccessKeyId
	AccessKeyId *string `json:"accessKeyId,optional"`
	// access_key_secret | AccessKeySecret
	AccessKeySecret *string `json:"accessKeySecret,optional"`
}

// AliyunAvatar information response | AliyunAvatar信息返回体
// swagger:model AliyunAvatarInfoResp
type AliyunAvatarInfoResp struct {
	BaseDataInfo
	// AliyunAvatar information | AliyunAvatar数据
	Data AliyunAvatarInfo `json:"data"`
}

// The response data of UsageDetail information | UsageDetail信息
// swagger:model UsageDetailInfo
type UsageDetailInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 1 微信 2 名片
	Type *int
	// 微信id
	BotId *string `json:"botId,optional"`
	// 微信id或open_id
	ReceiverId *string `json:"receiverId,optional"`
	// 1 cow-basic 2 cow-agent 3 cow-sop 4 mp-card 5 mp-employee
	App *string
	// 名片会话id
	SessionId *uint64 `json:"sessionId,optional"`
	// 请求内容
	Request *string `json:"request,optional"`
	// 响应内容
	Response *string `json:"response,optional"`
	// 使用token总数
	TotalTokens *uint64 `json:"totalTokens,optional"`
	// 请求token数
	PromptTokens *uint64 `json:"promptTokens,optional"`
	// 响应token数
	CompletionTokens *uint64 `json:"completionTokens,optional"`
	// 组织ID
	OrganizationId   *uint64  `json:"organizationId,optional"`
	OrganizationName *string  `json:"organizationName,optional"`
	Model            *string  `json:"model,optional"`
	Credits          *float64 `json:"credits,optional"`
}

// The response data of UsageDetail list | UsageDetail列表数据
// swagger:model UsageDetailListResp
type UsageDetailListResp struct {
	BaseDataInfo
	// UsageDetail list data | UsageDetail列表数据
	Data UsageDetailListInfo `json:"data"`
}

// UsageDetail list data | UsageDetail列表数据
// swagger:model UsageDetailListInfo
type UsageDetailListInfo struct {
	BaseListInfo
	// The API list data | UsageDetail列表数据
	Data []UsageDetailInfo `json:"data"`
}

// Get wx list request params | Wx列表请求参数
// swagger:model UsageDetailListReq
type UsageDetailListReq struct {
	PageInfo
	// 租户id
	OrganizationId *uint64  `json:"organizationId,optional"`
	Type           *int     `json:"type,optional"`
	BotId          *string  `json:"botId,optional"`
	ReceiverId     *string  `json:"receiverId,optional"`
	SearchDate     []string `json:"searchDate,optional"`
}

// swagger:model UsageDetailResp
type UsageDetailResp struct {
	BaseDataInfo
	Data UsageDetailInfo `json:"data"`
}

// The response data of UsageTotal information | UsageTotal信息
// swagger:model UsageTotalInfo
type UsageTotalInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// 1 微信 2 名片
	Type *int
	// 微信或名片id
	BotId *string `json:"botId,optional"`
	// 使用token总数
	TotalTokens *uint64 `json:"totalTokens,optional"`
	// 使用积分总数
	Credits float64 `json:"credits,optional"`
	// 重制后的起始usage_detail 索引
	StartIndex *uint64 `json:"startIndex,optional"`
	// usage_detail 索引
	EndIndex *uint64 `json:"endIndex,optional"`
	// 组织ID
	OrganizationId *uint64 `json:"organizationId,optional"`
}

// The response data of UsageTotal list | UsageTotal列表数据
// swagger:model UsageTotalListResp
type UsageTotalListResp struct {
	BaseDataInfo
	// UsageTotal list data | UsageTotal列表数据
	Data UsageTotalListInfo `json:"data"`
}

// UsageTotal list data | UsageTotal列表数据
// swagger:model UsageTotalListInfo
type UsageTotalListInfo struct {
	BaseListInfo
	// The API list data | UsageTotal列表数据
	Data []UsageTotalInfo `json:"data"`
}

// Get wx list request params | Wx列表请求参数
// swagger:model UsageTotalListReq
type UsageTotalListReq struct {
	PageInfo
	// 租户id
	OrganizationId *uint64 `json:"organizationId,optional"`
}

// The data of alloc agent information | AllocAgent信息
// swagger:model AllocAgentInfo
type AllocAgentInfo struct {
	BaseIDInfo
	// user_id | 前台用户ID
	UserId *string `json:"userId,optional"`
	// organization_id | 租户ID
	OrganizationId *uint64 `json:"organizationId,optional"`
	// agents | 分配的智能体IDs
	Agents []uint64 `json:"agents,optional"`
	// status | 状态 1-正常 2-禁用
	Status *int `json:"status,optional"`
}

type AllocAgentQuery struct {
	// user_id | 前台用户ID
	UserId *string `json:"userId,optional"`
	// organization_id | 租户ID
	OrganizationId *uint64 `json:"organizationId,optional"`
}

// The response data of alloc agent list | AllocAgent列表数据
// swagger:model AllocAgentListResp
type AllocAgentListResp struct {
	BaseDataInfo
	// AllocAgent list data | AllocAgent列表数据
	Data AllocAgentListInfo `json:"data"`
}

// AllocAgent list data | AllocAgent列表数据
// swagger:model AllocAgentListInfo
type AllocAgentListInfo struct {
	BaseListInfo
	// The API list data | AllocAgent列表数据
	Data []AllocAgentInfo `json:"data"`
}

// Get alloc agent list request params | AllocAgent列表请求参数
// swagger:model AllocAgentListReq
type AllocAgentListReq struct {
	PageInfo
	// agents | 分配的智能体IDs
	Agents *string `json:"agents,optional"`
}

// AllocAgent information response | AllocAgent信息返回体
// swagger:model AllocAgentInfoResp
type AllocAgentInfoResp struct {
	BaseDataInfo
	// AllocAgent information | AllocAgent数据
	Data AllocAgentInfo `json:"data"`
}

// swagger:model SignatureResp
type SignatureResp struct {
	BaseDataInfo
	// 临时签名
	Data *string `json:"data"`
}

// swagger:model MessageReq
type MessageReq struct {
	// 大模型生成内容
	UserId *uint64 `json:"user_id"`
	Text   *string `json:"text"`
}

// swagger:model ChatReq
type ChatReq struct {
	// 大模型生成内容
	AvatarId *string `json:"avatar_id"`
	UserId   *uint64 `json:"user_id"`
	Text     *string `json:"text"`
}

// swagger:model DashboardInfo
type DashboardInfo struct {
	BaseIDInfo
}

// swagger:model ChartsReq
type ChartsReq struct {
	StartDate *string `json:"start_date"`
	EndDate   *string `json:"end_date"`
	// 租户id
	OrganizationId *uint64 `json:"organizationId,optional"`
	Wxid           *string `json:"wxid,optional"`
}

// swagger:model ChartsResp
type ChartsResp struct {
	BaseDataInfo
	Data *ChartsData `json:"data"`
}

type ChartsData struct {
	AiResponse     *ChartsUint  `json:"ai_response"`
	SopRun         *ChartsUint  `json:"sop_run"`
	TotalFriend    *ChartsUint  `json:"total_friend"`
	TotalGroup     *ChartsUint  `json:"total_group"`
	AccountBalance *ChartsInt   `json:"account_balance"`
	ConsumeToken   *ChartsUint  `json:"consume_token"`
	ActiveUser     *ChartsUint  `json:"active_user"`
	NewUser        *ChartsInt   `json:"new_user"`
	LabelDist      []LabelsData `json:"label_dist"`
	ConsumeCoin    *ChartsStr   `json:"consume_coin"`
}

type ChartsUint struct {
	Count     uint64   `json:"count"`
	Rate      *float32 `json:"rate"`
	Label     []string `json:"label"`
	Val       []uint64 `json:"val"`
	LabelText string   `json:"labelText"`
	Tip       *string  `json:"tip"`
}

type ChartsFloat struct {
	Count     float64   `json:"count"`
	Rate      *float32  `json:"rate"`
	Label     []string  `json:"label"`
	Val       []float64 `json:"val"`
	LabelText string    `json:"labelText"`
	Tip       *string   `json:"tip"`
}

type ChartsMix struct {
	Count     int64     `json:"count"`
	Rate      *float32  `json:"rate"`
	Label     []string  `json:"label"`
	Val       []float64 `json:"val"`
	LabelText string    `json:"labelText"`
	Tip       *string   `json:"tip"`
}

type ChartsStr struct {
	Count     string   `json:"count"`
	Rate      *float32 `json:"rate"`
	Label     []string `json:"label"`
	Val       []string `json:"val"`
	LabelText string   `json:"labelText"`
	Tip       *string  `json:"tip"`
}

type ChartsInt struct {
	Count     int64    `json:"count"`
	Rate      *float32 `json:"rate"`
	Label     []string `json:"label"`
	Val       []int64  `json:"val"`
	LabelText string   `json:"labelText"`
	Tip       *string  `json:"tip"`
}

type LabelsData struct {
	Value uint64 `json:"value"`
	Name  string `json:"name"`
}

// swagger:model WxReq
type WxReq struct {
	PageInfo
	EndDate *string `json:"end_date"`
	// 租户id
	OrganizationId *uint64 `json:"organizationId,optional"`
	Wxid           *string `json:"wxid,optional"`
}

// swagger:model WxResp
type WxResp struct {
	BaseDataInfo
	Data WxList `json:"data"`
}

type WxList struct {
	BaseListInfo
	Data []WxData `json:"data"`
}

type WxData struct {
	Nickname        string  `json:"nickname"`
	TotalFriend     uint64  `json:"total_friend"`
	TotalGroup      uint64  `json:"total_group"`
	InteractionRate float32 `json:"interaction_rate"`
}

// The data of credit balance information | CreditBalance信息
// swagger:model CreditBalanceInfo
type CreditBalanceInfo struct {
	BaseIDInfo
	// user_id | 用户ID
	//        UserId  *string `json:"userId,optional"`
	// role | 角色设定
	Balance *float64 `json:"balance,optional"`
	// status | 状态 1-正常 2-禁用
	Status *int `json:"status,optional"`
	// organization_id | 租户ID
	OrganizationId   *uint64 `json:"organizationId,optional"`
	OrganizationName *string `json:"organizationName,optional"`
}

// The response data of credit balance list | CreditBalance列表数据
// swagger:model CreditBalanceListResp
type CreditBalanceListResp struct {
	BaseDataInfo
	// CreditBalance list data | CreditBalance列表数据
	Data CreditBalanceListInfo `json:"data"`
}

// CreditBalance list data | CreditBalance列表数据
// swagger:model CreditBalanceListInfo
type CreditBalanceListInfo struct {
	BaseListInfo
	// The API list data | CreditBalance列表数据
	Data []CreditBalanceInfo `json:"data"`
}

// Get credit balance list request params | CreditBalance列表请求参数
// swagger:model CreditBalanceListReq
type CreditBalanceListReq struct {
	PageInfo
	// user_id | 用户ID
	UserId         *string `json:"userId,optional"`
	OrganizationId *uint64 `json:"organizationId,optional"`
}

// CreditBalance information response | CreditBalance信息返回体
// swagger:model CreditBalanceInfoResp
type CreditBalanceInfoResp struct {
	BaseDataInfo
	// CreditBalance information | CreditBalance数据
	Data CreditBalanceInfo `json:"data"`
}

// swagger:model CreditBalanceOperateReq
type CreditBalanceOperateReq struct {
	OrganizationId *uint64  `json:"organizationId,optional"`
	Number         *float64 `json:"number,optional"`
	PayNumber      *float64 `json:"payNumber,optional"`
	PayMethod      *int     `json:"payMethod,optional"`
	Reason         *string  `json:"reason,optional"`
}

// The data of credit usage information | CreditUsage信息
// swagger:model CreditUsageInfo
type CreditUsageInfo struct {
	BaseIDInfo
	// user_id | 用户ID
	//        UserId  *string `json:"userId,optional"`
	// number | 积分改变量
	Number       *float64 `json:"number,optional"`
	BeforeNumber *float64 `json:"beforeNumber,optional"`
	AfterNumber  *float64 `json:"afterNumber,optional"`
	PayNumber    *float64 `json:"payNumber,optional"`
	PayMethod    *int     `json:"payMethod,optional"`
	// status | 状态 1-正常 2-禁用
	Status *int `json:"status,optional"`
	// ntype | 积分变化类型：1-消耗 2-增加
	Ntype *int `json:"ntype,optional"`
	// table | 积分变化表名
	Table *string `json:"table,optional"`
	// organization_id | 租户ID
	OrganizationId   *uint64 `json:"organizationId,optional"`
	OrganizationName *string `json:"organizationName,optional"`
	// nid | 积分变化关联信息ID
	Nid *uint64 `json:"nid,optional"`
	// reason | 积分变动原因
	Reason *string `json:"reason,optional"`
	// operator | 积分变动人
	Operator     *string `json:"operator,optional"`
	OperatorName *string `json:"operatorName,optional"`
}

// The response data of credit usage list | CreditUsage列表数据
// swagger:model CreditUsageListResp
type CreditUsageListResp struct {
	BaseDataInfo
	// CreditUsage list data | CreditUsage列表数据
	Data CreditUsageListInfo `json:"data"`
}

// CreditUsage list data | CreditUsage列表数据
// swagger:model CreditUsageListInfo
type CreditUsageListInfo struct {
	BaseListInfo
	// The API list data | CreditUsage列表数据
	Data []CreditUsageInfo `json:"data"`
}

// Get credit usage list request params | CreditUsage列表请求参数
// swagger:model CreditUsageListReq
type CreditUsageListReq struct {
	PageInfo
	OrganizationId *uint64  `json:"organizationId,optional"`
	Ntype          *int     `json:"ntype,optional"`
	SearchDate     []string `json:"searchDate,optional"`
}

// CreditUsage information response | CreditUsage信息返回体
// swagger:model CreditUsageInfoResp
type CreditUsageInfoResp struct {
	BaseDataInfo
	// CreditUsage information | CreditUsage数据
	Data CreditUsageInfo `json:"data"`
}

// The data of pay recharge information | PayRecharge信息
// swagger:model PayRechargeInfo
type PayRechargeInfo struct {
	BaseIDInfo
	// user_id | 用户ID
	UserId   *string  `json:"userId,optional"`
	UserInfo UserInfo `json:"userInfo,optional"`
	// number | 变化积分数
	Number *float32 `json:"number,optional"`
	// status | 状态 1-正常 2-禁用
	Status *int `json:"status,optional"`
	// money | 充值钱数
	Money *float32 `json:"money,optional"`
	// out_trade_no | 外部订单号
	OutTradeNo *string `json:"outTradeNo,optional"`
	// organization_id | 租户ID
	OrganizationId   *uint64 `json:"organizationId,optional"`
	OrganizationName *string `json:"organizationName,optional"`
}

// The response data of pay recharge list | PayRecharge列表数据
// swagger:model PayRechargeListResp
type PayRechargeListResp struct {
	BaseDataInfo
	// PayRecharge list data | PayRecharge列表数据
	Data PayRechargeListInfo `json:"data"`
}

// PayRecharge list data | PayRecharge列表数据
// swagger:model PayRechargeListInfo
type PayRechargeListInfo struct {
	BaseListInfo
	// The API list data | PayRecharge列表数据
	Data []PayRechargeInfo `json:"data"`
}

// Get pay recharge list request params | PayRecharge列表请求参数
// swagger:model PayRechargeListReq
type PayRechargeListReq struct {
	PageInfo
	// user_id | 用户ID
	UserId *string `json:"userId,optional"`
	// out_trade_no | 外部订单号
	OutTradeNo *string `json:"outTradeNo,optional"`
}

// PayRecharge information response | PayRecharge信息返回体
// swagger:model PayRechargeInfoResp
type PayRechargeInfoResp struct {
	BaseDataInfo
	// PayRecharge information | PayRecharge数据
	Data PayRechargeInfo `json:"data"`
}

// The data of whatsapp information | Whatsapp信息
// swagger:model WhatsappInfo
type WhatsappInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8  `json:"status,optional"`
	WaId   *string `json:"waId,optional"`
	WaName *string `json:"waName,optional"`
	// 回调地址
	Callback *string `json:"callback,optional"`
	// 模式ID
	AgentId   *uint64    `json:"agentId,optional"`
	AgentInfo *AgentInfo `json:"agentInfo,optional"`
	// 微信账号
	Account *string `json:"account,optional"`
	// 手机号
	Phone *string `json:"phone,optional"`
	Cc    *string `json:"cc,optional"`
	// 号码名称
	PhoneName *string `json:"phoneName,optional"`
	// 号码状态
	PhoneStatus *string `json:"phoneStatus,optional"`
	Tokens      *uint64 `json:"tokens,optional"`
	// 号码发送频率号码发送频率
	Frequency *string `json:"frequency,optional"`
	// 号码质量
	Quality *string `json:"quality,optional"`
	// 号码校验状态
	VerifyStatus *string `json:"verifyStatus,optional"`
	// 机构 ID
	OrganizationId   *uint64 `json:"organizationId,optional"`
	OrganizationName *string `json:"organizationName,optional"`
	// 大模型服务地址
	ApiBase *string `json:"apiBase,optional"`
	// 大模型服务密钥
	ApiKey *string `json:"apiKey,optional"`
	// 白名单
	AllowList []ContactInfo `json:"allowList,optional"`
	// 群白名单
	GroupAllowList []ContactInfo `json:"groupAllowList,optional"`
	// 黑名单
	BlockList []ContactInfo `json:"blockList,optional"`
	// 群黑名单
	GroupBlockList []ContactInfo `json:"groupBlockList,optional"`
}

// swagger:model WhatsappPhoneInfo
type WhatsappPhoneInfo struct {
	Avatar   *string `json:"avatar,optional"`
	Industry *string `json:"industry,optional"`
	Intro    *string `json:"intro,optional"`
	Address  *string `json:"address,optional"`
	Email    *string `json:"email,optional"`
	Website  *string `json:"website,optional"`
}

// The response data of whatsapp list | Whatsapp列表数据
// swagger:model WhatsappListResp
type WhatsappListResp struct {
	BaseDataInfo
	// Whatsapp list data | Whatsapp列表数据
	Data WhatsappListInfo `json:"data"`
}

// Whatsapp list data | Whatsapp列表数据
// swagger:model WhatsappListInfo
type WhatsappListInfo struct {
	BaseListInfo
	// The API list data | Whatsapp列表数据
	Data []WhatsappInfo `json:"data"`
}

// Get whatsapp list request params | Whatsapp列表请求参数
// swagger:model WhatsappListReq
type WhatsappListReq struct {
	PageInfo
	// 手机号
	Phone *string `json:"phone,optional"`
	// 号码名称
	PhoneName      *string `json:"phoneName,optional"`
	WaId           *string `json:"waId,optional"`
	OrganizationId *uint64 `json:"organizationId,optional"`
}

// Whatsapp information response | Whatsapp信息返回体
// swagger:model WhatsappInfoResp
type WhatsappInfoResp struct {
	BaseDataInfo
	// Whatsapp information | Whatsapp数据
	Data WhatsappInfo `json:"data"`
}

// swagger:model AutomationReq
type AutomationReq struct {
	WaId  *string `json:"waId,optional"`
	Phone *string `json:"phone,optional"`
}

// swagger:model AutomationResp
type AutomationResp struct {
	BaseDataInfo
	// Whatsapp list data | Whatsapp列表数据
	Data ConversationalAutomationInfo `json:"data"`
}

// swagger:model ConversationalAutomationInfo
type ConversationalAutomationInfo struct {
	Prompts              []string  `json:"prompts,optional"`
	Commands             []Command `json:"commands,optional"`
	Phone                string    `json:"phone,optional"`
	EnableWelcomeMessage bool      `json:"enableWelcomeMessage,optional"`
}

type Command struct {
	CommandDescription string `json:"commandDescription,optional"`
	CommandName        string `json:"commandName,optional"`
}

// swagger:model SetAutomationReq
type SetAutomationReq struct {
	EnableWelcomeMessage bool      `json:"enableWelcomeMessage,optional"`
	Phone                string    `json:"phone,optional"`
	Commands             []Command `json:"commands,optional"`
	Prompts              []string  `json:"prompts,optional"`
	WaId                 string    `json:"waId,optional"`
}

// swagger:model sendCodeReq
type SendCodeReq struct {
	Cc     *string `json:"cc"`
	Phone  *string `json:"phone"`
	WaId   *string `json:"waId"`
	Method *string `json:"method"`
	Locale *string `json:"locale"`
}

// swagger:model submitCodeReq
type SubmitCodeReq struct {
	Cc    *string `json:"cc"`
	Phone *string `json:"phone"`
	WaId  *string `json:"waId"`
	Code  *string `json:"code"`
}

// swagger:model getQrcodeReq
type GetQrcodeReq struct {
	Phone *string `json:"phone"`
	WaId  *string `json:"waId"`
}

// swagger:model getQrcodeResp
type GetQrcodeResp struct {
	BaseDataInfo
	Data QrcodeListInfo `json:"data"`
}

// swagger:model QrcodeListInfo
type QrcodeListInfo struct {
	BaseListInfo
	Data []Qrcode `json:"data"`
}

type Qrcode struct {
	Phone            string `json:"phone,optional"`
	QrdlCode         string `json:"qrdlCode,optional"`
	GenerateQrImage  string `json:"generateQrImage,optional"`
	PrefilledMessage string `json:"prefilledMessage,optional"`
	DeepLinkUrl      string `json:"deepLinkUrl,optional"`
	QrImageUrl       string `json:"qrImageUrl,optional"`
}

// swagger:model createQrcodeReq
type CreateQrcodeReq struct {
	Phone            string `json:"phone"`
	GenerateQrImage  string `json:"generateQrImage"`
	PrefilledMessage string `json:"prefilledMessage"`
	WaId             string `json:"waId"`
}

// swagger:model updateQrcodeReq
type UpdateQrcodeReq struct {
	Phone            string `json:"phone,optional"`
	GenerateQrImage  string `json:"generateQrImage,optional"`
	PrefilledMessage string `json:"prefilledMessage,optional"`
	QrdlCode         string `json:"qrdlCode,optional"`
	WaId             string `json:"waId"`
}

// swagger:model removeQrcodeReq
type RemoveQrcodeReq struct {
	Phone    string `json:"phone,optional"`
	QrdlCode string `json:"qrdlCode,optional"`
	WaId     string `json:"waId"`
}

// swagger:model getBusinessReq
type GetBusinessReq struct {
	Phone *string `json:"phone"`
	WaId  *string `json:"waId"`
}

// swagger:model getBusinessResp
type GetBusinessResp struct {
	BaseDataInfo
	Data BusinessInfo `json:"data"`
}

// swagger:model BusinessInfo
type BusinessInfo struct {
	Vertical          string   `json:"vertical,optional"`
	Description       string   `json:"description,optional"`
	Email             string   `json:"email,optional"`
	Address           string   `json:"address,optional"`
	ProfilePictureUrl string   `json:"profilePictureUrl,optional"`
	Websites          []string `json:"websites,optional"`
	About             string   `json:"about,optional"`
}

// swagger:model setBusinessReq
type SetBusinessReq struct {
	Phone             *string  `json:"phone"`
	WaId              *string  `json:"waId"`
	Vertical          string   `json:"vertical,optional"`
	Description       string   `json:"description,optional"`
	Email             string   `json:"email,optional"`
	Address           string   `json:"address,optional"`
	ProfilePictureUrl string   `json:"profilePictureUrl,optional"`
	Websites          []string `json:"websites,optional"`
	About             string   `json:"about,optional"`
}

// swagger:model registerReq
type RegisterReq struct {
	Phone *string `json:"phone"`
	WaId  *string `json:"waId"`
}

// swagger:model deregisterReq
type DeregisterReq struct {
	Phone *string `json:"phone"`
	WaId  *string `json:"waId"`
}

// swagger:model UpdateAgentReq
type UpdateAgentReq struct {
	Id      uint64 `json:"id"`
	AgentId uint64 `json:"agentId"`
}

// 获取黑白名单列表返回体
// swagger:model WhatsappAllowBlockListResp
type WhatsappAllowBlockListResp struct {
	BaseDataInfo
	// Wx information | Wx数据
	Data WhatsappAllowBlockListRespData `json:"data"`
}

// WhatsappAllowBlockListRespData
type WhatsappAllowBlockListRespData struct {
	// 白名单
	AllowList *string `json:"allowList,optional"`
	// 群白名单
	GroupAllowList *string `json:"groupAllowList,optional"`
	// 黑名单
	BlockList *string `json:"blockList,optional"`
	// 群黑名单
	GroupBlockList *string `json:"groupBlockList,optional"`
}

// swagger:model UpdateAllowAndBlockListReq
type UpdateAllowAndBlockListReq struct {
	Id uint64 `json:"id"`
	// 白名单
	AllowList *string `json:"allowList,optional"`
	// 群白名单
	GroupAllowList *string `json:"groupAllowList,optional"`
	// 黑名单
	BlockList *string `json:"blockList,optional"`
	// 群黑名单
	GroupBlockList *string `json:"groupBlockList,optional"`
}

// swagger:model UpdateAgentApiReq
type UpdateAgentApiReq struct {
	Id      uint64  `json:"id"`
	ApiBase *string `json:"apiBase,optional"`
	ApiKey  *string `json:"apiKey,optional"`
}

// swagger:model TemplateInfo
type TemplateInfo struct {
	Category              string              `json:"category,optional"`
	TemplateCode          string              `json:"templateCode,optional"`
	Name                  string              `json:"name,optional"`
	Language              string              `json:"language,optional"`
	TemplateType          string              `json:"templateType,optional"`
	AuditStatus           string              `json:"auditStatus,optional"`
	Components            []TemplateComponent `json:"components,optional"`
	QualityScore          string              `json:"qualityScore,optional"`
	MessageSendTtlSeconds int                 `json:"messageSendTtlSeconds,optional"`
	Reason                string              `json:"reason,optional"`
}

// swagger:model TemplateSingleInfo
type TemplateSingleInfo struct {
	Category     string `json:"category,optional"`
	TemplateCode string `json:"templateCode,optional"`
	Name         string `json:"name,optional"`
	Language     string `json:"language,optional"`
	TemplateType string `json:"templateType,optional"`
	AuditStatus  string `json:"auditStatus,optional"`
}

type TemplateComponent struct {
	Type                    string           `json:"type,optional"`
	Url                     string           `json:"url,optional"`
	Text                    string           `json:"text,optional"`
	Caption                 string           `json:"caption,optional"`
	FileName                string           `json:"fileName,optional"`
	Format                  string           `json:"format,optional"`
	Buttons                 []TemplateButton `json:"buttons,optional"`
	ThumbUrl                string           `json:"thumbUrl,optional"`
	Duration                int              `json:"duration,optional"`
	FileType                string           `json:"fileType,optional"`
	Latitude                string           `json:"latitude,optional"`
	Longitude               string           `json:"longitude,optional"`
	LocationName            string           `json:"locationName,optional"`
	LocationAddress         string           `json:"locationAddress,optional"`
	AddSecretRecommendation bool             `json:"addSecretRecommendation,optional"`
	CodeExpirationMinutes   int              `json:"codeExpirationMinutes,optional"`
	HasExpiration           bool             `json:"hasExpiration,optional"`
	OfferExpirationTimeMs   string           `json:"offerExpirationTimeMs,optional"`
}

type TemplateButton struct {
	Type           string                 `json:"type,optional"`
	Text           string                 `json:"text,optional"`
	PhoneNumber    string                 `json:"phoneNumber,optional"`
	Url            string                 `json:"url,optional"`
	UrlType        string                 `json:"urlType,optional"`
	SignatureHash  string                 `json:"signatureHash,optional"`
	PackageName    string                 `json:"packageName,optional"`
	AutofillText   string                 `json:"autofillText,optional"`
	IsOptOut       bool                   `json:"isOptOut,optional"`
	ExtendAttrs    []TemplateExtendAttr   `json:"extendAttrs,optional"`
	CouponCode     string                 `json:"couponCode,optional"`
	FlowId         string                 `json:"flowId,optional"`
	FlowAction     string                 `json:"flowAction,optional"`
	NavigateScreen string                 `json:"navigateScreen,optional"`
	SupportedApps  []TemplateSupportedApp `json:"supportedApps,optional"`
}

type TemplateSupportedApp struct {
	SignatureHash string `json:"signatureHash,optional"`
	PackageName   string `json:"packageName,optional"`
}

type TemplateExtendAttr struct {
	NextTemplateCode string `json:"nextTemplateCode,optional"`
	NextTemplateName string `json:"nextTemplateName,optional"`
	NextLanguageCode string `json:"nextLanguageCode,optional"`
	Action           string `json:"action,optional"`
	IntentCode       string `json:"intentCode,optional"`
}

// swagger:model createTemplateReq
type CreateTemplateReq struct {
	Category              string `json:"category"`
	TemplateCode          string `json:"templateCode"`
	Name                  string `json:"name"`
	Language              string `json:"language"`
	TemplateType          string `json:"templateType,optional"`
	AllowCategoryChange   bool   `json:"allowCategoryChange,optional"`
	MessageSendTtlSeconds int    `json:"messageSendTtlSeconds,optional"`
}

// swagger:model listTemplateReq
type ListTemplateReq struct {
	Page         int32  `json:"page"`
	PageSize     int32  `json:"pageSize"`
	Name         string `json:"name,optional"`
	Language     string `json:"language,optional"`
	AuditStatus  string `json:"auditStatus,optional"`
	TemplateType string `json:"templateType,optional"`
	Code         string `json:"code,optional"`
	WaId         string `json:"waId,optional"`
}

// swagger:model listTemplateResp
type ListTemplateResp struct {
	Code int          `json:"code"`
	Msg  string       `json:"msg"`
	Data ListTemplate `json:"data,omitempty"`
}

type ListTemplate struct {
	BaseListInfo
	Data []TemplateSingleInfo `json:"data,omitempty"`
}

// swagger:model removeTemplateReq
type RemoveTemplateReq struct {
	TemplateCode string `json:"templateCode,optional"`
	TemplateName string `json:"templateName,optional"`
	Language     string `json:"language"`
	TemplateType string `json:"templateType,optional"`
}

// swagger:model editTemplateReq
type EditTemplateReq struct {
	Components            []TemplateComponent `json:"components,optional"`
	Language              string              `json:"language,optional"`
	TemplateCode          string              `json:"templateCode,optional"`
	Category              string              `json:"category,optional"`
	TemplateType          string              `json:"templateType,optional"`
	MessageSendTtlSeconds int                 `json:"messageSendTtlSeconds,optional"`
	TemplateName          string              `json:"templateName,optional"`
}

// swagger:model getTemplateReq
type GetTemplateReq struct {
	TemplateCode string `json:"templateCode,optional"`
	Language     string `json:"language"`
	TemplateType string `json:"templateType,optional"`
	TemplateName string `json:"templateName,optional"`
}

// swagger:model getTemplateResp
type GetTemplateResp struct {
	Code int                `json:"code"`
	Msg  string             `json:"msg"`
	Data TemplateSingleInfo `json:"data,omitempty"`
}

// The data of whatsapp channel information | WhatsappChannel信息
// swagger:model WhatsappChannelInfo
type WhatsappChannelInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// ak
	Ak *string `json:"ak,optional"`
	// 端口号
	Sk *string `json:"sk,optional"`
	// 通道ID
	WaId *string `json:"waId,optional"`
	// 通道名
	WaName *string `json:"waName,optional"`
	// WABA ID
	WabaId *uint64 `json:"wabaId,optional"`
	// 商业平台ID
	BusinessId *uint64 `json:"businessId,optional"`
	// 机构 ID
	OrganizationId   *uint64 `json:"organizationId,optional"`
	OrganizationName *string `json:"organizationName,optional"`
	// 认证主体
	VerifyAccount *string `json:"verifyAccount,optional"`
}

// The response data of whatsapp channel list | WhatsappChannel列表数据
// swagger:model WhatsappChannelListResp
type WhatsappChannelListResp struct {
	BaseDataInfo
	// WhatsappChannel list data | WhatsappChannel列表数据
	Data WhatsappChannelListInfo `json:"data"`
}

// WhatsappChannel list data | WhatsappChannel列表数据
// swagger:model WhatsappChannelListInfo
type WhatsappChannelListInfo struct {
	BaseListInfo
	// The API list data | WhatsappChannel列表数据
	Data []WhatsappChannelInfo `json:"data"`
}

// Get whatsapp channel list request params | WhatsappChannel列表请求参数
// swagger:model WhatsappChannelListReq
type WhatsappChannelListReq struct {
	PageInfo
	OrganizationId *uint64 `json:"organizationId,optional"`
	WaName         *string `json:"waName,optional"`
	WaID           *string `json:"waID,optional"`
	WabaId         *uint64 `json:"wabaId,optional"`
	VerifyAccount  *string `json:"verifyAccount,optional"`
}

// WhatsappChannel information response | WhatsappChannel信息返回体
// swagger:model WhatsappChannelInfoResp
type WhatsappChannelInfoResp struct {
	BaseDataInfo
	// WhatsappChannel information | WhatsappChannel数据
	Data WhatsappChannelInfo `json:"data"`
}

// The data of xunji information | Xunji信息
// swagger:model XunjiInfo
type XunjiInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// AppKey
	AppKey *string `json:"appKey,optional"`
	// AppSecret
	AppSecret *string `json:"appSecret,optional"`
	// Token
	Token *string `json:"token,optional"`
	// 加密key
	EncodingKey *string `json:"encodingKey,optional"`
	// organization_id | 租户ID
	OrganizationId *uint64 `json:"organizationId,optional"`
}

// The response data of xunji list | Xunji列表数据
// swagger:model XunjiListResp
type XunjiListResp struct {
	BaseDataInfo
	// Xunji list data | Xunji列表数据
	Data XunjiListInfo `json:"data"`
}

// Xunji list data | Xunji列表数据
// swagger:model XunjiListInfo
type XunjiListInfo struct {
	BaseListInfo
	// The API list data | Xunji列表数据
	Data []XunjiInfo `json:"data"`
}

// Get xunji list request params | Xunji列表请求参数
// swagger:model XunjiListReq
type XunjiListReq struct {
	PageInfo
	// AppKey
	AppKey *string `json:"appKey,optional"`
	// AppSecret
	AppSecret *string `json:"appSecret,optional"`
	// Token
	Token *string `json:"token,optional"`
}

// Xunji information response | Xunji信息返回体
// swagger:model XunjiInfoResp
type XunjiInfoResp struct {
	BaseDataInfo
	// Xunji information | Xunji数据
	Data XunjiInfo `json:"data"`
}

// The data of xunji service information | XunjiService信息
// swagger:model XunjiServiceInfo
type XunjiServiceInfo struct {
	BaseIDInfo
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status *uint8 `json:"status,optional"`
	// Xunji表ID
	XunjiId *uint64 `json:"xunjiId,optional"`
	// 智能体ID
	AgentId *uint64 `json:"agentId,optional"`
	// 模式信息
	AgentInfo *AgentInfo `json:"agentInfo,optional"`
	// organization_id | 租户ID
	OrganizationId *uint64 `json:"organizationId,optional"`
	// 微信ID
	Wxid *string `json:"wxid,optional"`
	// 大模型服务地址
	ApiBase *string `json:"apiBase,optional"`
	// 大模型服务密钥
	ApiKey *string `json:"apiKey,optional"`
}

// The response data of xunji service list | XunjiService列表数据
// swagger:model XunjiServiceListResp
type XunjiServiceListResp struct {
	BaseDataInfo
	// XunjiService list data | XunjiService列表数据
	Data XunjiServiceListInfo `json:"data"`
}

// XunjiService list data | XunjiService列表数据
// swagger:model XunjiServiceListInfo
type XunjiServiceListInfo struct {
	BaseListInfo
	// The API list data | XunjiService列表数据
	Data []XunjiServiceInfo `json:"data"`
}

// Get xunji service list request params | XunjiService列表请求参数
// swagger:model XunjiServiceListReq
type XunjiServiceListReq struct {
	PageInfo
	XunjiID *uint64 `json:"configId,optional"`
}

// XunjiService information response | XunjiService信息返回体
// swagger:model XunjiServiceInfoResp
type XunjiServiceInfoResp struct {
	BaseDataInfo
	// XunjiService information | XunjiService数据
	Data XunjiServiceInfo `json:"data"`
}

// swagger:model WpWecomMsgReq
type WpWecomMsgReq struct {
	// 机器人微信id
	WxId *string `json:"wx_id"`
	// 接收方微信 id
	ConvId *string `json:"conv_id"`
	// 消息类型
	ContentType *string `json:"content_type"`
	// 消息内容
	Content *string `json:"content"`
}

// swagger:model CreateInfo
type CreateInfo struct {
	// Translated Name | 展示名称
	UserName string `json:"username"`
	// Name | 部门名称
	Title *string `json:"title"`
}

// swagger:model AppsListReq
type AppsListReq struct {
	Type    string  `json:"type"`
	Keyword *string `json:"keyword,optional"`
}

// swagger:model AppsListResp
type AppsListResp struct {
	BaseDataInfo
	Data []*AppsListRespInfo `json:"data"`
}

// swagger:model AppsListRespInfo
type AppsListRespInfo struct {
	Id     string `json:"_id"`
	TeamId string `json:"teamId"`
	TmbId  string `json:"tmbId"`
	Avatar string `json:"avatar"`
	Name   string `json:"name"`
	Intro  string `json:"intro"`
}

// swagger:model CreateAppsReq
type CreateAppsReq struct {
	Type  string  `json:"type"`
	Name  string  `json:"name"`
	Intro *string `json:"intro,optional"`
}

// swagger:model UpdateAppsReq
type UpdateAppsReq struct {
	Id    string  `json:"id"`
	Name  string  `json:"name"`
	Intro *string `json:"intro,optional"`
}

// swagger:model DeleteAppsReq
type DeleteAppsReq struct {
	Id string `json:"id"`
}

// The response data of department information | 部门信息
// swagger:model DepartmentInfo
type DepartmentInfo struct {
	BaseIDInfo
	// Translated Name | 展示名称
	Trans string `json:"trans,optional"`
	// Status | 状态
	// max : 20
	Status *uint32 `json:"status,optional" validate:"omitempty,lt=20"`
	// Sort | 排序
	// max : 10000
	Sort *uint32 `json:"sort,optional" validate:"omitempty,lt=10000"`
	// Name | 部门名称
	// min length : 1
	// max length : 50
	Name *string `json:"name,optional" validate:"omitempty,min=1,max=50"`
	// Ancestors | 父级部门列表
	// max length : 200
	Ancestors *string `json:"ancestors,optional" validate:"omitempty,max=200"`
	// Leader | 部门负责人
	// max length : 20
	Leader *string `json:"leader,optional" validate:"omitempty,max=20"`
	// Phone | 电话号码
	// max length : 18
	Phone *string `json:"phone,optional" validate:"omitempty,max=18"`
	// Email | 邮箱
	// max length : 70
	Email *string `json:"email,optional" validate:"omitempty,max=70"`
	// Remark | 备注
	// max length : 200
	Remark *string `json:"remark,optional" validate:"omitempty,max=200"`
	// ParentId | 父级 ID
	ParentId *uint64 `json:"parentId,optional"`
}

// The response data of department list | 部门列表数据
// swagger:model DepartmentListResp
type DepartmentListResp struct {
	BaseDataInfo
	// Department list data | 部门列表数据
	Data DepartmentListInfo `json:"data"`
}

// Department list data | 部门列表数据
// swagger:model DepartmentListInfo
type DepartmentListInfo struct {
	BaseListInfo
	// The API list data | 部门列表数据
	Data []DepartmentInfo `json:"data"`
}

// Get department list request params | 部门列表请求参数
// swagger:model DepartmentListReq
type DepartmentListReq struct {
	PageInfo
	// Name | 部门名称
	// max length : 50
	Name *string `json:"name,optional" validate:"omitempty,max=50"`
	// Leader | 部门负责人
	// max length : 20
	Leader *string `json:"leader,optional" validate:"omitempty,max=20"`
}

// Department information response | 部门信息返回体
// swagger:model DepartmentInfoResp
type DepartmentInfoResp struct {
	BaseDataInfo
	// Department information | 部门数据
	Data DepartmentInfo `json:"data"`
}

// The data of api_key information | ApiKey信息
// swagger:model ApiKeyInfo
type ApiKeyInfo struct {
	BaseIDInfo
	// Title
	Title *string `json:"title,optional"`
	// Key
	Key *string `json:"key,optional"`
	// 租户ID
	OrganizationId  *uint64    `json:"organization_id,optional"`
	AgentId         *uint64    `json:"agent_id,optional"`
	AgentInfo       *AgentInfo `json:"agent_info,optional"`
	CustomAgentBase *string    `json:"custom_agent_base,optional"`
	CustomAgentKey  *string    `json:"custom_agent_key,optional"`
	OpenaiBase      *string    `json:"openai_base,optional"`
	OpenaiKey       *string    `json:"openai_key,optional"`
}

// The response data of api_key list | ApiKey列表数据
// swagger:model ApiKeyListResp
type ApiKeyListResp struct {
	BaseDataInfo
	// ApiKey list data | ApiKey列表数据
	Data ApiKeyListInfo `json:"data"`
}

// ApiKey list data | ApiKey列表数据
// swagger:model ApiKeyListInfo
type ApiKeyListInfo struct {
	BaseListInfo
	// The API list data | ApiKey列表数据
	Data []ApiKeyInfo `json:"data"`
}

// Get ApiKey list request params | ApiKey列表请求参数
// swagger:model ApiKeyListReq
type ApiKeyListReq struct {
	PageInfo
	// Key
	Key            *string `json:"key,optional"`
	OrganizationId *uint64 `json:"organization_id,optional"`
}

// The log in information | 登陆返回的数据信息
// swagger:model LoginInfo
type LoginInfo struct {
	// User's UUID | 用户的UUID
	UserId string `json:"userId"`
	// Token for authorization | 验证身份的token
	Token string `json:"token"`
	// Expire timestamp | 过期时间戳
	Expire uint64 `json:"expire"`
}

// The permission code for front end permission control | 权限码： 用于前端权限控制
// swagger:model PermCodeResp
type PermCodeResp struct {
	BaseDataInfo
	// Permission code data | 权限码数据
	Data []string `json:"data"`
}

// Login request | 登录参数
// swagger:model LoginReq
type LoginReq struct {
	// User Name | 用户名
	// required : true
	// max length : 20
	Username string `json:"username" validate:"required,alphanum,max=20"`
	// Password | 密码
	// required : true
	// max length : 30
	// min length : 6
	Password string `json:"password" validate:"required,max=30,min=6"`
	// Captcha ID which store in redis | 验证码编号, 存在redis中
	// required : true
	// max length : 20
	// min length : 20
	CaptchaId string `json:"captchaId"  validate:"required,len=20"`
	// The Captcha which users input | 用户输入的验证码
	// required : true
	// max length : 5
	// min length : 5
	Captcha string `json:"captcha" validate:"required,len=5"`
}

// Log in by email request | 邮箱登录参数
// swagger:model LoginByEmailReq
type LoginByEmailReq struct {
	// The user's email address | 用户的邮箱
	// required : true
	// max length : 100
	Email string `json:"email" validate:"required,email,max=100"`
	// The Captcha which users input | 用户输入的验证码
	// max length : 5
	// min length : 5
	Captcha string `json:"captcha,optional" validate:"omitempty,len=5"`
}

// Log in by SMS request | 短信登录参数
// swagger:model LoginBySmsReq
type LoginBySmsReq struct {
	// The user's mobile phone number | 用户的手机号码
	// required : true
	// max length : 20
	PhoneNumber string `json:"phoneNumber"  validate:"required,numeric,max=20"`
	// The Captcha which users input | 用户输入的验证码
	// max length : 5
	// min length : 5
	Captcha string `json:"captcha,optional" validate:"omitempty,len=5"`
}

// The log in response data | 登录返回数据
// swagger:model LoginResp
type LoginResp struct {
	BaseDataInfo
	// The log in information | 登陆返回的数据信息
	Data LoginInfo `json:"data"`
}

// add_friend_by_phone api接口请求值
// swagger:model AddWechatFriendLogInfo
type AddWechatFriendLogInfo struct {
	Type        int      `json:"type,options=1|3,default=1"`
	WeChatIds   []string `json:"wechat_ids,optional,omitempty"`
	Phones      []string `json:"phones"`
	Message     string   `json:"message"`
	CallbackURL string   `json:"callback_url,optional"`
}

// swagger:model AddFriendListReq
type AddFriendListReq struct {
	PageInfo
	OwnerWxId   *string `json:"wxId,optional"`
	OwnerWxType *int    `json:"type,optional"`
	FindContent *string `json:"phone,optional"`
	Status      *int    `json:"status,optional"`
}

// swagger:model AddFriendListResp
type AddFriendListResp struct {
	BaseDataInfo
	Data FriendListInfo `json:"data"`
}

// swagger:model FriendListInfo
type FriendListInfo struct {
	BaseListInfo
	Data []FriendList `json:"data"`
}

type FriendList struct {
	Id int64 `json:"id,optional"`
	// 微信id 公众号微信ID
	OwnerWxId   *string `json:"wxId,optional"`
	OwnerWxType *string `json:"wxType,optional"`
	FindContent *string `json:"phone,optional"`
	Status      *string `json:"status,optional"`
	StatusInt   *int    `json:"statusInt,optional"`
	ErrMessage  *string `json:"errMessage,optional"`
	TaskCount   *int    `json:"taskCount,optional"`
	IsShow      *int    `json:"isShow,optional"`
	// 微信昵称 群备注名称
	Message    *string `json:"message,optional"`
	CreateTime *string `json:"createTime,optional"`
	UpdateTime *string `json:"updateTime,optional"`
}

// swagger:model CancelByIdsReq
type CancelByIdsReq struct {
	// required : true
	// min length : 1
	Ids []int64 `json:"ids" validate:"required,min=1"`
}
