package compapi

import (
	"github.com/openai/openai-go"
)

const (
	ChatModelDeepSeekV3 openai.ChatModel = "deepseek-chat"
	ChatModelDeepSeekR1 openai.ChatModel = "deepseek-reasoner"

	APIAuthInfoKey string = "COMPAPI_AUTHINFO"
)

type workIdInfo struct {
	Id  string
	Idx uint
}

var fastgptWorkIdMap = map[string]workIdInfo{
	"default":              {"fastgpt-jcDATa9aH4vtUsjDpCU773BxmLU50IxKUX9nUT0mCTLQkEoo1hPxPEdNQeOEWGTn", 0},
	"OPTIMIZE_CALL_SCRIPT": {"fastgpt-bcQ9cWKd6y9a2LfizweeWEnukkQi1Oq46yoiRg9yDNLm8NPTWXsyFwcB", 1},
	"TEST_DOUYIN":          {"fastgpt-bwt6oSGcjwJ1qBgT276oeFD34IAhfjEQBCZWJfJR1oj3WqJl7751ljSrc", 2},
	"GENERALIZED_KEYWORDS": {"fastgpt-yefNCWpNtzY2Qn0xtJvKuvepOP9DR7BiXQwv5BiVP5JseP2IS92gE", 3},
	"TEST_DOUYIN_CN":       {"fastgpt-jsMmQKEM5uX7tDimT1zHlZHkBhMHRT2k61YaxyDJRZTUHehID7sG8BKXADNIU", 4},
	"travel":               {"fastgpt-bcnfFtw1lXWdmYGOv165UVD5R1kY28tyXX8SJv8MHhrSMOgVJsuU", 5},
	"loreal":               {"fastgpt-qqJeBEkwhgx7wR9fvGToQygmOb7FVjAbGBTFjOAMbd95InEtndke", 6},
	"xiulike-dc":           {"fastgpt-ir9RgnKHMT9HIOnPsUCFChN15ZbW9kt1lbd5Y0ohfLw9gOz3KcPrfaZWHRB", 7},
	"wuhanzhongxin":        {"fastgpt-jX6Gl50Ivrc7vzyD4xNlahG11cgmJ4N63QHKrntt2gQ78g31haxuAsA", 8},
}
